program ESvc; //New150305
{$apptype GUI}
uses //x191121: DsInit, DataSys,
     EvalStartAlloc, //New191121
     Windows,SysUtils,Classes,
     UDebug,
     UFileSvc in 'WlServer\UFileSvc.pas',
     UFileSvcMain in 'WlServer\UFileSvcMain.pas',
     UEvalScript in 'UEvalScript.pas';

{$R *.res} //New191106

var
  gSrvIniFileName: String; // default ESvc.ini , can change on command line: ESvc.exe -ini File.ini
  ScriptFile,ScriptCode: String;
  gLibs: TStringList;
  hSvcTree: THandle;
  ErrorLogFile: String; //New191106 default 'Error.log'

function StrLoadFile(const FileName: String8; var Text: String8): Boolean; forward;

function ExecSvcFunc(const Names: array of String8): Boolean;
var i: integer;
    lpName: PString8;
    FuncNode: PEvalNode;
    ResVar: Variant;
    Stack: TLocalVarStack;
    Args: TEvalNode;
    bnIsFunc: Boolean;
begin
  if (hSvcTree=0) then begin
    Result:=False;
    exit;
  end;
  bnIsFunc:=False; //New191101
  SetVarNull(ResVar);
  FuncNode:=nil;
  lpName:=nil;
  for i:=0 to High(Names) do begin
    if (Names[i]<>'') then begin
      bnIsFunc:=True; //New191101
      FuncNode:=EvalFindTreeFunc(hSvcTree,Names[i]);
    end else begin
      bnIsFunc:=False; //New191101
      FuncNode:=GetTreeRootNode(hSvcTree);
    end;
    if (FuncNode<>nil) then begin
      lpName:=@Names[i];
      break;
    end;
  end;
  //
  if (FuncNode<>nil) then begin
    //New191101 -- but using EvalCallFuncNode we by-pass root context stack and global variables cannot be used...
    FillChar(Stack,SizeOf(Stack),0);
    Stack.wSign:=cwEvalBlock_Run;
    SetTopEvalStack(@Stack);
    FillChar(Args,SizeOf(Args),0); // probably not needed?
    Args.Kind:=enkNop;
    //
    try
      SetCurrentEvalTree(hSvcTree);
      try
        //x191101: Result:=EvaluateNode(ResVar,FuncNode);
        //New191101
        if bnIsFunc then
          Result:=EvalCallFuncNode(FuncNode,@Args,ResVar,@Stack)
        else
          Result:=EvaluateNodeEx(ResVar,FuncNode,@Stack);
        //
      finally
        SetVarNull(ResVar);
        PopTopEvalStack(@Stack); //New191101
        PopCurrentEvalTree(hSvcTree); //New191101
      end;
    except
      LogException(nil,PChar8(lpName^));
      Result:=False;
    end;
  end else
    Result:=False;
end;

procedure FileOutLine(H: THandle; Line: PAnsiChar; Len: integer); //New191106
var Buffer: array[0..1023] of char;
    Temp: PAnsiChar;
begin
  Temp:=nil;
  if (Len<High(Buffer)-4) then begin
    Move(Line^,Buffer,Len);
    Line:=Buffer;
  end else begin
    GetMem(Temp,Len+4);
    Move(Line^,Temp^,Len);
    Line:=Temp;
  end;
  //
  Line[Len]:=#13; inc(Len);
  Line[Len]:=#10; inc(Len);
  //
  FileWrite(H,Line^,Len);
  //
  FreeMem(Temp);
end;

procedure OutErrHeader(hErrLog: THandle); //New191106
var T: TSystemTime;
    Buffer: array[0..255] of AnsiChar;
begin
  GetLocalTime(T);
  StrLFmt(Buffer,High(Buffer),
    '----------------------------------------------------------------'#13#10+
    '{%d.%d.%d %.2d:%.2d:%.2d.%.3d} '#13#10,
    [T.wDay,T.wMonth,T.wYear,T.wHour,T.wMinute,T.wSecond,T.wMilliseconds]);
  FileWrite(hErrLog,Buffer,StrLen(Buffer));
end;

procedure ErrOutput(Arg: Pointer; const S: AnsiString); //New191106
var hErrLog: THandle;
begin
  if (ErrorLogFile<>'') and (S<>'') then begin
    hErrLog:=CreateFile(PChar(ErrorLogFile),GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,nil,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
    if (hErrLog<>INVALID_HANDLE_VALUE) then begin
      try
        SetFilePointer(hErrLog,0,nil,FILE_END);
        //
        OutErrHeader(hErrLog);
        //
        FileOutLine(hErrLog,PChar(S),Length(S));
      finally
        CloseHandle(hErrLog);
      end;
    end;
  end;
end;

function pSkipBlank(pc: PChar8): PChar8;
begin
  if (pc<>nil) then
    while (pc^ in [#1..' ']) do
      inc(pc);
  Result:=pc;
end;

procedure DoTrim(var S: String8);
var pc: PChar8;
    Len,L0: integer;
begin
  Len:=Length(S);
  L0:=Len;
  pc:=Pointer(S);
  //
  dec(Len);
  while (Len>=0) and (pc[Len]<=' ') do
    dec(Len);
  inc(Len);
  while (Len>0) and (pc^<=' ') do begin
    inc(pc);
    dec(Len);
  end;
  //
  if (Len<L0) then
    SetString(S,pc,Len);
end;

procedure SetTrimString(var S: String8; pc: PChar8; Len: integer);
begin
  dec(Len);
  while (Len>=0) and (pc[Len]<=' ') do
    dec(Len);
  inc(Len);
  while (Len>0) and (pc^<=' ') do begin
    inc(pc);
    dec(Len);
  end;
  //
  SetString(S,pc,Len);
end;

// [Service]
// Script=ESvc.script
// [Code]
// Script-Code

procedure LoadScriptConfig(const IniFile: String8);
var Lines,Sec: TStringList;
    i,p: integer;
    S,Name: String8;
    bnSvcSec,bnCodeSec: Boolean;
begin
  Sec:=TStringList.Create;
  Lines:=TStringList.Create;
  try
    Lines.LoadFromFile(IniFile);
    //
    bnSvcSec:=False;
    bnCodeSec:=False;
    //
    i:=0;
    while (i<Lines.Count) do begin
      S:=Lines[i];
      inc(i);
      if (S='')
      or (pSkipBlank(PChar(S))^ in [';','#'])
      then
        continue;
      if (S[1]='[') and (Pos(']',S)>0) then begin
        Delete(S,1,1);
        SetLength(S,Pos(']',S)-1);
        bnSvcSec:=False;
        bnCodeSec:=False;
        if SameText(S,'Service') then
          bnSvcSec:=True
        else
        if SameText(S,'Code')
        or SameText(S,'Script')
        then begin
          bnCodeSec:=True;
          if (Sec=nil) then
            Sec:=TStringList.Create;
        end;
        continue;
      end;
      //
      if bnCodeSec
      and (Sec<>nil)
      then begin
        Sec.Add(S);
        continue;
      end;
      //
      if bnSvcSec then begin
        DoTrim(S);
        p:=Pos('=',S);
        if (p>0) then begin
          Name:=Copy(S,1,p-1);
          Delete(S,1,p);
          DoTrim(S);
        end else
          Name:='';
        if SameText(Name,'Script') then begin
          ScriptFile:=S;
          continue;
        end else
        if SameText(Name,'ErrorLog') then begin //New191106
          ErrorLogFile:=S;
        end;
      end;
    end;
    //
    if (Sec<>nil) then
      if (ScriptFile='')
      or not FileExists(ScriptFile)
      then begin
        ScriptCode:=Sec.Text;
      end;
    //
  finally
    Lines.Free;
    Sec.Free;
  end;
end;

procedure InternalStartServer;
var Code: String8;
    hTree: THandle;
begin
  if (gSrvIniFileName<>'')
  and FileExists(gSrvIniFileName)
  then begin
    LoadScriptConfig(gSrvIniFileName);
  end;
  //
  if (hSvcTree=0) then begin
    if (ScriptFile<>'') and (hSvcTree=0) then begin
      // Execute server script:
      if not StrLoadFile(ScriptFile,Code) then begin
        Debug('Failed to load file "%s"',[ScriptFile]);
        exit;
      end;
      ScriptCode:=Code;
    end;
    //New191106
    SetCompileErrorProc(ErrOutput,nil);
    SetRunErrorProc(ErrOutput,nil);
    //
    if (ScriptCode<>'') then begin
      hTree:=CreateEvalTree();
      SetKeepSourcePtr(hTree,True);
      if (ParseExpressionStr(hTree,ScriptCode,nil)=nil) then begin
        Debug('Failed to compile code in "%s"',[ScriptFile]);
        DestroyEvalTree(hTree);
        exit;
      end;
      hSvcTree:=hTree;
    end;
  end;
  //
  if (hSvcTree<>0) then begin
    ExecSvcFunc(['Start','StartServer','']);
  end;
end;

function DoStartThread(Param: Pointer): Longint;
begin
  try
    InternalStartServer;
  except
    // Main thread catcher...
    try
      LogException(nil,'StartThread');
    except ; end;
  end;
  Result:=0;
end;

function Eval_SvcTerminate(var ResVar: Variant; Args: PEvalNode; Stack: PLocalVarStack): Boolean;
begin
  SetVarNull(ResVar);
  SetEvent(ServiceTerminate);
  Result:=True;
end;

function DynEval_SvcTermEvent(var ResVar: Variant; Arg: Pointer): Boolean;
begin
  ResVar:=Longint(ServiceTerminate);
  Result:=True;
end;

procedure StartServer;
var hThr: THandle;
    idThr,Timeout: Cardinal;
begin
  //
  SetGlobalVar_Var('IsService',bnService);
  RegisterExternalFunc2('SvcTerminate',Eval_SvcTerminate);
  RegisterExternalFunc2('ServiceTerminate',Eval_SvcTerminate);
  RegisterDynConst('ServiceTerminate',DynEval_SvcTermEvent,nil);
  SetKeepSourcePtr(0,True);
  //
  hThr:=BeginThread(nil,0,DoStartThread,nil,0,idThr);
  if (hThr<>0) then begin
    if bnService then
      Timeout:=500
    else
      Timeout:=INFINITE;
    WaitForSingleObject(hThr,Timeout);
    CloseHandle(hThr);
  end;
end;

procedure StopServer;
begin
  if (hSvcTree<>0) then begin
    ExecSvcFunc(['Stop','StopServer']);
  end;
end;

function StrLoadFile(const FileName: String8; var Text: String8): Boolean;
var hf: THandle;
    Size: integer;
begin
  hf:=FileOpen(FileName,fmOpenRead or fmShareDenyNone);
  if (hf=INVALID_HANDLE_VALUE) then begin
    Debug('Failed to open file "%s"',[FileName]);
    Result:=False;
    exit;
  end;
  Result:=True;
  try
    Size:=GetFileSize(hf,nil);
    if (Size<0) then begin
      Result:=False;
      Size:=0;
    end;
    SetString(Text,PChar8(nil),Size);
    Size:=FileRead(hf,Pointer(Text)^,Size);
    if (Size<0) then begin
      Result:=False;
      Size:=0;
    end;
    if (Size<Length(Text)) then
      SetLength(Text,Size);
  finally
    CloseHandle(hf);
  end;
end;

function UseLibrary(const LibFile: String): Boolean;
var BaseName,Text: String8;
    hLib: THandle;
begin
  Result:=False;
  if not StrLoadFile(LibFile,Text) then
    exit;
  //
  BaseName:=ChangeFileExt(ExtractFileName(LibFile),'');
  hLib:=EvalMakeLibrary(PChar8(BaseName),PChar8(Text),cLib_Shared or cLib_GlobalVars);
  if (hLib=0) then begin
    Debug('Failed to compile library "%s"',[LibFile]);
    Result:=False;
    exit;
  end;
  //
  if (gLibs=nil) then
    gLibs:=TStringList.Create;
  gLibs.AddObject(LibFile,TObject(hLib));
  //
  AddEvalLibrary(BaseName,Text);
  //
  Result:=True;
end;

type
  TTextOutProc=procedure(Arg: Pointer; Text: PChar8; Len: integer);

function InternalExtQuoted(pc: PChar8; Output: TTextOutProc; Arg: Pointer; lpbnIncomplete: PBoolean): PChar8; //New150203
var Q: Char8;
    ps: PChar8;
begin
  if (pc<>nil) then begin
    // with this version, also #0 may be used as quote... not recomended...
    Q:=pc^;
    inc(pc);
    ps:=pc;
    while True do begin
      if (pc^<>Q) then begin
        if (pc^=#0) then begin
          if (lpbnIncomplete<>nil) then
            lpbnIncomplete^:=True;
          break;
        end;
        inc(pc);
      end else begin
        // quote found...
        if (pc[1]<>Q) then begin
          // terminal quote found...
          Output(Arg,ps,pc-ps);
          inc(pc);
          Result:=pc;
          exit;
        end else begin
          // double-quote found... output previous part and 1 quote...
          inc(pc);
          Output(Arg,ps,pc-ps);
          inc(pc);
          ps:=pc;
        end;
      end;
    end;
    // Output last part:
    if (pc>ps) then
      Output(Arg,ps,pc-ps);
  end;
  Result:=pc;
end;

procedure OutCountLen(Arg: Pointer; Text: PChar8; Len: integer); //New130310
begin
  inc(PLongint(Arg)^,Len);
end;

type
  PPointer=^Pointer; //New191121

procedure OutFillText(Arg: Pointer; Text: PChar8; Len: integer); //New130310
var Put: PChar8;
begin
  Put:=PPointer(Arg)^;
  inc(PLongint(Arg)^,Len);
  Move(Text^,Put^,Len);
end;

function ExtQuoted(pc: PChar8; var Item: String8): PChar8; //New150203
var S: String8;
    Len: integer;
    Put: PChar8;
begin
  // with pascal-style quote doubling, ignoring \ backslash...
  Len:=0;
  Result:=InternalExtQuoted(pc,OutCountLen,@Len,nil);
  if (Len>0) then begin
    SetString(S,PChar8(nil),Len);
    Put:=Pointer(S);
    Result:=InternalExtQuoted(pc,OutFillText,@Put,nil);
    Item:=S;
  end else
    Item:='';
end;

function PerformSetVar(const S: string8): Boolean;
var pc,pe,ps: PChar8;
    Name,Value: String8;
    bnQuoted: Boolean;
    V: Variant;
begin
  Result:=False;
  pc:=Pointer(S);
  pe:=pc+Length(S);
  ps:=pc;
  while (pc<pe) and (pc^<>'=') do
    inc(pc);
  if (pc<pe) then begin
    SetTrimString(Name,ps,pc-ps);
    inc(pc);
    while (pc<pe) and (pc^<=' ') do
      inc(pc);
    if (pc^ in ['"','''']) then begin
      ExtQuoted(pc,Value);
      bnQuoted:=True;
    end else begin
      SetTrimString(Value,pc,pe-pc);
      bnQuoted:=False;
    end;
    //
    if bnQuoted then
      EvalCpToVar(V,Value,CP_ACP)
    else
      CvtStrToVariant(Value,V);
    //
    Result:=SetGlobalVar_Var(Name,V);
  end;
end;

procedure DoCmdDispatch(Cmd: string);
begin
  WarnUnknownCommand(Cmd);
end;

function DoUnknownCmdFlag(var CmdLine: PChar): Boolean;
var Cmd,pCmd,Tok: PChar;
    S: String;
    TokBuf: array[0..31] of char;
Label _Ok;
begin
  Cmd:=CmdLine;
  if (Cmd<>nil) then begin
    TokBuf[0]:=#0;
    //
    if (Cmd^='/') then begin
      TokBuf[0]:='-';
      pCmd:=Cmd;
      ExtractCmdToken(pCmd,@TokBuf[1],High(TokBuf)-1);
      Cmd:=pCmd;
      TokBuf[High(TokBuf)]:=#0;
      if (TokBuf[0]<>#0) then
        TokBuf[0]:='-';
    end else
    if (Cmd^='-')
    and ( (Cmd[1] in ['A'..'Z','a'..'z','0'..'9'])
        or
          ((Cmd[1]='-') and (Cmd[2] in ['A'..'Z','a'..'z','0'..'9']))
        )
    then begin
      while (Cmd^='-') do
        inc(Cmd);
      TokBuf[0]:='-';
      pCmd:=Cmd;
      ExtractCmdToken(pCmd,@TokBuf[1],High(TokBuf)-1);
      Cmd:=pCmd;
    end else
      Cmd:=nil;
    if (Cmd<>nil)
    and (TokBuf[0]<>#0)
    then begin
      Tok:=TokBuf;
      pCmd:=Cmd;
      if IsPar(Tok,'-lib') then begin
        if ExtractCmdTokenStr(pCmd,S) then begin
          Debug('Using library "%s"',[S]);
          if not UseLibrary(S) then begin
            Debug('Library "%s" not used',[S]);
          end;
          Cmd:=pCmd;
        _Ok:
          CmdLine:=Cmd;
          Result:=True;
          exit;
        end;
      end else
      if IsPar(Tok,'-f') then begin
        if ExtractCmdTokenStr(pCmd,S) then begin
          Debug('ScriptFile "%s"',[S]);
          ScriptFile:=S;
          Cmd:=pCmd;
          goto _Ok;
        end;
      end else
      if IsPar(Tok,'-dll') then begin
        if ExtractCmdTokenStr(pCmd,S) then begin
          Debug('Loading dll "%s"',[S]);
          SafeLoadLibrary(S);
          Cmd:=pCmd;
          goto _Ok;
        end;
      end else
      if IsPar(Tok,'-v')
      or IsPar(Tok,'-var')
      then begin
        if ExtractCmdTokenStr(pCmd,S) then begin
          if PerformSetVar(S) then begin
            Cmd:=pCmd;
            goto _Ok;
          end;
        end;
      end;
    end;
  end;
  //
  Debug('Unknown command: %s',[CmdLine]);
  Result:=False;
end;

procedure SetOtherCmdHelp(var Help: string);
begin
  Help:=
    '... /cfg File               '#9'Service config file'#13#10+
    '... -f ScriptFile           '#9'Service script file'#13#10+
    '... -lib LibFile.lib        '#9'Script library file'#13#10+
    '... -dll File.dll             '#9'Load dll'#13#10+
    '... -v Name=Value           '#9'Set variable'#13#10+
    '';
end;

{//x191109: is already in UFileSvcMain.pas ...
procedure DoGetMemoryManager(var Mmgr: TMemoryManager); export;
begin
  System.GetMemoryManager(Mmgr);
end;
exports
  DoGetMemoryManager name 'GetMemoryManager';
{}

begin
  gSrvIniFileName:=ChangeFileExt(ParamStr(0),'.ini');
  //
  UFileSvcMain.StartServer:=StartServer;
  UFileSvcMain.StopServer:=StopServer;
  UFileSvcMain.lpSrvIniFileName:=@gSrvIniFileName;
  //
  UFileSvcMain.OnCmdDispatch:=DoCmdDispatch;
  UFileSvcMain.OnUnknownCmd:=DoUnknownCmdFlag;
  //
  SetOtherCmdHelp(OtherCommandHelp);
  ErrorLogFile:='Error.log'; //New191106
  //
  StrLCopy(szbufServerName,'ScriptSvc',SizeOf(szbufServerName));
  StrLCopy(szServiceName,'ScriptSvc',SizeOf(szServiceName));
  StrLCopy(szServiceDesc,'Generic script service',SizeOf(szServiceDesc));
  //
  TransSvc_Main(exe_Svc);
end.
