{--------------------------------------------------------------}
{                                                              }
{  UEvalNet2.pas - Network sockets for EvalTree                }
{                                                              }
{  Author:     Semi                                            }
{  Started:    191019                                          }
{                                                              }
{                                                              }
{  TESTED little ...                                           }
{--------------------------------------------------------------}
unit UEvalNet2;
interface
uses ActiveX, Math, Windows, Messages, SysUtils, Classes, UDebug, EvalGenObj, EvalModule;
//-------------------------------------------------------------

procedure EvalNet_ThreadExit();

type
  PESockStream=^TESockStream;
    PSockStreamOperator=^TSockStreamOperator;
  
  // INetSvcStream - special services for IStream in Sock.RecvStream or Sock.SendStream ...
  INetSvcStream=interface(IUnknown) //New191029
    ['{EF211DBB-63C0-71F7-BF89-F3E91AAA4C83}']
    // special receive functions:
    function PeekData(Buffer: Pointer; var Size: integer): HResult; // recv with MSG_PEEK - do not consume from buffer (if it is supported?)
    function RecvFrom(Buffer: Pointer; var Size: integer; Addr: Pointer; var AddrSize: integer): HResult;
    function SendTo(Buffer: Pointer; var Size: integer; Addr: Pointer; AddrSize: integer): HResult;
    // query peer address or SSL cert etc:
    //function GetPeerInfo(Code: Longint; Buffer: Pointer; var Size: integer): HResult;
    // get/set socket flags:
    //function GetSocketFlag(Code: Longint; Param: Pointer): HResult;
    //function SetSocketFlag(Code: Longint; Param: Pointer): HResult;
    function Control(Code: Longint; Param: Pointer): HResult;
    // ctrl_DereferenceSocket, ctrl_GetSocketFlag, ctrl_SetSocketFlag, ctrl_GetPeerInfo, ...
  end;
  
  ISocketHandle=interface(IUnknown) //New191030
    ['{6D028302-1BAE-26B2-6FA6-AAF10E544157}']
    function GetHandle(): THandle; // returns HSocket if available...
    function GetSslCtx(): Pointer; // returns PSSL_CTX (or PSSL?) if available...
    // +QueryInterface INetSvcStream
  end;
  
  // Simple socket-like interface:
  INetSocket=interface(IUnknown) //New200828 (from UEvalSynSocket.pas)
    ['{5FE686BB-3109-D7F1-6240-0D565C92C191}']
    function Send(Buffer: Pointer; Size: Longint): Longint;
    function Recv(Buffer: Pointer; Size: Longint): Longint;
    function GetLastError(): Longint;
    function Control(Code: Longint; Param: Pointer): HResult;
  end;

  // socket handle shared by multiple objects:
  PSocketHandle=^TSocketHandle;
  TSocketHandle=record
    Vmt:           Pointer; //IUnknown - only for closesocket on release... +ISocketHandle
    RefCount:      integer;
    hSocket:       THandle;
    SslCtx:        Pointer; // Ssl context if used...
    FreeCtx:       TFreeDataProc;
    //? bnUdp:         Boolean; //New191029
    Svc:           INetSvcStream;
    SocketObj:     Pointer; //New191109 - PEvalSocket, not referenced...
    LastError:     HResult; //New191109
  end;
  
  // 2 streams per socket:
  // Note: Streams cannot reference Socket, since Socket references streams...
  TESockStream=record
    Vmt:           Pointer; // IStream,IUnknown, IEvalObj->SocketObj, ISocketStreamInfo->helper, INetSvcStream->phSocket.Svc
    RefCount:      integer;
    phSocket:      PSocketHandle;
    //x191109: SocketObj:     IEvalObj;
    Operator:      PSockStreamOperator; // Read/Write operator (virtual functions)
    Async:         Pointer; // for async socket, fifo-buffer, send/recv buffer + Overlapped etc...
    IoSize:        LARGE_INTEGER; // total send/recv size on this socket...
  end;
  
  // Operator (in code segment) distinguishes Send/Recv streams:
  // (virtual functions of TEvalSockStream, to share single VMT for both send/recv for rest of stream...)
    TSockIoProc=function(Stm: Pointer; Buffer: Pointer; Size: Longint; pcbActual: PLongint): HResult stdcall;
    TSockIsReadyProc=function(Stm: Pointer; Flags: Longint): HResult;
  TSockStreamOperator=record
    Read:          TSockIoProc; //function Read(Self; pv: Pointer; cb: Longint; pcbRead: PLongint): HResult; stdcall;
    Write:         TSockIoProc; //function Write(Self; pv: Pointer; cb: Longint; pcbWritten: PLongint): HResult; stdcall;
    IsReady:       TSockIsReadyProc; // function(SockStream; Flags: Longint): HResult;
  end;

// Kind=0 for IStream PESockStream, 1 for SendOperator, 2 for RecvOperator
function Vmt_ESockStream(Kind: Byte): Pointer;
const
  vmt__SockStream  = 0;
  vmt__SendOperator= 1;
  vmt__RecvOperator= 2;
  vmt__SslSendOp   = 3;
  vmt__SslRecvOp   = 4;

type
  // supported by Socket streams:
  ISocketStreamInfo=interface(IUnknown)
    ['{10904689-84E1-946F-88CF-E70DF788F97A}']
    function GetSocketHandle(var hSocket: THandle): HResult;
    function GetAvailSize(var AvailSize: Longint): HResult; // avail receive size
    function IsReady(Flags: Longint): HResult; // select(), returns 0 if ready, WSAEWOULDBLOCK if not ready, may return CO_E_NOT_SUPPORTED 80004021, CO_E_OBJNOTCONNECTED 800401FD, STG_E_ABNORMALAPIEXIT 800300FA, ...
    function Peek(Buffer: Pointer; var Size: integer): HResult; //New191116 - for line reading... E_NOTIMPL if not implemented...
  end;
  
  //INetStreamOp=interface(IUnknown) //New191116a
  //  ['{04E07EB7-D903-27C8-6E0A-66D1BD914158}']
  //  function GetAvailSize(): integer; // 0 if none, -1 if error, >0 if data available for reading
  //  function Peek(Buffer: Pointer; Size: integer; lpActual: integer): HResult;
  //end;
  INetStreamOp=ISocketStreamInfo; //New191116b

const
  guid_ISocketStreamInfo: TGuid='{10904689-84E1-946F-88CF-E70DF788F97A}';
  guid_INetSvcStream: TGuid='{EF211DBB-63C0-71F7-BF89-F3E91AAA4C83}'; //New191029
  guid_ISocketHandle:TGuid='{6D028302-1BAE-26B2-6FA6-AAF10E544157}'; //New191030
  guid_INetSocket:TGuid='{5FE686BB-3109-D7F1-6240-0D565C92C191}'; //New200828
  // ISocketStreamInfo.IsReady Flags bit-masks, used internally...
  sir_Recv   = 1;
  sir_Send   = 2;
  sir_Except = 4; // returns S_FALSE=1 if set in ExceptFds

const
  // INetSvcStream.Control codes:
  // ctrl_DereferenceSocket, ctrl_GetSocketFlag, ctrl_SetSocketFlag, ctrl_GetPeerInfo, ...
  ctrl_DereferenceSocket = Longint($B6D239BA);
  ctrl_GetSocketFlag     = Longint($B6D239BB);
  ctrl_SetSocketFlag     = Longint($B6D239BC);
  ctrl_GetPeerInfo       = Longint($B6D239BD);

const
  // IStream.Seek(dlibMove,0,AvailSize) to get available size for read on socket RecvStream...
  //             asks FIONREAD - is not supported on pushed socket filters...
  // IStream.Seek(soFromCurrent,0,DoneSize) to retrieve total SentSize or ReceivedSize so far...
  so_GetAvailSize = $41;

function Vmt_SocketHandle(): Pointer;
  procedure SockHandle_Released(phs: PSocketHandle);
  function Vmt_NetSvc(Kind: Byte): Pointer;

type
  // IEvalObj for Socket:
  PEvalSocket=^TEvalSocket;
  TEvalSocket=record
    // GenObj
    Vmt:           Pointer; // IEvalObj, IUnknown, IStream - which?, INetSocket...
    RefCount:      integer;
    Prototype:     IEvalObj;
    Props:         PNamedPropList;
    //
    phSocket:      PSocketHandle;
    SendStream:    IStream;
    RecvStream:    IStream;
    MyAddress:     Pointer; // PSockAddrIn
    PeerAddress:   Pointer; // PSockAddrIn
    LastError:     HResult;
    Timeout:       Longint;
    bDefaultSide:  Byte; // 0=Send, 1=Recv (default stream for IStream)
    bnUdp:         Boolean; //New191029
    bPad:          array[2..3] of Byte;
  end;

function Vmt_EvalSocket(): Pointer;

type
  PEvalForward=^TEvalForward;
    PFwdSockPair=^TFwdSockPair;
  TEvalForward=record
    // GenObj
    Vmt:           Pointer; // IEvalObj, IUnknown, IStream - which?
    RefCount:      integer;
    Prototype:     IEvalObj;
    Props:         PNamedPropList;
    //
    hThread:       THandle;
    idThread:      Cardinal;
    hSignal:       THandle;
    Lock:          PRtlCriticalSection;
    Pairs:         TList;
    bnTerminate:   Boolean;
  end;
  
  //PFwdSockPair=^TFwdSockPair;
  TFwdSockPair=record
    Signature:     Cardinal;
    ReadStream:    IStream; // read data from this socket stream
    WriteBuffer:   IStream; // NetPipe buffer for received data before sending...
    SendStream:    IStream; // write data to this socket stream
    hRecv:         THandle; // for determining ready-state
    hSend:         THandle; // for determining ready-state
    Socket1:       IEvalObj;
    Socket2:       IEvalObj;
    Options:       IEvalObj; // possible other options?
    LastError:     HResult;
    RestSize:      LARGE_INTEGER; // if limited size...
  end;

function Vmt_SockForward(): Pointer;
function Eval_CreateForward(Arg: Pointer; out Obj: IEvalObj; Params: PEvalNode): Boolean;

type
  // simple in-memory buffer...
  PNetPipe=^TNetPipe; //New191116
  TNetPipe=record
    // almost as GenObj...
    Vmt:           Pointer; // IStream, IRefStream, IEvalObj -> EStream, IUnknown
    RefCount:      integer;
    EStream:       IEvalObj; //Prototype:     IEvalObj;
    Props:         PNamedPropList;
    // Buffers:
    Buffers:       TListEntry; // list of TNetPipeBufDesc, Buffers.FLink=ReadBuffer, Buffers.BLink=WriteBuffer
    Size:          integer; // current amount of data in Buffers...
    Capacity:      integer; // configured maximum amount of data... =0 if pipe source closed...
  end;
  
  PNetPipeBufDesc=^TNetPipeBufDesc;
  TNetPipeBufDesc=record
    Next:          Pointer; // linked in TNetPipe.Buffers
    Buffer:        PByteArray;
    WriteOffset:   Word;
    ReadOffset:    Word;
    BufSize:       Word;
    wPad:          Word;
  end;

function Eval_CreateNetPipe(Arg: Pointer; out Obj: IStream; Params: PEvalNode): Boolean; //New191116
function Vmt_NetPipe(): Pointer; //New191116
    // Write returns Result=0 Size>0 if ok, Result=WSAEWOULDBLOCK if pipe full, Result=WSAENETRESET if pipe closed writing (Capacity=0), Result<0 on error ...
    function NetPipe_Write(Pipe: PNetPipe; Buffer: Pointer; Size: Longint; pcbWritten: PLongint): HResult; stdcall;
    // Read,Peek return Result=0 Size>0 if something read, Result=0 Size=0 if source closed and all finished, Result=ERROR_IO_PENDING if nothing read but still expecting other, Result<0 on error
    function NetPipe_Read(Pipe: PNetPipe; Buffer: Pointer; Size: Longint; pcbRead: PLongint): HResult; stdcall;
    function NetPipe_Peek(Pipe: PNetPipe; Buffer: Pointer; Size: Longint; pcbRead: PLongint): HResult; stdcall;

type
  PEvalNetNotify=^TEvalNetNotify; //New191103
  TEvalNetNotify=record
    // GenObj:
    Vmt:           Pointer; // IEvalObj, IUnknown, ...
    RefCount:      integer;
    Prototype:     IEvalObj;
    Props:         PNamedPropList;
    //
    Handle:        THandle;
    Overlapped:    TOverlapped;
  end;

function Vmt_NetNotify(): Pointer; //New191103

//-------------------------------------------------------------
implementation
//-------------------------------------------------------------

//type Largeint=Int64;

{$i DsWSock.inc}

function NeedWSock(): HResult;
begin
  if LoadWSock32() then
    Result:=0
  else
    Result:=CLASS_E_CLASSNOTAVAILABLE;// = HRESULT($80040111);
end;

function WSwap(Port: Word): integer;
asm
  xchg al,ah
  and  eax,$FFFF
end;

function dwSwap(dw: DWORD): DWORD; //New191102
asm
  bswap eax
end;

function ApiError(): HResult; //New191030
begin
  Result:=GetLastError();
  if (Result=0) then
    Result:=STG_E_ABNORMALAPIEXIT; // 800300FA
end;

function SockStream_AsyncSend(Stm: PESockStream; Buffer: Pointer; Size: Longint; pcbActual: PLongint): HResult; stdcall;
begin
  //!!! (sometime later)
end;

function SockStream_AsyncRecv(Stm: PESockStream; Buffer: Pointer; Size: Longint; pcbActual: PLongint): HResult; stdcall;
begin
  //!!! (sometime later)
end;

function SockStream_SetLastError(Stm: PESockStream; ECode: HResult): HResult;
var tv: TVarData;
begin
  if (ECode<>0)
  and (Stm.phSocket<>nil) //x191109: and (Stm.SocketObj<>nil)
  then begin
    //New191109
    Stm.phSocket.LastError:=ECode;
    if (Stm.phSocket.SocketObj<>nil) then begin
    //
      ZeroMem16(@tv);
      tv.VType:=varInteger;
      tv.VInteger:=ECode;
      IEvalObj(Stm.phSocket.SocketObj).SetProp('LastError',Variant(tv),nil); //zmena191109: +phSocket...
    end;
  end;
  Result:=ECode;
end;

function SockStream_Send(Stm: PESockStream; Buffer: Pointer; Size: Longint; pcbActual: PLongint): HResult; stdcall;
var This,nSent,Total: Longint;
    pb: Pointer;
begin
  if (Stm.phSocket=nil) or (Stm.phSocket.hSocket=0) then begin
    //ERROR_BROKEN_PIPE = 109; Result:=-ERROR_BROKEN_PIPE;// = -109;
    Result:=CO_E_OBJNOTCONNECTED;// = HRESULT($800401FD);
    exit;
  end;
  //
  if (Stm.Async<>nil) then begin
    // Async version - append to send-buffer, wake send-thread: -- not implemented yet...
    Result:=SockStream_AsyncSend(Stm,Buffer,Size,pcbActual);
    exit;
  end;
  //
  Result:=0;
  Total:=0;
  if (pcbActual=nil) then
    pcbActual:=@Total;
  //
  pb:=Buffer;
  while (Size>0) do begin
    This:=2*1440;
    if (This>Size) then
      This:=Size;
    nSent:=send(Stm.phSocket.hSocket,pb^,This,0);
    if (nSent<=0) then begin
      Result:=GetLastError();
      if (Result=0) then begin
        Result:=STG_E_ABNORMALAPIEXIT;// = HRESULT($800300FA);
        break;
      end;
      //
      if (Result=WSAEWOULDBLOCK) then begin
        // here we do not expect non-blocking socket...
        //Result:=TYPE_E_INVALIDSTATE;// = HRESULT($80028029);
        if (Total>0) then
          Result:=0
        else begin
          //Result:=E_PENDING;// = HRESULT($8000000A);
          Result:=ERROR_IO_PENDING;// = 997;
        end;
        break;
      end;
      SockStream_SetLastError(Stm,Result);
      break;
    end;
    inc(Total,nSent);
    inc(Longint(pb),nSent);
    dec(Size,nSent);
    pcbActual^:=Total;
  end;
  //
end;

function SockStream_Recv(Stm: PESockStream; Buffer: Pointer; Size: Longint; pcbActual: PLongint): HResult; stdcall;
var This,nRecv,Total,Code: Longint;
    pb: Pointer;
    ReadSet,ErrSet: TFdSet;
    time: TTimeVal;
    H: THandle;
begin
  if (Stm.phSocket=nil) or (Stm.phSocket.hSocket=0) then begin
    //ERROR_BROKEN_PIPE = 109; Result:=-ERROR_BROKEN_PIPE;// = -109;
    Result:=CO_E_OBJNOTCONNECTED;// = HRESULT($800401FD);
    exit;
  end;
  //
  if (Stm.Async<>nil) then begin
    // Async version - append to send-buffer:
    Result:=SockStream_AsyncRecv(Stm,Buffer,Size,pcbActual);
    exit;
  end;
  //
  Result:=0;
  Total:=0;
  if (pcbActual=nil) then
    pcbActual:=@Total;
  //
  pb:=Buffer;
  while (Size>0) do begin
    This:=4096;
    if (This>Size) then
      This:=Size;
    nRecv:=recv(Stm.phSocket.hSocket,pb^,This,0);
    if (nRecv<=0) then begin
      //
      if (Total>0) then begin
        // ? set last-error with nRecv=0 ? Not needed, gets nRecv=0 next time also...
        Result:=0;
        exit;
      end;
      //
      if (nRecv=0) then begin
        // EOF...
        Result:=0;
        break;
      end;
      //
      Result:=GetLastError();
      if (Result=0) then begin
        Result:=STG_E_ABNORMALAPIEXIT;// = HRESULT($800300FA);
        break;
      end;
      //
      if (Result=WSAEWOULDBLOCK) then begin
        // here we do not expect non-blocking socket...
        //Result:=TYPE_E_INVALIDSTATE;// = HRESULT($80028029);
        Result:=ERROR_IO_PENDING;// = 997;
        break;
      end;
      //
      SockStream_SetLastError(Stm,Result);
      break;
    end;
    inc(Total,nRecv);
    inc(Longint(pb),nRecv);
    dec(Size,nRecv);
    pcbActual^:=Total;
    //
    if (Size<=0)
    or (Stm.phSocket=nil)
    or (Stm.phSocket.hSocket=0)
    then
      break;
    //
    // Check, if there is more to receive now:
    ZeroMem(@ReadSet,SizeOf(ReadSet));
    ZeroMem(@ErrSet,SizeOf(ErrSet));
    H:=Stm.phSocket.hSocket;
    FD_SET(H,ReadSet);
    FD_SET(H,ErrSet);
    time.tv_sec:=0;
    time.tv_usec:=0;
    Code:=select(1,@ReadSet,nil,@ErrSet,@time);
    // Code : num sockets in sets on return, 0 on timeout, <0 on error...
    if (Code<=0) then
      break;
  end;
end;

function SslSock_Send(Stm: PESockStream; Buffer: Pointer; Size: Longint; pcbActual: PLongint): HResult; stdcall;
begin
  //!!!
end;

function SslSock_Recv(Stm: PESockStream; Buffer: Pointer; Size: Longint; pcbActual: PLongint): HResult; stdcall;
begin
  //!!!
end;

procedure SockHandle_Released(phs: PSocketHandle);
var H: THandle;
    P: Pointer;
begin
  if (phs.RefCount=0) then begin
    //
    if (phs.SslCtx<>nil) and Assigned(phs.FreeCtx) then begin
      P:=phs.SslCtx;
      phs.SslCtx:=nil;
      phs.FreeCtx(P);
    end;
    //
    H:=phs.hSocket;
    phs.hSocket:=0;
    if (H<>0) then begin
      shutdown(H,SD_BOTH);
      CloseSocket(H);
    end;
    //
    if (phs.Svc<>nil) then begin
      phs.Svc.Control(ctrl_DereferenceSocket,phs);
      FinitIntf(phs.Svc);
    end;
    //
    phs.Vmt:=nil;
    FreeMem(phs);
  end;
end;

// destructor...
function SockStream_Released(Stm: PESockStream): Longint; stdcall;
//var phs: PSocketHandle;
begin
  if (Stm.RefCount=0) then begin
    FinitIntf(Stm.phSocket); //phs:=Stm.phSocket; Stm.phSocket:=nil; if (phs<>nil) then begin dec(phs.RefCount); if (phs.RefCount=0) then SockHandle_Released(phs); end;
    //
    //x191109: FinitIntf(Stm.SocketObj);
    if (Stm.Async<>nil) then begin
      //!!! async (release)
    end;
    Stm.Vmt:=nil;
    FreeMem(Stm);
    //
    Result:=0;
  end else
    Result:=Stm.RefCount;
end;

function SockStream_GetAvailSize(Stm: PESockStream; var qwAvail: LARGE_INTEGER): HResult;
var lAvail: Longint;
begin
  if (Stm.phSocket<>nil)
  and (Stm.phSocket.hSocket<>0)
  then begin
    if (ioctlsocket(Stm.phSocket.hSocket,FIONREAD,lAvail)=0) then begin
      qwAvail.LowPart:=lAvail;
      qwAvail.HighPart:=0;
      Result:=0;
    end else begin
      Result:=ApiError(); //x191030: Result:=GetLastError(); if (Result=0) then Result:=STG_E_ABNORMALAPIEXIT; // 800300FA
    end;
  end else
    Result:=MK_E_NOOBJECT;// = HRESULT($800401E5);
end;

function SockRecv_CopyTo(Stm: PESockStream; const Output: IStream; cb: Largeint; out cbRead: Largeint; out cbWritten: Largeint): HResult; stdcall;
var Buffer: array[0..4095] of Byte;
    Size,nRead,nWritten: Longint;
    pb: PByte;
    ECode: HResult;
begin
  // copy receive-stream to output:
  // (receive-stream must be blocking...)
  cbRead:=0;
  cbWritten:=0;
  Result:=0;
  //
  if (Output=nil) then begin
    Result:=E_INVALIDARG;
    exit;
  end;
  if (cb<=0) then begin
    // copy whole:
    LARGE_INTEGER(cb).HighPart:=MaxInt;
  end;
  //
  while (cb>0) do begin
    nRead:=0;
    Size:=SizeOf(Buffer);
    if (Size>cb) then
      Size:=LARGE_INTEGER(cb).LowPart;
    ECode:=IStream(Stm).Read(@Buffer,Size,@nRead);
    if (ECode<>0) then begin
      Result:=ECode;
      exit;
    end;
    if (nRead<=0) then begin
      if (nRead=0) then
        Result:=0
      else begin
        Result:=STG_E_ABNORMALAPIEXIT; // 800300FA
      end;
      break;
    end;
    inc(cbRead,Size);
    //
    pb:=@Buffer;
    while (Size>0) do begin
      nWritten:=0;
      ECode:=Output.Write(pb,Size,@nWritten);
      if (ECode<>0) then begin
        Result:=ECode;
        exit;
      end;
      if (nWritten<=0) then begin
        Result:=STG_E_WRITEFAULT;// = HRESULT($8003001D);
        exit;
      end;
      inc(cbWritten,nWritten);
      inc(pb,nWritten);
      dec(Size,nWritten);
    end;
  end;
end;

function SockStream_Clone(Stm: PESockStream; out Clone: IStream): HResult; stdcall;
var New: PESockStream;
begin
  New:=AllocMem(SizeOf(TESockStream));
  inc(New.RefCount); //New.RefCount:=1;
  New.Operator:=Stm.Operator;
  if (Stm.phSocket<>nil) then begin
    inc(Stm.phSocket.RefCount);
    New.phSocket:=Stm.phSocket;
  end;
  //x191109: New.SocketObj:=Stm.SocketObj;
  //
  if (Stm.Async<>nil) then begin
    //!!! async
  end;
  //
  Pointer(Clone):=New;
  Result:=0;
end;

function SockStream_IsReady(Stm: PESockStream; Flags: Longint): HResult;
begin
  // Handler for ISocketStreamInfo.IsReady...
  if (Stm.Operator<>nil)
  and Assigned(Stm.Operator.IsReady)
  then begin
    Result:=Stm.Operator.IsReady(Stm,Flags);
  end else
    Result:=CO_E_NOT_SUPPORTED;// = HRESULT($80004021);
end;

const
  sir_Both = $40; //!!! keep both sir_Recv and sir_Send

function SockStream_InternalIsReady(Stm: PESockStream; Flags: Longint): HResult;
var fds,fdsExcept: TFdSet;
    pfdRead,pfdWrite,pfdExcept: PFdSet;
    Code,_0: Longint;
    time: TTimeVal;
begin
  // sir_Send uses select() with writefds
  // sir_Recv uses select() with readfds
  //
  ZeroMem(@fds,SizeOf(fds));
  ZeroMem(@fdsExcept,SizeOf(fdsExcept));
  pfdRead:=nil;
  pfdWrite:=nil;
  if (Stm.phSocket<>nil)
  and (Stm.phSocket.hSocket<>0)
  then begin
    FD_SET(Stm.phSocket.hSocket,fds);
    FD_SET(Stm.phSocket.hSocket,fdsExcept);
    //
    if (Flags and sir_Send<>0) then
      pfdWrite:=@fds
    else
    if (Flags and sir_Recv<>0) then
      pfdRead:=@fds;
    pfdExcept:=nil;
    if (Flags and sir_Except<>0) then
      pfdExcept:=@fdsExcept;
    //
    _0:=0;
    time.tv_sec:=_0;
    time.tv_usec:=_0;
    //
    Code:=select(1,pfdRead,pfdWrite,pfdExcept,@time);
    if (Code>=0) then begin
      if (Flags and sir_Except<>0)
      and FD_ISSET(Stm.phSocket.hSocket,fdsExcept)
      then
        Result:=S_FALSE // 1
      else
      if (Flags and (sir_Recv or sir_Send)<>0)
      and FD_ISSET(Stm.phSocket.hSocket,fds)
      then
        Result:=0
      else
        Result:=WSAEWOULDBLOCK;
    end else begin
      Result:=ApiError(); //x191030: Result:=GetLastError(); if (Result=0) then Result:=STG_E_ABNORMALAPIEXIT; // 800300FA
    end;
  end else
    Result:=CO_E_OBJNOTCONNECTED; // 800401FD
end;

function SockStream_SendIsReady(Stm: PESockStream; Flags: Longint): HResult;
begin
  // use select() with writefds
  if (Flags and sir_Both=0) then
    Flags:=Flags and not sir_Recv;
  if (Flags and sir_Except=0) then
    Flags:=Flags or sir_Send;
  Result:=SockStream_InternalIsReady(Stm,Flags);
end;

function SockStream_RecvIsReady(Stm: PESockStream; Flags: Longint): HResult;
begin
  // use select() with readfds
  if (Flags and sir_Both=0) then
    Flags:=Flags and not sir_Send;
  if (Flags and sir_Except=0) then
    Flags:=Flags or sir_Recv;
  Result:=SockStream_InternalIsReady(Stm,Flags);
end;

function Vmt_ESockStream(Kind: Byte): Pointer;
asm //                      EAX
  and  eax,7
  mov  edx,offset @VmtList
  mov  eax,[edx+4*eax]
  ret
@VmtList:
  dd  @Vmt_IStream       // vmt__SockStream
  dd  @Vmt_SendOperator  // vmt__SendOperator
  dd  @Vmt_RecvOperator  // vmt__RecvOperator
  dd  @Vmt_SslSendOp     // vmt__SslSendOp
  dd  @Vmt_SslRecvOp     // vmt__SslRecvOp
  dd  0,0
  //dd  0 -- shared with following dd 0...
  //
  dd  0
@Vmt_IStream:
  // IUnknown:
  dd  @QueryInterface
  dd  @AddRef
  dd  @Release
  // IStream
  dd  @Read
  dd  @Write
  dd  @Seek
  dd  @SetSize
  dd  @CopyTo
  dd  @Commit
  dd  @Revert
  dd  @LockRegion
  dd  @UnlockRegion
  dd  @Stat
  dd  @Clone
  //
  dd  0
  db  'SockStream',0,0
  //
@Vmt_SendOperator:
  // TSockStreamOperator
  dd  0 // Read
  dd  SockStream_Send // Write
  dd  SockStream_SendIsReady // IsReady
  dd  0
  //
@Vmt_RecvOperator:
  // TSockStreamOperator
  dd  SockStream_Recv // Read
  dd  0 // Write
  dd  SockStream_RecvIsReady // IsReady
  dd  0
  //
@Vmt_SslSendOp:
  // TSockStreamOperator
  dd  0  // Read
  dd  SslSock_Send // Write
  dd  SockStream_SendIsReady // IsReady
  dd  0
@Vmt_SslRecvOp:
  // TSockStreamOperator
  dd  SslSock_Recv  // Read
  dd  0 // Write
  dd  SockStream_RecvIsReady // IsReady
  dd  0
  //
@Vmt_ISocketStreamInfo:
  // IUnknown
  dd  @Qi_SocketStreamInfo
  dd  GenHelper_AddRef
  dd  GenHelper_Release
  // ISocketStreamInfo
  dd  @Ssi_GetSocketHandle
  dd  @Ssi_GetAvailSize
  dd  @Ssi_IsReady
  dd  @Ssi_Peek //New191116
  dd  0
  //
@qi_IStream:
  dd  offset guid_IStream
  dd  @qi_this
  dd  offset guid_IEvalObj
  dd  @qi_EvalObj
  dd  offset guid_INetSvcStream //New191029
  dd  @qi_NetSvc
  dd  offset guid_IUnknown
  dd  @qi_this
  dd  offset guid_ISocketStreamInfo
  dd  @qi_SocketInfo_FromStream
  dd  0
  dd  ENoInterface_rb12
  //
@qidef_ISocketStreamInfo:
  dd  offset guid_ISocketStreamInfo
  dd  @qi_this
  dd  offset guid_IUnknown
  dd  @qi_this
  dd  offset guid_IStream
  dd  @qi_fromHelper
  dd  0
  dd  ENoInterface_rb12
  //
@Qi_SocketStreamInfo: // [esp+4]=Self, [esp+8]=Guid, [esp+12]=^Out ...
  // in Helper.QueryInterface
  mov  eax,offset @qidef_ISocketStreamInfo
  jmp  @qi0
  //
@QueryInterface:
  // [esp+4]=[ebp+8]=Self, [esp+8]=[ebp+12]=Guid, [esp+12]=[ebp+16]=^Out
  mov  eax,offset @qi_IStream
@qi0:
  push ebp
  mov  ebp,esp
  // IEvalObj,IStream->helper,IEvalObjEnumerable->helper,IEvalPrototype->Prototype.IEvalObj,IUnknown
  call QiMultiInternal
  jmp  eax
  //
@qi_this:
  // this interface...
  mov  eax,[ebp+8]
  push eax
  mov  eax,[eax]
  call [eax].TIUnknownVmt.AddRef
  //
  mov  eax,[ebp+8]
  //
@qi_retEax:
  mov  ecx,[ebp+16]
  mov  [ecx],eax
  xor  eax,eax
@rb12:
  mov  esp,ebp
  pop  ebp
  retn 12
  //
@qi_EvalObj:
  mov  eax,[ebp+8]
  //x191109: mov  eax,[eax].TESockStream.SocketObj
  //New191109
  mov  eax,[eax].TESockStream.phSocket
  test eax,eax
  jz   @no_obj
  mov  eax,[eax].TSocketHandle.SocketObj
  //
  test eax,eax
  jz   @no_obj
  push dword [ebp+16]
  push dword [ebp+12]
  push eax
  mov  eax,[eax]
  call [eax].TIUnknownVmt.QueryInterface
  jmp  @rb12
  //
@qi_NetSvc: //New191029
  mov  eax,[ebp+8]
  mov  eax,[eax].TESockStream.phSocket
  test eax,eax
  jz   @no_obj
  mov  eax,[eax].TSocketHandle.Svc
  test eax,eax
  //jz   @no_obj
  mov  [ebp+8],eax
  jnz  @qi_this
@no_obj:
  mov  eax,MK_E_NOOBJECT
  jmp  @rb12
  //
@qi_fromHelper:
  mov  eax,[ebp+8]
  mov  eax,[eax].TEvalGenHelper.Target
  mov  [ebp+8],eax
  jmp  @qi_this
  //
@qi_SocketInfo_FromStream:
  //function MakeGenHelperI(Vmt: Pointer; const Target: IUnknown; ReserveSize: integer): PEvalGenHelper;
  mov  edx,[ebp+8]
  mov  eax,offset @Vmt_ISocketStreamInfo
  xor  ecx,ecx
  call MakeGenHelperI
  jmp  @qi_retEax
  //
@AddRef: // [esp+4]=Self
  mov  eax,[esp+4]
  lea  eax,[eax].TESockStream.RefCount
  push 1
  pop  edx
  lock xadd [eax],edx
  inc  edx
  mov  eax,edx
  retn 4
  //
@Release: // [esp+4]=Self
  mov  eax,[esp+4]
  lea  eax,[eax].TESockStream.RefCount
  or   edx,-1
  lock xadd [eax],edx
  dec  edx
  jz   SockStream_Released // is stdcall, pass our parameter...
  mov  eax,edx
  retn 4
  //
@Read:
  //function Read(Self; pv: Pointer; cb: Longint; pcbRead: PLongint): HResult; stdcall;
  //             [+4]  [+8]          [+12]        [+16]
  mov  eax,[esp+4]
  mov  eax,[eax].TESockStream.Operator
  cmp  [eax].TSockStreamOperator.Read,0
  je   @no_read
  // call operator, update IoSize ...
  push dword [esp+16]
  push dword [esp+16]
  push dword [esp+16]
  push dword [esp+16]
  call [eax].TSockStreamOperator.Read
  //
  test eax,eax
  jnz  @done_16
  //
  mov  edx,[esp+4]
  mov  ecx,[esp+16]
  mov  ecx,[ecx]
  add  [edx].TESockStream.IoSize.LowPart,ecx
  adc  [edx].TESockStream.IoSize.LowPart,eax // here eax=0...
  jmp  @done_16
  //
@Write:
  //function Write(Self; pv: Pointer; cb: Longint; pcbWritten: PLongint): HResult; stdcall;
  //              [+4]  [+8]          [+12]        [+16]
  mov  eax,[esp+4]
  mov  eax,[eax].TESockStream.Operator
  cmp  [eax].TSockStreamOperator.Write,0
  je   @no_write
  // call operator, update IoSize ...
  push dword [esp+16]
  push dword [esp+16]
  push dword [esp+16]
  push dword [esp+16]
  call [eax].TSockStreamOperator.Write
  //
  test eax,eax
  jnz  @done_16
  //
  mov  edx,[esp+4]
  mov  ecx,[esp+16]
  mov  ecx,[ecx]
  add  [edx].TESockStream.IoSize.LowPart,ecx
  adc  [edx].TESockStream.IoSize.LowPart,eax // here eax=0...
  //
@done_16:
  retn 16
  //
@no_read:
@no_write:
  mov  eax,E_NOTIMPL
  jmp  @done_16
  //
@Seek:
  //function Seek(Self; dlibMove: Largeint; dwOrigin: Longint; out libNewPosition: Largeint): HResult; stdcall;
  //              [+4]  [+8]                [+16]              [+20]
  //
  // supports only Seek(0,soFromCurrent) to return SendSize/RecvSize...
  cmp  dword [esp+16],so_GetAvailSize
  je   @SeekGetAvail
  cmp  dword [esp+16],soFromCurrent
  jne  @notImpl_20
  xor  edx,edx
  cmp  dword [esp+8],edx
  jne  @notImpl_20
  cmp  dword [esp+12],edx
  jne  @notImpl_20
  mov  eax,[esp+4]
  mov  ecx,[esp+20]
  mov  edx,[eax].TESockStream.IoSize.LowPart
  mov  [ecx],edx
  mov  edx,[eax].TESockStream.IoSize.HighPart
  mov  [ecx+4],edx
  xor  eax,eax
  retn 20
  //
@SeekGetAvail:
  cmp  dword [esp+16],0
  jne  @notImpl_20
  mov  eax,[esp+4] // Self
  //
  mov  edx,[eax].TESockStream.Operator
  cmp  [edx].TSockStreamOperator.Read,0
  jz   @notImpl_20
  //
  mov  edx,[esp+20] // ^libNewPosition
  call SockStream_GetAvailSize
  retn 20
  //
@notImpl_20:
  mov  eax,E_NOTIMPL
  retn 20
  //
@SetSize:
  //function SetSize(Self; libNewSize: Largeint): HResult; stdcall;
  mov  eax,E_NOTIMPL
  retn 12
@CopyTo:
  //function CopyTo(Self; stm: IStream; cb: Largeint; out cbRead: Largeint; out cbWritten: Largeint): HResult; stdcall;
  //               [+4]   [+8]          [+12]             [+20]                 [+24]
  mov  eax,[esp+4]
  mov  eax,[eax].TESockStream.Operator
  cmp  [eax].TSockStreamOperator.Read,0
  je   @notImpl_24
  //
  jmp  SockRecv_CopyTo
  //retn 24
  //
@Commit:
  //function Commit(Self; grfCommitFlags: Longint): HResult; stdcall;
  mov  eax,E_NOTIMPL
  retn 8
@Revert:
  //function Revert(Self): HResult; stdcall;
  mov  eax,E_NOTIMPL
  retn 4
  //
@LockRegion:
@UnLockRegion:
@notImpl_24:
  //function LockRegion(Self; libOffset: Largeint; cb: Largeint; dwLockType: Longint): HResult; stdcall;
  //function UnlockRegion(Self; libOffset: Largeint; cb: Largeint; dwLockType: Longint): HResult; stdcall;
  mov  eax,E_NOTIMPL
  retn 24
  //
@Stat:
  //function Stat(Self; out statstg: TStatStg; grfStatFlag: Longint): HResult; stdcall;
  //             [+4]       [+8]               [+12]
  mov  edx,[esp+8]
  // clear 17 dwords:
  push 17
  pop  ecx
  xor  eax,eax
@cl17_cy:
  mov  [edx],eax
  add  edx,4
  dec  ecx
  jnz  @cl17_cy
  // return SendSize/RecvSize
  mov  eax,[esp+4]
  mov  edx,[esp+8]
  mov  ecx,[eax].TESockStream.IoSize.LowPart
  mov  dword ptr [edx].TStatStg.cbSize,ecx
  mov  ecx,[eax].TESockStream.IoSize.HighPart
  mov  dword ptr [edx].TStatStg.cbSize+4,ecx
  //
  xor  eax,eax
  retn 12
  //
@Clone:
  //function Clone(Self; out stm: IStream): HResult; stdcall;
  jmp  SockStream_Clone
  //retn 8
  //
@Ssi_GetSocketHandle: // eax=Helper, edx=^hSocket out, returns HResult
  mov  eax,[eax].TEvalGenHelper.Target
  mov  eax,[eax].TESockStream.phSocket
  test eax,eax
  jz   @noobj_0
  mov  eax,[eax].TSocketHandle.hSocket
  test eax,eax
  jz   @noobj_0
  mov  [edx],eax
@0ok:
  xor  eax,eax
  ret
  //
@Ssi_GetAvailSize: // eax=Helper, edx=^AvailSize out, returns HResult
  mov  eax,[eax].TEvalGenHelper.Target
  push edx
  push 0
  push 0
  mov  edx,esp
  // SockStream_GetAvailSize(Self,@qwTemp)
  call SockStream_GetAvailSize
  pop  ecx
  pop  edx
  pop  edx
  test eax,eax
  jnz  @out0
  mov  [edx],ecx
  ret
  //
@Ssi_IsReady: // eax=Helper, edx=Flags, returns HResult
  mov  eax,[eax].TEvalGenHelper.Target
  jmp  SockStream_IsReady
  //
@Ssi_Peek: // eax=Helper, edx=Buffer, ecx=^Size, out eax=HResult
  //!!!
  //
  mov  eax,E_NOTIMPL
  ret
  //
@noobj_0:
  mov  eax,MK_E_NOOBJECT
  //ret
@out0:
  //ret
end;

function EvalSocket_Destroy(Sock: PEvalSocket): Longint; stdcall;
var P: Pointer; //phs: PSocketHandle;
begin
  if (Sock.RefCount=0) then begin
    //
    FinitIntf(Sock.phSocket); // phs:=Sock.phSocket; Sock.phSocket:=nil; if (phs<>nil) then begin dec(phs.RefCount); if (phs.RefCount=0) then SockHandle_Released(phs); end;
    //
    FinitIntf(Sock.SendStream);
    FinitIntf(Sock.RecvStream);
    //
    P:=Sock.MyAddress;
    Sock.MyAddress:=nil;
    if (P<>nil) then
      FreeMem(P);
    P:=Sock.PeerAddress;
    Sock.PeerAddress:=nil;
    if (P<>nil) then
      FreeMem(P);
    //
    Result:=GenObj_Released(Sock);
  end else
    Result:=Sock.RefCount;
end;

function DnsLookup(const Name: String8; Addr: PSockAddr): Boolean;
var ph: PHostEnt;
begin
  if (Name<>'') then begin
    ph:=gethostbyname(PChar8(Name));
    if (ph<>nil) then begin
      //!!! ph.h_addrtype, ph.h_length ?!
      Addr.sin_family:=AF_INET;
      Addr.sin_addr.S_addr:=Longint(Pointer(ph^.h_addr_list^)^);
      Result:=True;
      exit;
    end;
  end;
  Result:=False;
end;

function GetIpProp(var ResVar: Variant; lpTempStr: PString8; Addr: PSockAddr; bnWithPort: Boolean): Boolean; forward;

function Eval_DnsLookup(var ResVar: Variant; Args: PEvalNode): Boolean;
var S: String8;
    Addr: TSockAddrIn;
    ECode: HResult;
begin
  //* DnsLookup('host.cz',?options)  - returns string '1.2.3.4'
  //!!!TODO +reverse lookup?
  Result:=False;
  if EvalNodeStr8(Args,S) then begin
    if (S<>'') then begin
      ZeroMem(@Addr,SizeOf(Addr));
      //
      ECode:=NeedWSock();
      if (ECode<>0) then begin
        EvalHResultToVar(ResVar,ECode);
        Result:=True;
        exit;
      end;
      //
      if DnsLookup(S,@Addr) then begin
        Result:=GetIpProp(ResVar,@S,@Addr,False);
        exit;
      end;
    end;
    SetVarNull(ResVar);
    Result:=True;
  end;
end;

function Eval_IpAddress_v1(Params: PObjCallParams; Addr: PSockAddr; bnPortRequired: Boolean): Boolean;
var Int,i: Longint;
    pc,pe: PChar8;
    pb: PByte;
Label _BadIp,_ParsePort,_Ok;
begin
  // evaluate (Ip,Port) or ('Ip:Port'), updates Params.Args, fills Addr ...
  Result:=False;
  if EvalNodeStr8(Params.Args,Params.TempStr1) then begin
    Params.Args:=Params.Args.Next;
    // Parse IP address, possibly with port:
    pc:=PChar8(Params.TempStr1);
    if (pc=nil) then
      exit;
    //!!! ipv6?
    pb:=Pointer(@Addr.sin_addr);
    //inc(Longint(pb),3);
    i:=0;
    while True do begin
      if not (pc^ in ['0'..'9']) then begin
        // Is it DNS name?
      _BadIp:
        pc:=PChar8(Params.TempStr1);
        pe:=pc;
        while not (pe^ in [#0,':','/']) do
          inc(pe);
        SetString(Params.TempStr2,pc,pe-pc);
        pc:=pe;
        //
        if not DnsLookup(Params.TempStr2,Addr) then
          exit;
        //
        if (pc^=':') then
          goto _ParsePort
        else
          goto _Ok;
        //
      end;
      pc:=ValPcNums(pc,Int);
      if (Int<0) or (Int>255) then
        goto _BadIp;
      pb^:=Int;
      inc(pb); //dec(pb); //inc(pb);
      inc(i);
      if (i>=4) then
        break;
      if (pc^<>'.') then
        goto _BadIp;
      inc(pc);
    end;
    // it is IPv4
    Addr.sin_family:=AF_INET;
    //
    if (pc^=':') then begin
    _ParsePort:
      inc(pc);
      if (pc^ in ['0'..'9']) then begin
        pc:=ValPcNums(pc,Int);
        if (Int<0) or (Int>=65535) then
          exit;
        Addr.sin_port:=WSwap(Int);
      end;
      if (pc^<>#0) and (pc^<>'/') then
        exit;
    end else
    if (pc^<>#0) then
      goto _BadIp;
  _Ok:
    //
    if (Addr.sin_port=0)
    and (bnPortRequired or (Params.Args<>nil))
    then begin
      if not EvalNodeInt(Params.Args,Int) then
        exit;
      Addr.sin_port:=WSwap(Int);
    end;
    //
    Result:=True;
  end;
end;

function ParseStrAddress(const S: String8; Addr: PSockAddr): Boolean; //New191030
var pc,pe: PChar8;
    pb: PByte;
    i,Int: integer;
    S2: String8;
Label _BadIp,_ParsePort,_Ok;
begin
  Result:=False;
  pb:=Pointer(@Addr.sin_addr);
  pc:=PChar8(S);
  //
  //New191102 - it may be binary string:
  if (Length(S)=4) then begin
    Addr.sin_addr.S_addr:=PDWORD(Pointer(S))^;
    Result:=True;
    exit;
  end;
  //
  i:=0;
  while True do begin
    if not (pc^ in ['0'..'9']) then begin
      // Is it DNS name?
    _BadIp:
      pc:=PChar8(S);
      pe:=pc;
      while not (pe^ in [#0,':','/']) do
        inc(pe);
      SetString(S2,pc,pe-pc);
      pc:=pe;
      if not DnsLookup(S2,Addr) then
        exit;
      if (pc^=':') then
        goto _ParsePort
      else
        goto _Ok;
    end;
    //
    pc:=ValPcNums(pc,Int);
    if (Int<0) or (Int>255) then
      goto _BadIp;
    //
    pb^:=Int;
    inc(pb);
    inc(i);
    if (i>=4) then
      break;
    if (pc^<>'.') then
      goto _BadIp;
    inc(pc);
  end;
  if (i=4) then begin
    // it is IPv4
    Addr.sin_family:=AF_INET;
  end;
  if (pc^=':') then begin
  _ParsePort:
    inc(pc);
    if (pc^ in ['0'..'9']) then begin
      pc:=ValPcNums(pc,Int);
      if (Int<0) or (Int>=65535) then
        exit;
      Addr.sin_port:=WSwap(Int);
    end;//else named port like 'www' ?!
    //
    if (pc^<>#0) and (pc^<>'/') then
      exit;
    //
    //Result:=True;
  end else
  if not (pc^ in [#0,'/']) then
    goto _BadIp;
  //
_Ok:
  Result:=True;
end;

function Eval_IpAddress(Params: PObjCallParams; Addr: PSockAddr; bnPortRequired: Boolean): Boolean; //zmena191030 - if we return address in object, support it...
var bnAddr,bnPort: Boolean;
    Int: Longint;
    qw: LARGE_INTEGER;
Label _Retry1,_Str;
begin
  Result:=False;
  //
  if not EvaluateNode(Variant(Params.TempVar),Params.Args) then
    exit;
  Params.Args:=Params.Args.Next;
  bnAddr:=False;
  bnPort:=False;
  //
_Retry1:
  case TVarData(Params.TempVar).VType and varTypeMask of
    varUnknown: begin
      if EvalVarToObj(Variant(Params.TempVar),Params.TempObj) then begin
        if (GetObjProp(Params.TempObj,'Address',Variant(Params.TempVar))
           or
            GetObjProp(Params.TempObj,'Ip',Variant(Params.TempVar))
           )
        and EvalVarToStr8(Variant(Params.TempVar),Params.TempStr1)
        then begin
          bnAddr:=ParseStrAddress(Params.TempStr1,Addr);
          bnPort:=(Addr.sin_port<>0);
        end;
        if not bnPort then begin
          if GetObjProp(Params.TempObj,'Port',Variant(Params.TempVar))
          and EvalVarToInt(Variant(Params.TempVar),Int)
          and (Int>=0) and (Int<=65534)
          then begin
            Addr.sin_port:=WSwap(Int);
            bnPort:=True;
          end;
        end;
        if bnAddr and (bnPort or (not bnPortRequired)) then begin
          Result:=True;
          exit;
        end;
        EvalIntfToVar(Params.TempObj,Variant(Params.TempVar));
      end;
      if EvalVarObjToBaseType(Variant(Params.TempVar),Variant(Params.TempVar)) then
        goto _Retry1;
    end;
    varString,varOleStr: begin
      if EvalVarToStr8(Variant(Params.TempVar),Params.TempStr1) then begin
        bnAddr:=ParseStrAddress(Params.TempStr1,Addr);
        bnPort:=(Addr.sin_port<>0);
      end;
    end;
    varInteger,$13..$14: begin
      if EvalVarToInt64(Variant(Params.TempVar),qw.QuadPart) then begin
        Addr.sin_addr.S_addr:=dwSwap(qw.LowPart); //zmena191102: +dwSwap...
        bnAddr:=True;
      end;
    end;
    0..varNull: begin
      Addr.sin_addr.S_addr:=0;
      bnAddr:=True;
    end;
  end;
  //
  if bnAddr and not bnPort and bnPortRequired then begin
    Int:=WSwap(Addr.sin_port);
    if not EvalNodeInt_Optional(Params.Args,Int) then
      exit;
    if (Params.Args<>nil) then
      Params.Args:=Params.Args.Next;
    //
    if (Int<0) or (Int>=65535) then
      exit;
    Addr.sin_port:=WSwap(Int);
    bnPort:=True;
  end;
  Result:=bnAddr and (bnPort or (not bnPortRequired));
end;

function Vmt_SocketHandle(): Pointer;
asm
  mov eax,offset @Vmt
  ret
  nop
  nop
  dd 0
@Vmt:
  // IUnknown
  dd @QueryInterface
  dd @AddRef
  dd @Release
  // ISocketHandle
  dd @GetHandle
  dd @GetSslCtx
  //
  dd 0
  db 'HSocket',0
  //
@qi_def:
  dd offset guid_ISocketHandle //New191030
  dd @qi_this
  dd offset guid_IUnknown
  dd @qi_this
  dd offset guid_INetSvcStream //New191030
  dd @qi_NetSvc
  dd 0
  dd ENoInterface_rb12
  //
@QueryInterface:
  // [esp+4]=[ebp+8]=Self, [esp+8]=[ebp+12]=Guid, [esp+12]=[ebp+16]=^Out
  mov  eax,offset @qi_def
@qi0:
  push ebp
  mov  ebp,esp
  // IEvalObj,IStream->helper,IEvalObjEnumerable->helper,IEvalPrototype->Prototype.IEvalObj,IUnknown
  call QiMultiInternal
  jmp  eax
  //
@qi_this:
  // this interface...
  mov  eax,[ebp+8]
  push eax
  mov  eax,[eax]
  call [eax].TIUnknownVmt.AddRef
  //
  mov  eax,[ebp+8]
  //
@qi_retEax:
  mov  ecx,[ebp+16]
  mov  [ecx],eax
  xor  eax,eax
@rb12:
  mov  esp,ebp
  pop  ebp
  retn 12
  //
@qi_NetSvc:
  mov  eax,[ebp+8]
  mov  eax,[eax].TSocketHandle.Svc
  test eax,eax
  mov  [ebp+8],eax
  jnz  @qi_this // or @qi_AskThere
@no_obj:
  mov  eax,MK_E_NOOBJECT
  jmp  @rb12
  //
@AddRef: // [esp+4]=Self
  mov  eax,[esp+4]
  lea  eax,[eax].TSocketHandle.RefCount
  push 1
  pop  edx
  lock xadd [eax],edx
  inc  edx
  mov  eax,edx
  retn 4
  //
@Release: // [esp+4]=Self
  mov  eax,[esp+4]
  lea  eax,[eax].TSocketHandle.RefCount
  or   edx,-1
  lock xadd [eax],edx
  dec  edx
  jnz  @rel_out
@_Released:
  mov  eax,[esp+4]
  call SockHandle_Released
  xor  edx,edx
@rel_out:
  mov  eax,edx
  retn 4
  //
@GetHandle:
  mov  eax,[eax].TSocketHandle.HSocket
  ret
  //
@GetSslCtx:
  mov  eax,[eax].TSocketHandle.SslCtx
  //ret
end;

function Eval_CreateSockStream(OperatorVmtId: Byte; var Stream; const SocketObj: IEvalObj; phSocket: PSocketHandle): Boolean;
var Stm: PESockStream;
    OpVmt: Pointer;
begin
  OpVmt:=Vmt_ESockStream(OperatorVmtId);
  if (OpVmt=nil) then begin
    FinitIntf(Stream);
    Result:=False;
    exit;
  end;
  //
  Stm:=AllocMem(SizeOf(TESockStream));
  Stm.Vmt:=Vmt_ESockStream(0);
  Stm.Operator:=OpVmt;
  inc(Stm.RefCount); // Stm.RefCount:=1;
  if (phSocket<>nil) then begin
    inc(phSocket.RefCount);
    Stm.phSocket:=phSocket;
  end;
  //x191109: Stm.SocketObj:=SocketObj;
  FinitIntf(Stream);
  Pointer(Stream):=Stm;
  Result:=True;
end;

function Sock_MakeStreams(Sock: PEvalSocket): Boolean;
begin
  Result:=False;
  if (Sock.SendStream=nil) then begin
    if not Eval_CreateSockStream(vmt__SendOperator,Sock.SendStream,IEvalObj(Sock),Sock.phSocket) then
      exit;
  end;
  if (Sock.RecvStream=nil) then begin
    if not Eval_CreateSockStream(vmt__RecvOperator,Sock.RecvStream,IEvalObj(Sock),Sock.phSocket) then
      exit;
  end;
  Result:=True;
end;

type
  PNetSvcStream=^TNetSvcStream; //New191029
  TNetSvcStream=record
    Vmt:           Pointer;
    RefCount:      integer;
    phSocket:      PSocketHandle; // not referenced here ? who references who ?!
  end;

function NetSvc_Released(Svc: PNetSvcStream): Longint; stdcall; //New191029
begin
  if (Svc.RefCount=0) then begin
    Svc.Vmt:=nil;
    Svc.phSocket:=nil; //!!! ref-count?
    FreeMem(Svc);
    //
    Result:=0;
  end else
    Result:=Svc.RefCount;
end;

// function PeekData(Self; Buffer: Pointer; var Size: integer): HResult; // recv with MSG_PEEK - do not consume from buffer (if it is supported?)
function NetSvc_PeekData(Svc: PNetSvcStream; Buffer: Pointer; var Size: integer): HResult; //New191029 // recv with MSG_PEEK - do not consume from buffer (if it is supported?)
var S: integer;
begin
  if (Svc.phSocket<>nil)
  and (Svc.phSocket.HSocket<>0)
  then begin
    S:=recv(Svc.phSocket.HSocket,Buffer^,Size,MSG_PEEK);
    if (S>=0) then begin
      Size:=S;
      Result:=0;
    end else begin
      Size:=0;
      Result:=ApiError();
    end;
  end else
    Result:=MK_E_NOOBJECT;
end;

// function RecvFrom(Self; Buffer: Pointer; var Size: integer; Addr: Pointer; var AddrSize: integer): HResult;
function NetSvc_RecvFrom_Tcp(Svc: PNetSvcStream; Buffer: Pointer; var Size: integer; Addr: Pointer; var AddrSize: integer): HResult; //New191029
begin
  // probably needed only for UDP...
  Result:=E_NOTIMPL;
end;

// function SendTo(Self; Buffer: Pointer; var Size: integer; Addr: Pointer; AddrSize: integer): HResult;
function NetSvc_SendTo_Tcp(Svc: PNetSvcStream; Buffer: Pointer; var Size: integer; Addr: Pointer; AddrSize: integer): HResult; //New191030
begin
  // probably needed only for UDP...
  Result:=E_NOTIMPL;
end;

// function RecvFrom(Self; Buffer: Pointer; var Size: integer; Addr: Pointer; var AddrSize: integer): HResult;
function NetSvc_RecvFrom_Udp(Svc: PNetSvcStream; Buffer: Pointer; var Size: integer; Addr: Pointer; var AddrSize: integer): HResult; //New191029
var HSocket: THandle;
    TempAddr: TSockAddr;
    Flags,S,ASize: integer;
begin
  if (Svc.phSocket<>nil) then begin
    HSocket:=Svc.phSocket.HSocket;
    if (Addr=nil) or (AddrSize<SizeOf(TSockAddr)) then begin
      Addr:=@TempAddr;
      ASize:=SizeOf(TSockAddrIn);
    end else
      ASize:=AddrSize;
    ZeroMem(Addr,ASize);
    Flags:=0;
    //
    S:=recvfrom(HSocket,Buffer^,Size,Flags,TSockAddr(Addr^),AddrSize);
    if (S>0) then begin
      Size:=S;
      Result:=0;
    end else begin
      Size:=0;
      Result:=GetLastError();
    end;
  end else
    Result:=MK_E_NOOBJECT;
end;

// function SendTo(Self; Buffer: Pointer; var Size: integer; Addr: Pointer; AddrSize: integer): HResult;
function NetSvc_SendTo_Udp(Svc: PNetSvcStream; Buffer: Pointer; var Size: integer; Addr: Pointer; AddrSize: integer): HResult; //New191030
var S: integer;
begin
  if (Svc.phSocket<>nil)
  and (Svc.phSocket.HSocket<>0)
  then begin
    S:=sendto(Svc.phSocket.HSocket,Buffer^,Size,0,PSockAddr(Addr)^,AddrSize);
    if (S>=0) then begin
      Size:=S;
      Result:=0;
    end else
      Result:=ApiError();
  end else
    Result:=MK_E_NOOBJECT;
end;

function NetSvc_Dereference(Svc: PNetSvcStream; Code: Longint; Param: Pointer): HResult; //New191029
begin
  // Code=ctrl_DereferenceSocket
  if (Param=Svc.phSocket) then begin
    Svc.phSocket:=nil;
    Result:=0;
  end else
    Result:=S_FALSE;
end;

function NetSvc_GetSockFlag(Svc: PNetSvcStream; Code: Longint; Param: Pointer): HResult; //New191029
begin
  // Code=ctrl_GetSocketFlag
  //!!!
  Result:=E_NOTIMPL;
end;

function NetSvc_SetSockFlag(Svc: PNetSvcStream; Code: Longint; Param: Pointer): HResult; //New191029
begin
  // Code=ctrl_SetSocketFlag
  //!!!
  Result:=E_NOTIMPL;
end;

function NetSvc_GetPeerInfo(Svc: PNetSvcStream; Code: Longint; Param: Pointer): HResult; //New191029
var Addr: TSockAddr;
    hSocket: THandle;
    Size: Longint;
begin
  // Code=ctrl_GetPeerInfo
  if (Svc<>nil)
  and (Svc.phSocket<>nil)
  then begin
    hSocket:=Svc.phSocket.HSocket;
    Size:=SizeOf(Addr);
    if (GetPeerName(hSocket,Addr,Size)=0) then begin
      Move(Addr,Param^,Size);
      Result:=0;
    end else begin
      Result:=ApiError(); //x191030: Result:=GetLastError(); if (Result=0) then Result:=STG_E_ABNORMALAPIEXIT; // 800300FA
    end;
  end else
    Result:=MK_E_NOOBJECT;
end;

// Kind: 1=tcp, 2=udp, ...
function Vmt_NetSvc(Kind: Byte): Pointer; //New191029
asm
  and  eax,1
  mov  eax,dword ptr @Vmts[eax*4]
  ret
@Vmts:
  dd offset @Vmt_TcpNetSvc
  dd offset @Vmt_UdpNetSvc
  //
  dd 0
@Vmt_TcpNetSvc:
  // IUnknown
  dd @QueryInterface
  dd @AddRef
  dd @Release
  // INetSvcStream
  dd NetSvc_PeekData
  dd NetSvc_RecvFrom_Tcp
  dd NetSvc_SendTo_Tcp
  dd @Control_Tcp
  dd 0
  db 'TcpNetSvc',0,0
@Control_Tcp:
  call ObjControlTable
  dd ctrl_DereferenceSocket,       NetSvc_Dereference
  dd ctrl_GetSocketFlag,           NetSvc_GetSockFlag
  dd ctrl_SetSocketFlag,           NetSvc_SetSockFlag
  dd ctrl_GetPeerInfo,             NetSvc_GetPeerInfo
  dd 0,@NetSvc_NoControl
  //
@Vmt_UdpNetSvc:
  dd @QueryInterface
  dd @AddRef
  dd @Release
  // INetSvcStream
  dd NetSvc_PeekData
  dd NetSvc_RecvFrom_Udp
  dd NetSvc_SendTo_Udp
  dd @Control_Udp
  dd 0
  db 'UdpNetSvc',0,0
@Control_Udp:
  call ObjControlTable
  dd ctrl_DereferenceSocket,       NetSvc_Dereference
  dd ctrl_GetSocketFlag,           NetSvc_GetSockFlag
  dd ctrl_SetSocketFlag,           NetSvc_SetSockFlag
  dd ctrl_GetPeerInfo,             NetSvc_GetPeerInfo
  dd 0,@NetSvc_NoControl
  //
@qi_def:
  dd offset guid_INetSvcStream,   @qi_this
  dd offset guid_IUnknown,        @qi_this
  dd 0,ENoInterface_rb12
  //
@QueryInterface:
  // [esp+4]=[ebp+8]=Self, [esp+8]=[ebp+12]=Guid, [esp+12]=[ebp+16]=^Out
  mov  eax,offset @qi_def
@qi0:
  push ebp
  mov  ebp,esp
  // IEvalObj,IStream->helper,IEvalObjEnumerable->helper,IEvalPrototype->Prototype.IEvalObj,IUnknown
  call QiMultiInternal
  jmp  eax
  //
@qi_this:
  // this interface...
  mov  eax,[ebp+8]
  push eax
  mov  eax,[eax]
  call [eax].TIUnknownVmt.AddRef
  //
  mov  eax,[ebp+8]
  //
@qi_retEax:
  mov  ecx,[ebp+16]
  mov  [ecx],eax
  xor  eax,eax
@rb12:
  mov  esp,ebp
  pop  ebp
  retn 12
  //
@AddRef: // [esp+4]=Self
  mov  eax,[esp+4]
  lea  eax,[eax].TNetSvcStream.RefCount
  push 1
  pop  edx
  lock xadd [eax],edx
  inc  edx
  mov  eax,edx
  retn 4
  //
@Release: // [esp+4]=Self
  mov  eax,[esp+4]
  lea  eax,[eax].TNetSvcStream.RefCount
  or   edx,-1
  lock xadd [eax],edx
  dec  edx
  jz   NetSvc_Released // is stdcall, pass our parameter...
  mov  eax,edx
  retn 4
  //
@NetSvc_NoControl:
  mov eax,E_NOTIMPL
  //ret
end;

function MakeNetSvc(var ASvc: INetSvcStream; phs: PSocketHandle; Kind: Byte): Boolean; //New191029
var Svc: PNetSvcStream;
begin
  Svc:=AllocMem(SizeOf(TNetSvcStream));
  Svc.Vmt:=Vmt_NetSvc(Kind);
  Svc.phSocket:=phs; // not referenced...
  ASvc:=INetSvcStream(Svc);
  Result:=True;
end;

function MakeTcpSvc(var Svc: INetSvcStream; phs: PSocketHandle): Boolean; //New191029
begin
  // make INetSvcStream for tcp socket:
  Result:=MakeNetSvc(Svc,phs,0);
end;

function MakeUdpSvc(var Svc: INetSvcStream; phs: PSocketHandle): Boolean; //New191029
begin
  // make INetSvcStream for udp socket:
  Result:=MakeNetSvc(Svc,phs,1);
end;

type
  TSockMakeSvcFunc=function(var Svc: INetSvcStream; phs: PSocketHandle): Boolean; //New191029
  
  PSocketFlags=^TSocketFlags;
  TSocketFlags=record
    af:            integer; // AF_INET ~ AF_INET6?
    struct:        integer; // SOCK_STREAM  ~ SOCK_DGRAM ~ SOCK_RAW
    proto:         integer; // IPPROTO_TCP  ~ IPPROTO_UDP
    MakeSvc:       TSockMakeSvcFunc; //New191029 -- specific function make INetSvcStream object...
  end;

function TcpSocketFlags(): PSocketFlags;
asm
  mov  eax,offset @Flags
  ret
  nop
  nop
@Flags:
  dd AF_INET,SOCK_STREAM,IPPROTO_TCP
  dd MakeTcpSvc //New191029
end;

function UdpSocketFlags(): PSocketFlags;
asm
  mov  eax,offset @Flags
  ret
  nop
  nop
@Flags:
  dd AF_INET,SOCK_DGRAM,IPPROTO_UDP
  dd MakeUdpSvc //New191029
end;

function Sock_NeedSocket(Sock: PEvalSocket; bnRecreate: Boolean; Flags: PSocketFlags): Boolean;
var phs: PSocketHandle;
begin
  if bnRecreate
  or (Sock.phSocket=nil)
  or (Sock.phSocket.hSocket=0)
  then begin
    phs:=AllocMem(SizeOf(TSocketHandle));
    phs.Vmt:=Vmt_SocketHandle();
    inc(phs.RefCount); //phs.RefCount:=1;
    FinitIntf(Sock.phSocket);
    Sock.phSocket:=phs;
    //
    if (Flags=nil) then
      Flags:=TcpSocketFlags();
    //
    //phs.hSocket:=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP); //??? configurable
    phs.hSocket:=socket(Flags.af,Flags.struct,Flags.proto);
    if (phs.hSocket=INVALID_HANDLE_VALUE) then begin
      FinitIntf(Sock.phSocket);
      Result:=False;
      exit;
    end;
    //
    if Assigned(Flags.MakeSvc) then begin //New191029
      Flags.MakeSvc(phs.Svc,phs);
    end;
    //
  end;
  Result:=True;
end;

type
  PSockOptDef=^TSockOptDef;
    TApplySockDefProc=function(hSock: THandle; const Value: Variant; Param: Pointer): Boolean;
  TSockOptDef=record
    Name:          String8;
    Apply:         TApplySockDefProc;
    Param:         Pointer;
  end;

function ApplySockDef_Bool(hSock: THandle; const Value: Variant; Param: Pointer): Boolean; forward;
function ApplySockDef_Linger(hSock: THandle; const Value: Variant; Param: Pointer): Boolean; forward;
function ApplySockDef_Int(hSock: THandle; const Value: Variant; Param: Pointer): Boolean; forward;
function ApplySockDef_Blocking(hSock: THandle; const Value: Variant; Param: Pointer): Boolean; forward;

const
  SockOpts: array[0..8] of TSockOptDef=(
    (Name: 'KeepAlive'; Apply: ApplySockDef_Bool; Param: Pointer(SO_KEEPALIVE or (SOL_SOCKET shl 16))),
    (Name: 'Linger'; Apply: ApplySockDef_Linger),
    (Name: 'ReuseAddr'; Apply: ApplySockDef_Bool; Param: Pointer(SO_REUSEADDR or (SOL_SOCKET shl 16))),
    (Name: 'SndBuf'; Apply: ApplySockDef_Int; Param: Pointer(SO_SNDBUF or (SOL_SOCKET shl 16))),
    (Name: 'RcvBuf'; Apply: ApplySockDef_Int; Param: Pointer(SO_RCVBUF or (SOL_SOCKET shl 16))),
    (Name: 'NoDelay'; Apply: ApplySockDef_Bool; Param: Pointer(TCP_NODELAY or (IPPROTO_TCP shl 16))),
    (Name: 'Blocking'; Apply: ApplySockDef_Blocking),
    (Name: 'NonBlocking'; Apply: ApplySockDef_Blocking; Param: Pointer(1)),
    (Name: 'Broadcast'; Apply: ApplySockDef_Int; Param: Pointer(SO_BROADCAST or (SOL_SOCKET shl 16))) //New191102
  );

function ApplySockDef_Bool(hSock: THandle; const Value: Variant; Param: Pointer): Boolean;
var iValue: Longint;
    bn: Boolean;
begin
  if EvalVarToBool(Value,bn) then begin
    iValue:=ord(bn);
    Result:=(SetSockOpt(hSock,Cardinal(Param) shr 16,Cardinal(Param) and $FFFF,@iValue,4)=0);
  end else
    Result:=False;
end;

function ApplySockDef_Linger(hSock: THandle; const Value: Variant; Param: Pointer): Boolean;
var Linger: TLinger;
    vt,opt,int,sz: integer;
    bn: Boolean;
Label _Apply;
begin
  Result:=False;
  vt:=TdwVarData(Value).dwType and varTypeMask;
  //
  ZeroMem(@Linger,SizeOf(Linger));
  sz:=SizeOf(Linger);
  opt:=SO_LINGER;
  if (vt=varBoolean) then begin
    // Linger: true -- unspecified timeout
    // Linger: false -- switch off
    if EvalVarToBool(Value,bn) then begin
      if bn then begin
        opt:=SO_DONTLINGER; // switch that off, same as setting SO_LINGER, delay by implementation...
        sz:=4;
      end else begin
        // already SO_LINGER,l_onoff=0
      end;
      goto _Apply;
    end;
  end else
  if (vt in [varSmallint..varCurrency,$10..$14]) then begin
    if EvalVarToInt(Value,int) then begin
      if (int>=0) then begin
        Linger.l_onoff:=1;
        Linger.l_linger:=int;
      end;
    _Apply:
      SetSockOpt(hSock,SOL_SOCKET,opt,@Linger,sz);
    end;
  end;
end;

function ApplySockDef_Int(hSock: THandle; const Value: Variant; Param: Pointer): Boolean;
var iValue: Longint;
begin
  if EvalVarToInt(Value,iValue) then begin
    Result:=(SetSockOpt(hSock,Cardinal(Param) shr 16,Cardinal(Param) and $FFFF,@iValue,4)=0);
  end else
    Result:=False;
end;

function ApplySockDef_Blocking(hSock: THandle; const Value: Variant; Param: Pointer): Boolean;
var bn: Boolean;
    iValue: Longint;
begin
  // Sock.Blocking:=false    -- FIONBIO 0... (Param=nil)
  // Sock.NonBlocking:=true  -- FIONBIO 1... (Param<>nil)
  if EvalVarToBool(Value,bn) then begin
    iValue:=ord(bn xor (Param=nil)); //iValue:=ord((not bn) xor (Param<>nil));
    Result:=(ioctlsocket(hSock,FIONBIO,iValue)=0);
  end else
    Result:=False;
end;

procedure ApplySockOpts(Params: PObjCallParams);
var Sock: PEvalSocket;
    i: integer;
    bnHandled: Boolean;
begin
  Sock:=Params.Self;
  if (Sock.Props<>nil)
  and (Sock.phSocket<>nil) and (Sock.phSocket.hSocket<>0)
  and NplGet(Sock.Props,'Options',Variant(Params.TempVar),nil,QiUnk(IUnknown(Sock)),@bnHandled)
  and EvalVarToObj(Variant(Params.TempVar),Params.TempObj)
  then begin
    //*  Socket.Options:={...};
    for i:=0 to High(SockOpts) do begin
      if (SockOpts[i].Name<>'')
      and Params.TempObj.GetProp(SockOpts[i].Name,Variant(Params.TempVar),nil)
      and (Params.TempVar.VType>varNull)
      then begin
        if Assigned(SockOpts[i].Apply) then
          SockOpts[i].Apply(Sock.phSocket.hSocket,Variant(Params.TempVar),SockOpts[i].Param);
      end;
    end;
  end;
end;

function Sock_SetOptions(Params: PObjPropParams): Boolean;
begin
  //* Socket.Options:={KeepAlive,Linger,ReuseAddr,SndBuf,RcvBuf,NoDelay,Blocking,NonBlocking,Broadcast}
  Result:=False;
  if (PVarData(Params.lpValue).VType<=varNull) then begin
    if (PEvalSocket(Params.Self).Props<>nil) then
      NplRemove(PEvalSocket(Params.Self).Props,'Options');
    Result:=True;
  end else
  if NplPut(PEvalSocket(Params.Self).Props,'Options',Params.lpValue^,Params.IndexArg,QiUnk(IUnknown(Params.Self))) then begin
    ApplySockOpts(PObjCallParams(Params));
  end;
end;

function Sock_GetIsBlocking(Params: PObjCallParams): Boolean;
begin
  //* Socket.Blocking -- returns boolean, default true...
  Params.bnNullRes:=True; //!!! how to determine?
  Result:=True;
end;

function Sock_SetIsBlocking(Params: PObjPropParams): Boolean;
var bn: Boolean;
    iValue: Longint;
begin
  //* Socket.Blocking:= -- boolean, default true...
  Result:=False;
  if (PVarData(Params.lpValue).VType>varNull)
  and EvalVarToBool(Params.lpValue^,bn)
  and ( (PEvalSocket(Params.Self).phSocket<>nil) or Sock_NeedSocket(Params.Self,False,nil) )
  then begin
    iValue:=ord(not bn);
    Result:=(ioctlsocket(PEvalSocket(Params.Self).phSocket.hSocket,FIONBIO,iValue)=0);
  end;
end;

function Sock_EventSelect(Params: PObjCallParams): Boolean;
var hEvent: THandle;
    qw: LARGE_INTEGER;
    lEvents: Longint;
Label _Retry;
begin
  //* Sock.EventSelect(hEvent,lEvents) -- for hEvent object gets hEvent.Handle
  //* -- enables non-blocking mode...
  //* -- lEvents : FD_READ=1,FD_WRITE=2,FD_OOB=4,FD_ACCEPT=8,FD_CONNECT=$10,FD_CLOSE=$20
  Result:=False;
  if EvaluateNode(Variant(Params.TempVar),Params.Args) then begin
    hEvent:=0;
  _Retry:
    if (Params.TempVar.VType>varNull) then begin
      if (Params.TempVar.VType in [varFuncNode,varOleStr,$E,$F,varSingle,varDouble,varDate])
      or (Params.TempVar.VType=varString)
      then
        exit
      else
      if (Params.TempVar.VType=varUnknown) then begin
        if EvalVarToObj(Variant(Params.TempVar),Params.TempObj)
        and ( GetObjProp(Params.TempObj,'Handle',Variant(Params.TempVar),nil)
            or (
              EvalIntfToVar(Params.TempObj,Variant(Params.TempVar))
              and
              EvalVarObjToBaseType(Variant(Params.TempVar),Variant(Params.TempVar))
            ))
        then
          goto _Retry;
        exit;
      end else
      if EvalVarToInt64(Variant(Params.TempVar),qw.QuadPart) then begin
        hEvent:=qw.LowPart;
      end else
        exit;
    end;
    //
    if EvalNodeInt(Params.Args.Next,lEvents) then begin
      //
      if ((PEvalSocket(Params.Self).phSocket<>nil) or Sock_NeedSocket(Params.Self,False,nil)) then begin
        Result:=(WsaEventSelect(PEvalSocket(Params.Self).phSocket.hSocket,hEvent,lEvents and $3F)=0);
      end;
      Ocp_RetBool(Params,Result);
      Result:=True;
    end;
  end;
end;

function Sock_Connect(Params: PObjCallParams): Boolean;
var Addr: TSockAddrIn;
    Sock: PEvalSocket;
    phs: PSocketHandle;
    Timeout,AddrSize: Longint;
    Flags: TSocketFlags;
Label _Fail;
begin
  //* Socket.Connect(Ip,Port,?Timeout)
  //* Socket.Connect('Ip:Port',?Timeout)
  Result:=False;
  Sock:=Params.Self;
  if (Sock.phSocket<>nil) // ~ Sock.bnConnected
  or (Sock.LastError<>0)
  then begin
    EvalHResultToVar(Params.lpResVar^,TYPE_E_INVALIDSTATE); // = HRESULT($80028029);
    Result:=True;
    exit;
  end;
  //
  //New191117
  ZeroMem(@Addr,SizeOf(Addr));
  if (Sock.PeerAddress<>nil) then
    Addr:=TSockAddrIn(Sock.PeerAddress^);
  //
  //New191029
  Flags:=(TcpSocketFlags())^; //!!! tcp~udp, ipv4~ipv6
  //
  if Eval_IpAddress(Params,@Addr,(Sock.PeerAddress=nil) or (PSockAddr(Sock.PeerAddress).sin_port=0)) then begin
    ReAllocMem(Sock.PeerAddress,SizeOf(TSockAddrIn));
    PSockAddrIn(Sock.PeerAddress)^:=Addr;
    //
    Timeout:=Sock.Timeout;
    if (Params.Args<>nil) then begin
      if not EvalNodeInt(Params.Args,Timeout) then
        exit;
      Params.Args:=Params.Args.Next;
    end;
    //
    // Create socket:
    //!!! tcp~udp, ipv4 ~ ipv6?
    if not Sock_NeedSocket(Sock,True,@Flags) then begin
      goto _Fail;
    end;
    phs:=Sock.phSocket;
    //
    ApplySockOpts(Params);
    //
    // possibly bind local port:
    if (Sock.MyAddress<>nil) then
      if (bind(phs.hSocket,PSockAddr(Sock.MyAddress)^,SizeOf(TSockAddrIn))<0) then begin
      _Fail:
        Sock.LastError:=ApiError(); //x191030: Sock.LastError:=GetLastError(); if (Sock.LastError=0) then Sock.LastError:=STG_E_ABNORMALAPIEXIT; // 800300FA
        EvalHResultToVar(Params.lpResVar^,Sock.LastError);
        Result:=True;
        exit;
      end;
    // Connect now:
    if (Timeout>0) then begin
      // Connect in other thread, wait Timeout and possibly cancel by CloseSocket :
      // or non-blocking socket + EventSelect, turn FIONBIO later...
      //!!!
    end;
    // connect without timeout:
    if (connect(Sock.phSocket.hSocket,PSockAddr(Sock.PeerAddress)^,SizeOf(TSockAddrIn))<0) then
      goto _Fail;
    //
    //New191102 - get MyAddress
    if (Sock.MyAddress=nil) then
      Sock.MyAddress:=AllocMem(SizeOf(TSockAddrIn));
    AddrSize:=SizeOf(TSockAddrIn);
    getsockname(Sock.phSocket.hSocket,PSockAddr(Sock.MyAddress)^,AddrSize);
    //
    // Create streams:
    Result:=Sock_MakeStreams(Sock);
    if not Result then
      exit;
    //
    Result:=Ocpi_RetSelf(Params);
  end;
end;

function AllocSockAddr(): PSockAddr;
begin
  Result:=AllocMem(SizeOf(TSockAddrIn));
  Result.sin_family:=AF_INET;
end;

function Sock_CreateParams(Params: PObjCallParams): Boolean;
var Int: Longint;
    Sock: PEvalSocket;
    Args: PEvalNode;
    bnProto,bnOpts: Boolean;
Label _Ok,_Fail;
begin
  //* new Socket
  //* new Socket(Port,?proto,?{opt:value})
  if (Params.Args<>nil) then begin
    Int:=-1;
    Sock:=Params.Self;
    Args:=Params.Args;
    if (Sock.phSocket<>nil)
    or not EvalNodeInt_Optional(Args,Int)
    then begin
    _Fail:
      Result:=False;
      exit;
    end;
    if (Args<>nil) then
      Args:=Args.Next;
    //!!!TODO191030 - use Eval_IpAddress ... (not only Port...)
    //New191030
    bnProto:=False;
    bnOpts:=False;
    if (Args<>nil) then begin
      if not EvalNodeStr8(Args,Params.TempStr1) then begin
        Result:=False;
        exit;
      end;
      Args:=Args.Next;
      bnProto:=True;
      //
      if (Args<>nil) then begin
        if not EvalNodeObjOrNull(Args,Params.TempObj,nil) then begin
          Result:=False;
          exit;
        end;
        bnOpts:=True;
      end;
      //
    end;
    FinitIntf(Sock.phSocket);
    //
    //New191030
    if (Sock.MyAddress=nil) then begin
      if (Int<=0) and not bnProto then
        goto _Ok;
      Sock.MyAddress:=AllocSockAddr();
    end;
    if bnOpts and (Params.TempObj<>nil) then begin
      EvalIntfToVar(Params.TempObj,Variant(Params.TempVar));
      IEvalObj(Sock).SetProp('Options',Variant(Params.TempVar),nil);
    end;
    //
    if (Int<=0) then begin
      //x191030 if (Sock.MyAddress=nil) then begin goto _Ok; end;
      PSockAddr(Sock.MyAddress).sin_port:=0;
    end else begin
      if (Int>=65535) then
        goto _Fail;
      //x191030: if (Sock.MyAddress=nil) then begin Sock.MyAddress:=AllocSockAddr(); end;
      PSockAddr(Sock.MyAddress).sin_port:=WSwap(Int);
    end;
    //
    //
    //New191030
    if bnProto then begin
      if SameText(Params.TempStr1,'udp') then begin
        Sock.bnUdp:=Sock_NeedSocket(Sock,True,UdpSocketFlags());
        if Sock.bnUdp then begin
          //
          Int:=1;
          setsockopt(Sock.phSocket.hSocket,SOL_SOCKET,SO_REUSEADDR,@Int,1);
          //
          ApplySockOpts(Params);
          if (Sock.MyAddress<>nil) and (PSockAddr(Sock.MyAddress).sin_port<>0) then begin
            // bind the socket automatically:
            if (bind(Sock.phSocket.hSocket,PSockAddr(Sock.MyAddress)^,SizeOf(TSockAddrIn))<0) then begin
              EvalHResultToVar(Params.lpResVar^,ApiError());
              Result:=True;
              exit;
            end;
            //
            Sock_MakeStreams(Sock);
            //
          end;
        end;
      end else
      if SameText(Params.TempStr1,'udp6') then begin
        //!!!Sock_NeedSocket(Sock,True,)
      end;
    end;
    //
  end;
  //
_Ok:
  Result:=Ocpi_RetSelf(Params);
end;

function Sock_Listen2(Params: PObjCallParams; bnListen: Boolean): Boolean;
var Port,Int: integer;
    Sock: PEvalSocket;
    Args: PEvalNode;
    Flags: PSocketFlags;
Label _Fail;
begin
  //* Socket.Listen(?Port,?Protocol)  Socket.Listen(123,'tcp') -- starts Listen
  //* Socket.Bind(?Port,?Protocol)    Socket.Bind(123,'tcp')   -- just Bind, does not start Listen
  Result:=False;
  Port:=0;
  if (PEvalSocket(Params.Self).MyAddress<>nil) then
    Port:=WSwap(PSockAddr(PEvalSocket(Params.Self).MyAddress).sin_port);
  Args:=Params.Args;
  if not EvalNodeInt_Optional(Args,Port) then
    exit;
  if (Args<>nil) then
    Args:=Args.Next;
  if (Port<=0) or (Port>=65535) then begin
    EvalHResultToVar(Params.lpResVar^,E_INVALIDARG);
    Result:=True;
    exit;
  end;
  //
  Sock:=PEvalSocket(Params.Self);
  if (Sock.MyAddress=nil) then begin
    Sock.MyAddress:=AllocSockAddr();
  end;
  PSockAddr(Sock.MyAddress).sin_port:=WSwap(Port);
  //
  if not Sock.bnUdp then
    Flags:=TcpSocketFlags()
  else
    Flags:=UdpSocketFlags();
  //
  //!!! tcp~udp, ipv4~ipv6 ?
  if (Args<>nil) then begin
    //New191029
    if not EvalNodeStr8(Args,Params.TempStr1) then
      exit;
    if (Params.TempStr1<>'') then begin
      if SameText(Params.TempStr1,'tcp') then begin
        Flags:=TcpSocketFlags();
        Sock.bnUdp:=False;
      end else
      if SameText(Params.TempStr1,'udp') then begin
        Flags:=UdpSocketFlags();
        Sock.bnUdp:=True;
        bnListen:=False;
      end else
      //!!! 'tcp6', 'udp6' ...
    end;
  end;
  //
  if not Sock_NeedSocket(Sock,True,Flags) then begin
  _Fail:
    Sock.LastError:=ApiError(); //x191030: Sock.LastError:=GetLastError(); if (Sock.LastError=0) then Sock.LastError:=STG_E_ABNORMALAPIEXIT; // 800300FA
    SetVarNull(Params.lpResVar^);
    Result:=True;
    exit;
  end;
  //
  Int:=1;
  setsockopt(Sock.phSocket.hSocket,SOL_SOCKET,SO_REUSEADDR,@Int,1);
  //
  ApplySockOpts(Params); //New191021 may override SO_REUSEADDR ...
  //
  if (bind(Sock.phSocket.hSocket,TSockAddrIn(Sock.MyAddress^),SizeOf(TSockAddrIn))<0) then
    goto _Fail;
  //
  if bnListen and (listen(Sock.phSocket.hSocket,4)<0) then
    goto _Fail;
  //
  //New191030
  if Sock.bnUdp then
    Sock_MakeStreams(Sock);
  //
  Result:=Ocpi_RetSelf(Params);
end;

function Sock_Listen(Params: PObjCallParams): Boolean; //zmena191030 contents moved...
asm
  mov dl,1
  jmp Sock_Listen2
end;

function Sock_Bind(Params: PObjCallParams): Boolean; //New191030
asm
  xor edx,edx
  jmp Sock_Listen2
end;

function Eval_CreateSocket(Arg: Pointer; out Obj: IEvalObj; Params: PEvalNode): Boolean; forward;

function Sock_Accept(Params: PObjCallParams): Boolean;
var Addr: TSockAddrIn;
    Srv,Cli: PEvalSocket;
    Timeout,AddrSize: Longint;
    hCliSock: THandle;
    ECode: HResult;
    phs: PSocketHandle;
Label _Fail;
begin
  //* Socket.Accept(?Timeout) -- on server socket, accept client, returns socket object
  //* Socket.Accept
  //* -- !!!TODO: Socket.Accept(0,OnConnect) -- async... -- not implemented yet
  Result:=False;
  Srv:=Params.Self;
  Timeout:=Srv.Timeout;
  //
  if (Srv.phSocket=nil)
  or (Srv.phSocket.hSocket=0)
  then begin
    EvalHResultToVar(Params.lpResVar^,E_INVALIDARG);
    Result:=True;
    exit;
  end;
  //
  if (Params.Args=nil)
  or EvalNodeInt_Optional(Params.Args,Timeout)
  then begin
    //!!!Timeout? (accept in other thread?)
    //
    AddrSize:=SizeOf(Addr);
    hCliSock:=accept(Srv.phSocket.hSocket,@Addr,@AddrSize);
    if (hCliSock=INVALID_HANDLE_VALUE) then begin
    _Fail:
      ECode:=ApiError(); //x191030: ECode:=GetLastError(); if (ECode=0) then ECode:=STG_E_ABNORMALAPIEXIT; // 800300FA
      EvalHResultToVar(Params.lpResVar^,ECode);
      Result:=True;
      exit;
    end;
    //
    // Create Client socket:
    Eval_CreateSocket(nil,Params.TempObj,nil);
    Cli:=Pointer(Params.TempObj);
    //
    Cli.PeerAddress:=AllocSockAddr(); //ReAllocMem(Cli.PeerAddress,SizeOf(TSockAddrIn));
    PSockAddr(Cli.PeerAddress)^:=Addr;
    //
    phs:=AllocMem(SizeOf(TSocketHandle));
    phs.Vmt:=Vmt_SocketHandle();
    inc(phs.RefCount);
    phs.hSocket:=hCliSock;
    Cli.phSocket:=phs;
    MakeTcpSvc(phs.Svc,phs); //New191029
    //
    Cli.Timeout:=Srv.Timeout;
    Cli.bDefaultSide:=1; // default recv...
    //
    AddrSize:=SizeOf(Addr);
    if (getsockname(phs.hSocket,Addr,AddrSize)>=0) then begin
      ReAllocMem(Cli.MyAddress,SizeOf(TSockAddrIn));
      PSockAddr(Cli.MyAddress)^:=Addr;
    end;
    //
    Sock_MakeStreams(Cli);
    //
    EvalIntfToVar(Params.TempObj,Params.lpResVar^);
    Result:=True;
  end;
end;

function Sock_Disconnect(Params: PObjCallParams): Boolean;
var Sock: PEvalSocket;
    bnImmediate: Boolean;
    phs: PSocketHandle;
    H: THandle;
begin
  //* Socket.Disconnect(?bnImmediate ~ ECode)
  //* Socket.Disconnect
  //* Socket.Close(?bnImmediate ~ ECode) //New191110
  Result:=False;
  SetVarNull(Variant(Params.TempVar));
  if (Params.Args=nil)
  or EvaluateNode(Variant(Params.TempVar),Params.Args)
  then begin
    Sock:=Params.Self;
    bnImmediate:=True;
    if (Params.TempVar.VType=varBoolean) then
      EvalVarToBool(Variant(Params.TempVar),bnImmediate)
    else
      EvalVarToInt(Variant(Params.TempVar),Longint(Sock.LastError));
    //
    if not bnImmediate then begin
      //!!! async shutdown?
    end;
    //
    phs:=Sock.phSocket;
    Sock.phSocket:=phs;
    if (phs<>nil) then begin
      //
      H:=phs.hSocket;
      phs.hSocket:=0;
      //
      if not bnImmediate then
        shutdown(H,SD_BOTH);
      Result:=(CloseSocket(H)>=0);
    end else
      Result:=True;
    SetVarBool(Params.lpResVar^,Result);
    Result:=True;
  end;
end;

function Sock_GetIsConnected(Params: PObjCallParams): Boolean; //New191110
var time: TTimeVal;
    fds: TFdSet;
    Sock: PEvalSocket;
    Code: Longint;
    Buffer: array[0..7] of Byte;
Label _CheckError,_NotConnected,_IsConnected;
begin
  //* Socket.IsConnected -- return true/false ...
  Result:=True;
  //
  Sock:=Params.Self;
  if (Sock.phSocket=nil)
  or (Sock.phSocket.hSocket=0)
  then begin
  _NotConnected:
    SetVarBool(Params.lpResVar^,False);
    exit;
  end;
  //
  time.tv_sec:=0;
  time.tv_usec:=0;
  ZeroMem(@fds,SizeOf(fds));
  FD_SET(Sock.phSocket.hSocket,fds);
  Code:=select(1,@fds,nil,@fds,@time);
  if (Code>0)
  and FD_ISSET(Sock.phSocket.hSocket,fds) //New191117
  then begin
    Code:=Recv(Sock.phSocket.hSocket,Buffer,1,MSG_PEEK);
    if (Code=0) then begin
      // Connection closed...
      if (Sock.LastError=0) then begin
        Code:=GetLastError();
        if (Code=0) then
          Code:=WSAENETRESET;
        Sock.LastError:=Code;
        if (Sock.phSocket<>nil) then
          Sock.phSocket.LastError:=Code;
      end;
      goto _NotConnected;
    end else
    if (Code<0) then begin
      // Socket error...
      goto _CheckError;
    end;
    // is connected...
  _IsConnected:
    SetVarBool(Params.lpResVar^,True);
  end else
  if (Code<0) then begin
    // Error... Socket handle is bad?
  _CheckError:
    Code:=GetLastError();
    if (Code<>WSAEWOULDBLOCK) and (Sock.LastError=0) then begin
      Sock.LastError:=Code;
      if (Sock.phSocket<>nil) then
        Sock.phSocket.LastError:=Code;
    end;
    if (Code<>0) then
      EvalHResultToVar(Params.lpResVar^,Code)
    else
      SetVarBool(Params.lpResVar^,False);
  end else begin
    //New191117 - socket handle ok, nothing to read...
    goto _IsConnected;
  end;
end;

function Sock_Shutdown(Params: PObjCallParams): Boolean;
var Int: Longint;
    Sock: PEvalSocket;
begin
  //* Socket.Shutdown(?how) // how : 0=SD_RECEIVE, 1=SD_SEND, 2=SD_BOTH (default)
  Result:=False;
  Sock:=Params.Self;
  if (Sock.phSocket=nil) then begin
    Params.bnNullRes:=True;
    Result:=True;
    exit;
  end;
  //
  Int:=SD_BOTH;
  if EvalNodeInt_Optional(Params.Args,Int) then begin
    if (shutdown(Sock.phSocket.hSocket,Int)=0) then
      SetVarBool(Params.lpResVar^,True)
    else
      EvalHResultToVar(Params.lpResVar^,GetLastError());
    Result:=True;
  end;
end;

function Sock_InitSSL(Params: PObjCallParams): Boolean; //New191023
var bnServer,bn: Boolean;
begin
  //* Socket.InitSSL(?bnServer)  -- not implemented yet...
  Result:=False;
  bnServer:=(PEvalSocket(Params.Self).bDefaultSide and 1<>0);
  //
  if (Params.Args<>nil) then begin
    if not EvaluateNode(Variant(Params.TempVar),Params.Args) then
      exit;
    if (Params.TempVar.VType>varNull) then begin
      if not EvalVarToBool(Variant(Params.TempVar),bn) then
        exit;
      bnServer:=bn;
    end;
  end;
  //
  // in Props: SslType, SslCiphers,
  // possibly SslCertFile ~ SslCert, SslKeyFile ~ SslPfx, SslPass ~ SslPassCallback
  //!!!
end;

function SockGetCodePage(Sock: PEvalSocket; var CodePage: Longint): Boolean;
var tv: TVarData;
    Index,Cp: Longint;
begin
  Result:=False;
  if (Sock.Props<>nil)
  and NplHas(Sock.Props,'CodePage',Index)
  then begin
    TdwVarData(tv).dwType:=TdwVarData(tv).dwType and 0;
    if NplGetI(Sock.Props,Index,Variant(tv),nil,QiUnk(IUnknown(Sock))) then begin
      if EvalVarToInt(Variant(tv),Cp) then begin
        CodePage:=Cp;
        Result:=True;
      end;
    end;
  end;
end;

function IsLineTerm(pcBuf: PAnsiChar; BufSize,CodePage: integer; lpTermLen: PByte): Boolean;
begin
  // require #13#10 terminator, but may be ansi 2-byte or unicode 4-byte ...
  if (CodePage<>1200) then begin
    // ansi...
    if (BufSize>=2) then begin
      dec(BufSize);
      if (pcBuf[BufSize]=#10) then begin
        dec(BufSize);
        if (pcBuf[BufSize]=#13) then begin
          if (lpTermLen<>nil) then
            lpTermLen^:=2;
          Result:=True;
          exit;
        end;
      end;
    end;
  end else begin
    // unicode...
    if (BufSize>=4) then begin
      dec(BufSize);
      if (pcBuf[BufSize-1]=#10) and (pcBuf[BufSize]=#0) then begin
        dec(BufSize,2);
        if (pcBuf[BufSize-1]=#13) and (pcBuf[BufSize]=#0) then begin
          if (lpTermLen<>nil) then
            lpTermLen^:=4;
          Result:=True;
          exit;
        end;
      end;
    end;
  end;
  Result:=False;
end;

function IsNiceText(const S: String8): Boolean;
var pc,pe: PChar8;
begin
  pc:=Pointer(S);
  pe:=@pc[Length(S)];
  while (pc<pe) do begin
    if (pc^ in [' '..#$7E]) then begin
      inc(pc);
    end else begin
      Result:=False;
      exit;
    end;
  end;
  Result:=True;
end;

procedure RecvAppendBuf(Params: PObjCallParams; pcBuf: Pointer; LenBuf: integer);
begin
  if (LenBuf>0) then begin
    SetString(Params.TempStr1,PChar8(pcBuf),LenBuf);
    if (Params.TempStr2='') then
      Params.TempStr2:=Params.TempStr1
    else
      AppendStr(Params.TempStr2,Params.TempStr1); //!!! could use TStringList for Parts...
    Params.TempStr1:='';
  end;
end;

function Sock_FlushSend(Params: PObjCallParams; lpSentSize: PInt64): Boolean;
var pc,pe: PAnsiChar;
    nWritten: Longint;
    ECode: HResult;
Label _Fail;
begin
  // in Params.TempStr2 is buffer to send...
  pc:=Pointer(Params.TempStr2);
  pe:=@pc[Length(Params.TempStr2)];
  while (pc<pe) and (PEvalSocket(Params.Self).LastError=0) do begin
    nWritten:=0;
    ECode:=PEvalSocket(Params.Self).SendStream.Write(pc,pe-pc,@nWritten);
    if (ECode<>0) then begin
    _Fail:
      if (PEvalSocket(Params.Self).LastError=0) then
        PEvalSocket(Params.Self).LastError:=ECode;
      break;
    end;
    if (nWritten<=0) then begin
      ECode:=STG_E_ABNORMALAPIEXIT; // 800300FA
      goto _Fail;
    end;
    inc(pc,nWritten);
    inc(lpSentSize^,nWritten);
  end;
  //
  if (pc<pe) then begin
    if (pc<>Pointer(Params.TempStr2)) then
      SetString(Params.TempStr2,pc,pe-pc);
  end else
    Params.TempStr2:='';
  //
  Result:=True;
end;

function Sock_Flush_SendTo(Params: PObjCallParams; Addr: PSockAddr; AddrSize: integer): Boolean; //New191030
var Size: integer;
    ECode: HResult;
begin
  // in Params.TempStr2 is buffer to send...
  if (AddrSize<=0) then begin
    Result:=False;
    exit;
  end;
  //
  // need no connect for UDP socket...
  if (PEvalSocket(Params.Self).SendStream=nil)
  and ((PEvalSocket(Params.Self).phSocket<>nil) or Sock_NeedSocket(Params.Self,False,UdpSocketFlags()))
  and PEvalSocket(Params.Self).bnUdp
  then
    Sock_MakeStreams(Params.Self);
  //
  if (PEvalSocket(Params.Self).SendStream<>nil)
  and (PEvalSocket(Params.Self).SendStream.QueryInterface(guid_INetSvcStream,Params.TempObj2)=0)
  then begin
    Size:=Length(Params.TempStr2);
    ECode:=INetSvcStream(Params.TempObj2).SendTo(Pointer(Params.TempStr2),Size,Addr,AddrSize);
    if (ECode=0) then begin
      SetVarInt(Params.lpResVar^,Size);
      ECode:=0;
    end else
    //if (ECode<>0) then
    begin
      // only permanent error will get into Sock.LastError...
      case ECode of
        WSAENOTSOCK, WSAECONNRESET, WSAECONNABORTED: PEvalSocket(Params.Self).LastError:=ECode;
      end;
    end;
  end else begin
    ECode:=MK_E_NOOBJECT;
  end;
  //
  if (ECode<>0) then begin
    EvalHResultToVar(Params.lpResVar^,ECode);
  end;
  Result:=True;
end;

function Sock_INetSocket_Send(Helper: PEvalGenHelper; Buffer: Pointer; Size: Longint): Longint; //New200828
var Sock: PEvalSocket;
    nWritten: Longint;
    ECode: HResult;
Label _Error;
begin
  Sock:=Pointer(Helper.Target);
  if (Sock.LastError<>0)
  or (Sock.SendStream=nil)
  then begin
    Result:=-1;
    exit;
  end;
  if (Size<=0) then begin
    Result:=0;
    exit;
  end;
  //
  nWritten:=0;
  ECode:=Sock.SendStream.Write(Buffer,Size,@nWritten);
  if (ECode=0) then begin
    if (nWritten<=0) then begin
      ECode:=STG_E_ABNORMALAPIEXIT; // 800300FA
      goto _Error;
    end;
    Result:=nWritten;
    //exit;
  end else begin
  _Error:
    if (Sock.LastError=0) then
      Sock.LastError:=ECode;
    Result:=0;
  end;
end;

function Sock_INetSocket_Recv(Helper: PEvalGenHelper; Buffer: Pointer; Size: Longint): Longint; //New200828
var Sock: PEvalSocket;
    nRead: Longint;
    ECode: HResult;
begin
  Sock:=Pointer(Helper.Target);
  if (Sock.LastError<>0)
  or (Sock.RecvStream=nil)
  then begin
    Result:=-1;
    exit;
  end;
  //
  nRead:=0;
  ECode:=Sock.RecvStream.Read(Buffer,Size,@nRead);
  if (ECode=0) then begin
    if (nRead=0) then begin
      // EOF...
      if (Sock.LastError=0) then
        Sock.LastError:=WSAECONNRESET;
      Result:=0;
      exit;
    end;
    Result:=nRead;
  end else begin
    Sock.LastError:=ECode;
    Result:=-1;
  end;
end;

function Sock_Recv2(Params: PObjCallParams; Op: Byte): Boolean;
var Size,CodePage,This,nRead,CharSize,nLastChar,PeekSize: Longint;
    Sock: PEvalSocket;
    Args: PEvalNode;
    ECode: HResult;
    pcText,peText,pbLastChar,p0Text: PAnsiChar;
    bnExact: Boolean;
    bLenLineEnd: Byte;
    Buffer: array[0..4095] of Byte;
Label _Done,_NullOk,_ErrOk,_RecvDone;
begin
  //* Socket.Recv(?Size,?bnExact) -- returns BinString, may receive less than Size, with bnExact=true waits for whole Size...
  //* Socket.RecvLine(?MaxSize) -- uses CodePage if set, default Ansi...
  //*                           -- waits for full line terminated by #13#10, does not return #13#10 in result...
  //* Socket.RecvText(?Size,?bnExact) -- returns String, uses CodePage if set, default Ansi...
  //* Socket.ReadInt(?Size=4) -- returns integer, waits for full Size...
  // Op: 0=Recv, 1=RecvLine, 2=RecvText, 3=ReadInt
  //
  //* -- (for RecvLine now must read 1-char at a time, no buffer, after last char may switch to stream copy...)
  //* -- (cannot have buffer in Stream either, may share socket handle in multiple read-streams by clone...)
  //
  Result:=False;
  bnExact:=False;
  Size:=-1;
  if (Params.Args=nil)
  or EvalNodeInt_Optional(Params.Args,Size)
  then begin
    if (Params.Args<>nil) then begin
      Args:=Params.Args.Next;
      if (Args<>nil) then begin
        if not EvalNodeBool(Args,bnExact) then
          exit;
      end;
    end;
    //
    Sock:=Params.Self;
    if (Sock.RecvStream=nil) then begin
      // EvalHResultToVar returns boolean False, but script can ask HResult() from it...
      EvalHResultToVar(Params.lpResVar^,CO_E_OBJNOTCONNECTED); // 800401FD
      Result:=True;
      exit;
    end;
    //
    if (Size<=0) then begin
      case Op of
        0,4: Size:=4096;
        1,2: Size:=1 shl 20; // limit RecvLine without MaxSize on 1Mb...
        3: Size:=4; // default Socket.ReadInt() reads 4-byte integer
      end;
    end else
    if (Op=3) and (Size>8) then begin
      Result:=False; // script error...
      exit;
    end;
    if (Op=3) then
      bnExact:=True;
    //
    CodePage:=0;
    CharSize:=1;
    if (Op in [1,2]) then begin
      // if (Sock.Props<>nil)
      // //and NplGet(Sock.Props,'CodePage',Variant(Params.TempVar),nil,nil,nil) //and NplGet(Sock.Props,'CodePage',Variant(Params.TempVar),nil,QiUnk(IUnknown(Sock)),nil)
      // and NplHas(Sock.Props,'CodePage',Index) // NplHas is faster, if we do not expect having it set...
      // and NplGetI(Sock.Props,Index,Variant(Params.TempVar),nil,nil)
      // then begin
      //   if EvalVarToInt(Variant(Params.TempVar),CodePage) then begin
      //     if (CodePage=1200) then
      //       inc(CharSize); //CharSize:=2;
      //   end;
      // end;
      if SockGetCodePage(Sock,CodePage) then begin
        if (CodePage=1200) then
          inc(CharSize); // CharSize:=2;
      end;
    end;
    //
    if (Op=4) then begin //New191029
      // Peek at incoming data, keep them in buffer:
      // MSG_PEEK for recv(), how to get that through streams ?! is it supported by SSL ?
      // using INetSvcStream.PeekData if supported:
      if (Sock.phSocket<>nil)
      and (Sock.phSocket.Svc<>nil)
      then begin
        if (Size>SizeOf(Buffer)) then
          Size:=SizeOf(Buffer);
        PeekSize:=Size;
        ECode:=Sock.phSocket.Svc.PeekData(@Buffer,PeekSize);
        if (ECode=0) then begin
          RecvAppendBuf(Params,@Buffer,PeekSize);
          goto _RecvDone;
        end;
      end else
        ECode:=WSAEOPNOTSUPP;
      //
      goto _ErrOk;
    end;
    //
    Params.TempStr2:='';
    if (Op=1) then begin
      //* -- RecvLine - read 1 char at time, must not read any byte more...
      //* -- !!!TODO191029 - use MSG_PEEK to see, how far is #13#10 in stream...
      pcText:=@Buffer[16];
      p0Text:=pcText;
      peText:=@Buffer[SizeOf(Buffer)-16];
      pbLastChar:=@Buffer[SizeOf(Buffer)-12];
      nLastChar:=0;
      bLenLineEnd:=0;
      //
      while (Size>0) do begin
        nRead:=0;
        ECode:=Sock.RecvStream.Read(pcText,CharSize,@nRead);
        if (ECode=0) then begin
          // with CharSize=2, may receive 1 byte and get all following chars mis-aligned...
          This:=nRead;
          if (This=0) then begin
            // EOF...
            if (Sock.LastError=0) then
              Sock.LastError:=WSAECONNRESET;
            if (pcText>p0Text) or (Params.TempStr2<>'') then
              goto _Done
            else
              goto _NullOk;
          end;
          //
          repeat
            if (nLastChar>=4) then begin
              PLongint(pbLastChar)^:=PLongint(pbLastChar+1)^;
              pbLastChar[3]:=pcText^;
            end else begin
              pbLastChar[nLastChar]:=pcText^;
              inc(nLastChar);
            end;
            inc(pcText);
            dec(This);
          until (This<=0);
          //
          if IsLineTerm(pbLastChar,nLastChar,CodePage,@bLenLineEnd) then begin
            // will remove line-term from buffer
            // but part of line-term may already be in TempStr2 buffer...
            while (bLenLineEnd>0) and (pcText>p0Text) do begin
              dec(bLenLineEnd);
              dec(pcText);
            end;
            if (bLenLineEnd>0) and (pcText=p0Text) then begin
              Size:=Length(Params.TempStr2)-bLenLineEnd;
              if (Size<0) then Size:=0;
              SetLength(Params.TempStr2,Size);
            end;
            //ECode:=0;
          _Done:
            if (pcText>p0Text) then begin
              RecvAppendBuf(Params,p0Text,pcText-p0Text);
            end;
            EvalCpToVar(Params.lpResVar^,Params.TempStr2,CodePage);
            Result:=True;
            exit;
          end;
          //
          if (peText-pcText<16) then begin
            RecvAppendBuf(Params,p0Text,pcText-p0Text);
            pcText:=p0Text;
          end;
          //
        end else begin
          // Error...
          Sock.LastError:=ECode;
          if (pcText>p0Text) or (Params.TempStr2<>'') then
            goto _Done;
        _ErrOk:
          EvalHResultToVar(Params.lpResVar^,ECode);
          Result:=True;
          exit;
        end;
      end;
      // MaxSize limit exceeded... fail...? or return what received...
      if (pcText>p0Text) or (Params.TempStr2<>'') then
        goto _Done;
    _NullOk:
      SetVarNull(Params.lpResVar^);
      Result:=True;
      exit;
      //
    end;
    // Other reads:
    while (Size>0) do begin
      This:=SizeOf(Buffer);
      if (This>Size) then
        This:=Size;
      ECode:=Sock.RecvStream.Read(@Buffer,This,@nRead);
      if (ECode=0) then begin
        if (nRead=0) then begin
          // EOF...
          if (Sock.LastError=0) then
            Sock.LastError:=WSAECONNRESET;
          break;
        end;
        //
        dec(Size,nRead);
        //
        RecvAppendBuf(Params,@Buffer,nRead);
        //
        // without bnExact, return just first received part...
        if not bnExact then
          break;
        //
      end else begin
        // Error...
        Sock.LastError:=ECode;
        if (Params.TempStr2='') then
          goto _ErrOk;
        break;
      end;
    end;
  _RecvDone:
    // Return, what received:
    case Op of
      0,4: begin
        // Recv() -- if it is nice ascii text, return normal String, otherwise BinString...
        //if Is7bitA(Pointer(Params.TempStr2),Length(Params.TempStr2)) then
        if IsNiceText(Params.TempStr2) then
          EvalAnsiToVar(Params.lpResVar^,Params.TempStr2)
        else
          EvalBinStringToVar(Params.lpResVar^,Params.TempStr2);
        Result:=True;
      end;
      // 1 - handled above...
      2: begin
        EvalCpToVar(Params.lpResVar^,Params.TempStr2,CodePage);
        Result:=True;
      end;
      3: begin
        // ReadInt
        Size:=Length(Params.TempStr2);
        if (Size=0) then
          goto _NullOk;
        if (Size>8) then
          Size:=8;
        LARGE_INTEGER(Pointer(@Buffer)^).QuadPart:=0;
        Move(Pointer(Params.TempStr2)^,Buffer[0],Size);
        SetVarInt64(Params.lpResVar^,LARGE_INTEGER(Pointer(@Buffer)^).QuadPart);
        Result:=True;
      end;
    end;
  end;
end;

function Sock_Recv(Params: PObjCallParams): Boolean;
asm
  //* Socket.Recv(?Size,?bnExact) -- returns BinString, may receive less than Size, with bnExact=true waits for whole Size...
  mov  dl,0
  jmp  Sock_Recv2
end;

function Sock_RecvLine(Params: PObjCallParams): Boolean;
asm
  //* Socket.RecvLine(?MaxSize) -- uses CodePage if set, default Ansi...
  mov  dl,1
  jmp  Sock_Recv2
end;

function Sock_RecvText(Params: PObjCallParams): Boolean;
asm
  //* Socket.RecvText(?Size,?bnExact) -- returns String, uses CodePage if set, default Ansi...
  mov  dl,2
  jmp  Sock_Recv2
end;

function Sock_ReadInt(Params: PObjCallParams): Boolean;
asm
  //* Socket.ReadInt(?Size=4) -- returns integer, waits for full Size...
  mov  dl,3
  jmp  Sock_Recv2
end;

function Sock_Peek(Params: PObjCallParams): Boolean; //New191029
asm
  //* Socket.Peek(?MaxSize) -- returns BinString, may receive less than Size
  mov  dl,4
  jmp  Sock_Recv2
end;

function EvalIpToStr(af: Word; lpIp: Pointer; Buffer: PChar8; BufSize: integer): integer; //New191102
var TempBuf: array[0..79] of Char8;
    pb: PByte;
    pc,pe,p0: PChar8;
    i,Len: integer;
begin
  if (Buffer=nil) then begin
    Buffer:=@TempBuf;
    BufSize:=SizeOf(TempBuf);
  end;
  //
  case af of
    AF_INET: begin
      pc:=TempBuf;
      p0:=pc;
      pe:=@pc[High(TempBuf)];
      //
      i:=0;
      pb:=lpIp;
      repeat
        if (i>0)
        //and (pc<pe)
        then begin
          pc^:='.';
          inc(pc);
        end;
        pc:=StrEnd(StrLFmt(pc,pe-pc,'%d',[pb^]));
        inc(pb);
        inc(i);
      until (i=4);
      //
      Len:=pc-p0;
      if (Len<=BufSize) then begin
        if (Len<BufSize) then
          Buffer[Len]:=#0;
        Move(p0^,Buffer^,Len);
      end;
      Result:=Len;
    end;
    //AF_INET6: //!!!TODO
    else
      Result:=0;
  end;
end;

function EvalIpToVar(af: Word; lpIp: Pointer; var V: Variant): Boolean; //New191102
var Buffer: array[0..79] of Char8;
    Len: integer;
begin
  Len:=EvalIpToStr(af,lpIp,@Buffer,SizeOf(Buffer));
  if (Len>0) then begin
    EvalPAnsiToVar(V,@Buffer,Len);
    Result:=True;
  end else begin
    SetVarNull(V);
    Result:=False;
  end;
end;

procedure SetAddrToObj(Params: PObjCallParams; Addr: PSockAddr; ASize: integer); //New191030
var Buffer: array[0..31] of Char8;
    pc: PChar8;
    //i: integer;
begin
  if (Params.TempObj<>nil)
  and (Addr<>nil)
  then begin
    //if (Addr.sin_family=AF_INET) then
    begin
      {//x191102:
      pc:=Buffer;
      i:=0;
      repeat
        pc:=StrEnd(StrLFmt(pc,15,'.%d',[PByteArray(@Addr.sin_addr)[i]]));
        inc(i);
      until (i>=4);
      pc:=@Buffer[1];
      {}
      if (EvalIpToStr(Addr.sin_family,@Addr.sin_addr,@Buffer,SizeOf(Buffer))<=0) then
        exit;
      pc:=Buffer;
      //
      EvalPAnsiToVar(Variant(Params.TempVar),pc,StrLen(pc));
      Params.TempObj.SetProp('IP',Variant(Params.TempVar),nil);
      //
      SetVarInt(Variant(Params.TempVar),WSwap(Addr.sin_port));
      Params.TempObj.SetProp('Port',Variant(Params.TempVar),nil);
      //
      if (Addr.sin_port<>0) then begin
        pc:=StrEnd(Buffer);
        StrLFmt(pc,8,':%d',[WSwap(Addr.sin_port)]);
        pc:=Buffer; //x191105: pc:=@Buffer[1];
        EvalPAnsiToVar(Variant(Params.TempVar),pc,StrLen(pc));
        Params.TempObj.SetProp('Address',Variant(Params.TempVar),nil);
      end;
      //
    end;
  end;
end;

function Sock_RecvFrom(Params: PObjCallParams): Boolean; //New191029
var Sock: PEvalSocket;
    ECode: HResult;
    Size,AddrSize: Longint;
    Addr: TSockAddr;
    Buffer: array[0..4095] of char;
Label _ErrOk;
begin
  //* Socket.RecvFrom(outAddr) -- for UDP socket, returns packet BinString,
  //* -- in outAddr object provided by caller returns Client address on return
  //* -- without outAddr object returns new outAddr object with 'Data' property holding received packet...
  Result:=False;
  if EvaluateNode(Variant(Params.TempVar),Params.Args) then begin
    if (Params.TempVar.VType=varUnknown) then begin
      if not EvalVarToObj(Variant(Params.TempVar),Params.TempObj) then
        exit;
    end else
    if (Params.TempVar.VType>varNull) then
      exit;
    //
    Sock:=Params.Self;
    if (Sock.phSocket=nil)
    or (Sock.phSocket.Svc=nil)
    then begin
      ECode:=MK_E_NOOBJECT;
    _ErrOk:
      EvalHResultToVar(Params.lpResVar^,ECode);
      Result:=True;
      exit;
    end;
    //
    Size:=SizeOf(Buffer);
    AddrSize:=SizeOf(Addr);
    //ECode:=Sock.phSocket.Svc.RecvFrom(@Buffer,Size,@Addr,AddrSize);
    // use Sock.RecvStream.QueryInterface instead!
    if (Sock.RecvStream<>nil) then
      ECode:=Sock.RecvStream.QueryInterface(guid_INetSvcStream,Params.TempObj2)
    else
    if (Sock.phSocket<>nil) and (Sock.phSocket.Svc<>nil) then
      ECode:=Sock.phSocket.Svc.QueryInterface(guid_INetSvcStream,Params.TempObj2)
    else
      ECode:=MK_E_NOOBJECT;
    if (ECode=0) then
      ECode:=INetSvcStream(Params.TempObj2).RecvFrom(@Buffer,Size,@Addr,AddrSize);
    if (ECode<>0) then
      goto _ErrOk;
    //
    if (Params.TempObj=nil) then begin
      EvalCreateObject(Params.TempObj);
      EvalIntfToVar(Params.TempObj,Params.lpResVar^);
      SetVarBin(Variant(Params.TempVar),@Buffer,Size);
      Params.TempObj.SetProp('Data',Variant(Params.TempVar),nil);
    end else begin
      SetVarBin(Params.lpResVar^,@Buffer,Size);
    end;
    //
    if (AddrSize>0) then begin
      SetAddrToObj(Params,@Addr,AddrSize);
    end;
    //
    Result:=True;
  end;
end;

{$undef NOT_FINISHED}
{$ifdef NOT_FINISHED}
function StrToSockAddr(const S: String8; Addr: PSockAddr; var AddrSize: integer): Boolean; //New191030
var TempAddr: TSockAddr;
begin
  if (Addr=nil) or (AddrSize<SizeOf(TSockAddr)) then begin
    Addr:=@TempAddr;
  end;
  AddrSize:=SizeOf(TSockAddr);
  // '1.2.3.4', '1.2.3.4:123', 'host.cz:123'
  DnsLookup... see Eval_IpAddress ...
  //!!!
end;

function VarToSockAddr(const V: Variant; Addr: PSockAddr; var AddrSize: integer; bnPortNeeded: Boolean): Boolean; //New191030
var Tmp: Pointer;
    tv: TVarData;
    Int: Longint;
begin
  // can be object { IP: '1.2.3.4', Port: 123 }
  // can be string '1.2.3.4:123'
  // can be ipv6 address ? !!! TODO
  Result:=False;
  case (TVarData(V).VType and varTypeMask) of
    varString,varOleStr: begin
      Tmp:=nil;
      if not EvalVarToStr8(V,String8(Tmp)) then
        exit;
      Result:=StrToSockAddr(PString8(@Tmp)^,Addr,AddrSize);
      FinitStr(Tmp);
      if Result and bnPortNeeded then
        Result:=(Addr.sin_port<>0);
      exit;
    end;
    varUnknown: begin
      Tmp:=nil;
      if not EvalVarToObj(V,IEvalObj(Tmp)) then
        exit;
      //
      TdwVarData(tv).dwType:=TdwVarData(tv).dwType and 0;
      if GetObjProp(IEvalObj(Tmp),'IP',Variant(tv))
      or GetObjProp(IEvalObj(Tmp),'Address',Variant(tv))
      then begin
        Result:=VarToSockAddr(Variant(tv),Addr,AddrSize,False);
        if Result and (Addr.sin_port=0) then begin
          if GetObjProp(IEvalObj(Tmp),'Port',Variant(tv))
          and EvalVarToInt(Variant(tv),Int)
          then
            Addr.sin_port:=WSwap(Int);
        end;
        if bnPortNeeded then
          Result:=(Addr.sin_port<>0)
        else
          Result:=True;
      end;
      //
      FinitObj(IEvalObj(Tmp));
    end;
  end;
end;
{$endif NOT_FINISHED}

const
  aVarBinSizes: array[0..$14] of Byte=
    (0,0,2,4,4,8,8,8,
     0,0,0,2,0,0,0,0,
     1,1,2,4,8
    );

function Sock_Send2(Params: PObjCallParams; Op: Byte): Boolean;
var Args: PEvalNode;
    SentSize,qw1,qw2,qw3: LARGE_INTEGER;
    F: Double;
    Sock: PEvalSocket;
    CodePage,AddrSize: Longint;
    ECode: HResult;
    tv: TVarData;
    Addr: TSockAddr;
    pb: Pointer; pc: PChar8;
    Tmp: Pointer;
    bSize: Byte;
    bnCodePage,bn,bnOk: Boolean;
Label _Append,_RetryParam,_Fail,_Bin,_BinData,_Fail_LastError,_RetSize;
begin
  //* Socket.Send(Data,...) - returns sent size
  //* Socket.SendLine(Line) - returns sent size, appends #13#10 after last part...
  //* Socket.SendTo(Data,Address) - returns sent size, used for UDP...
  // Op: 0=Send, 1=SendLine, 2=SendTo
  SentSize.QuadPart:=0;
  bnCodePage:=False;
  CodePage:=0;
  AddrSize:=0;
  Sock:=Params.Self;
  if (Sock.LastError<>0) then begin
  _Fail_LastError:
    EvalHResultToVar(Params.lpResVar^,Sock.LastError);
    Result:=True;
    exit;
  end;
  Args:=Params.Args;
  Params.TempStr2:='';
  while (Args<>nil) do begin
    if not EvaluateNode(Variant(Params.TempVar),Args) then begin
      Result:=False; // script error...
      exit;
    end;
    Args:=Args.Next;
    //
  _RetryParam:
    case Params.TempVar.VType and varTypeMask of
      0..varNull: ;
      varOleStr,varString: begin
        // CodePage... (default ansi)
        if not bnCodePage then begin
          bnCodePage:=True;
          //if (Sock.Props<>nil)
          //and NplHas(Sock.Props,'CodePage',Index)
          //then begin
          //  TdwVarData(tv).dwType:=TdwVarData(tv).dwType and 0;
          //  if NplGetI(Sock.Props,Index,Variant(tv),nil,nil) then
          //    EvalVarToInt(Variant(tv),CodePage);
          //  SetVarNull(Variant(tv));
          //end;
          SockGetCodePage(Sock,CodePage);
        end;
        EvalVarToStr_CP(Variant(Params.TempVar),Params.TempStr1,CodePage);
      _Append:
        if (Params.TempStr2='') then
          Params.TempStr2:=Params.TempStr1
        else
          AppendStr(Params.TempStr2,Params.TempStr1);
        Params.TempStr1:='';
        //
        if (Length(Params.TempStr2)>=4096) and (Op<>2) then begin
          Result:=Sock_FlushSend(Params,@SentSize.QuadPart);
          if not Result then
            exit;
          if (Sock.LastError<>0) then begin
            if (SentSize.QuadPart=0) then
              goto _Fail_LastError;
            break;
          end;
        end;
      end;
      varUnknown,varDispatch: begin
        if (Op<>2) and (VarQueryInterface(Variant(Params.TempVar),guid_IStream,Params.TempObj2)=0) then begin
          // Send stream:
          Result:=Sock_FlushSend(Params,@SentSize.QuadPart);
          if not Result then
            exit;
          if (Sock.LastError<>0) then begin
            if (SentSize.QuadPart=0) then
              goto _Fail_LastError;
            break;
          end;
          //
          qw1.HighPart:=$10000000;
          qw1.LowPart:=qw1.LowPart and 0;
          //qw2.QuadPart:=0;
          qw3.QuadPart:=0;
          ECode:=IStream(Params.TempObj2).CopyTo(Sock.SendStream,qw1.QuadPart,qw2.QuadPart,qw3.QuadPart);
          inc(SentSize.QuadPart,qw3.QuadPart);
          //
          if (ECode<>0) then begin
            if (SentSize.QuadPart<>0) then
              SetVarInt64(Params.lpResVar^,SentSize.QuadPart)
            else
              EvalHResultToVar(Params.lpResVar^,ECode);
            Result:=True;
            exit;
          end;
        end else begin
          // Byte-array etc...
          //if EvalVarObjToBaseType(Variant(Params.TempVar),Variant(Params.TempVar)) then goto _RetryParam;
        _Bin:
          if EvalVarToBinString(Variant(Params.TempVar),Params.TempStr1) then
            goto _Append;
          // Error...
          goto _Fail;
        end;
      end;
      varFuncNode,$f: begin // =varError
      _Fail:
        Result:=False;
        exit;
      end;
      $e: begin // vt_decimal...
        if EvalVarToDouble(Variant(Params.TempVar),F) then begin
          pb:=@F;
          bSize:=8;
          goto _BinData;
        end else
          goto _Fail;
      end;
      varBoolean: begin
        if EvalVarToBool(Variant(Params.TempVar),bn) then begin
          pb:=@bn;
          bSize:=1;
          goto _BinData;
        end else
          goto _Fail;
      end;
      varSmallint..varDate,$10..$14: begin
        if (Params.TempVar.VType and varByRef=0) then
          pb:=@Params.TempVar.VInteger
        else
          pb:=Params.TempVar.VPointer;
        bSize:=aVarBinSizes[Params.TempVar.VType and $F];
      _BinData:
        SetString(Params.TempStr1,PChar8(pb),bSize);
        goto _Append;
      end;
      varVariant: begin
        if (Params.TempVar.VType=varVariant or varByRef) then begin
          ZeroMem16(@tv);
          VarCopy(Variant(tv),PVariant(Params.TempVar.VPointer)^);
          VarMove(Variant(Params.TempVar),Variant(tv));
          goto _RetryParam;
        end;
        goto _Fail;
      end;
      else goto _Bin; // unknown type...?
    end;
    //New191030
    if (Op=2) then begin
      // SendTo - next param is address...
      AddrSize:=SizeOf(Addr);
      ZeroMem(@Addr,AddrSize);
      Params.Args:=Args;
      // Eval_IpAddress uses both TempStr1 and TempStr2 ...
      Tmp:=nil;
      PString8(@Tmp)^:=Params.TempStr2;
      try
        bnOk:=Eval_IpAddress(Params,@Addr,True);
      finally
        Params.TempStr2:=PString8(@Tmp)^;
        FinitStr(Tmp);
      end;
      if not bnOk then
        goto _Fail;
      //
      {if not EvaluateNode(Variant(Params.TempVar),Args) then
        goto _Fail;
      if not VarToSockAddr(Variant(Params.TempVar),@Addr,AddrSize,True) then
        goto _Fail;
      {}
      break;
    end;
    //
  end;
  //
  if (Sock.LastError=0) and (Op=1) then begin
    // Append line-terminator...
    if not bnCodePage then begin
      //bnCodePage:=True;
      SockGetCodePage(Sock,CodePage);
    end;
    if (CodePage<>1200) then begin
      pc:=#13#10;
      bSize:=2;
    end else begin
      pc:=#13#0#10#0;
      bSize:=4;
    end;
    SetString(Params.TempStr1,pc,bSize);
    AppendStr(Params.TempStr2,Params.TempStr1);
  end;
  //
  if (Op=2) and (Sock.LastError=0) then begin //New191030
    Result:=Sock_Flush_SendTo(Params,@Addr,AddrSize);
    exit;
  end else
  if (Sock.LastError=0) then begin
    // pass to Sock.SendStream.Write()
    Result:=Sock_FlushSend(Params,@SentSize.QuadPart);
    if not Result then
      exit;
  end;
  //
  if (Sock.LastError<>0) then begin
    if (SentSize.QuadPart=0) then
      goto _Fail_LastError
    else
      goto _RetSize;
  end else begin
  _RetSize:
    SetVarInt64(Params.lpResVar^,SentSize.QuadPart);
    Result:=True;
  end;
end;

function Sock_Send(Params: PObjCallParams): Boolean;
asm
  //* Socket.Send(Data,...) - returns sent size
  xor  edx,edx
  jmp  Sock_Send2
end;

function Sock_SendLine(Params: PObjCallParams): Boolean;
asm
  //* Socket.SendLine(Line) - returns sent size, appends #13#10 after last part...
  mov  dl,1
  jmp  Sock_Send2
end;

function Sock_SendTo(Params: PObjCallParams): Boolean; //New191030
asm
  //* Socket.SendTo(Data,Address) -- send UDP packet...
  mov  dl,2
  jmp  Sock_Send2
end;

function Sock_SendStream(Params: PObjCallParams): Boolean;
var Args: PEvalNode;
    MaxSize,qwRead,qwWrite: LARGE_INTEGER;
    ECode: HResult;
begin
  //* Socket.SendStream(SourceStream,?MaxSize)
  Result:=False;
  if EvalNodeObj(Params.Args,Params.TempObj)
  and (Params.TempObj.QueryInterface(guid_IStream,Params.TempObj2)=0)
  then begin
    MaxSize.HighPart:=$10000000;
    Args:=Params.Args.Next;
    if (Args<>nil) then begin
      if not EvalNodeInt64(Args,MaxSize.QuadPart) then
        exit;
    end;
    //
    Result:=True;
    //
    if (PEvalSocket(Params.Self).LastError<>0) then begin
      EvalHResultToVar(Params.lpResVar^,PEvalSocket(Params.Self).LastError);
      exit;
    end;
    //
    //qwRead.QuadPart:=0;
    qwWrite.QuadPart:=0;
    //
    ECode:=IStream(Params.TempObj2).CopyTo(PEvalSocket(Params.Self).SendStream,MaxSize.QuadPart,qwRead.QuadPart,qwWrite.QuadPart);
    if (ECode=0) then
      SetVarInt64(Params.lpResVar^,qwWrite.QuadPart)
    else
      EvalHResultToVar(Params.lpResVar^,ECode);
  end;
end;

function Eval_SockSelect2(Params: PObjCallParams; HandleList,RetObjList: TList): Boolean; //New191030
var Args: PEvalNode;
    idx,Code,i,j,Int: integer;
    Timeout,Capa,Count: Longint;
    ECode: HResult;
    Time: TTimeVal;
    lpTime: PTimeVal;
    Seen: TList;
    pfds: array[0..2] of PFDSet;
    Mem,P: Pointer;
    bns: array[0..3] of Boolean;
    Node: TEvalNode;
    Dt: TDateTime;
Label _ApplyTimeout;
begin
  //* Socket.Select(?read,?write,?except,?timeout) - returns boolean, if set... all sets default true
  //* Socket.Select({read:true,write:false,except:false,timeout:100}) - returns boolean, if set...
  //* -- all sets default false
  //* SockSelect([sockets],?read,?write,?except,?timeout) - returns array of sockets, that are in some set,
  //* -- all sets default true
  //* SockSelect([sockets],{read:true,write:false,except:false,timeout:100}) - returns array of sockets, that are in some set
  //* -- all sets default false
  Result:=False;
  Time.tv_sec:=0;
  Time.tv_usec:=0;
  Timeout:=-1; lpTime:=nil; // default infinite...
  DWORD(bns):=$00010101;
  //
  ZeroMemNode(Node);
  idx:=0;
  Args:=Params.Args;
  while (Args<>nil) do begin
    if not EvaluateNode(Variant(Params.TempVar),Args) then
      exit;
    Args:=Args.Next;
    //
    if (idx=0) and (Params.TempVar.VType=varUnknown) then begin
      if EvalVarToObj(Variant(Params.TempVar),Params.TempObj) then begin
        DWORD(bns):=0; // if some specified, others are false...
        if GetObjProp(Params.TempObj,'read',Variant(Params.TempVar)) then
          EvalVarToBool(Variant(Params.TempVar),bns[0]);
        if GetObjProp(Params.TempObj,'write',Variant(Params.TempVar)) then
          EvalVarToBool(Variant(Params.TempVar),bns[1]);
        if GetObjProp(Params.TempObj,'except',Variant(Params.TempVar)) then
          EvalVarToBool(Variant(Params.TempVar),bns[2]);
        if GetObjProp(Params.TempObj,'Timeout',Variant(Params.TempVar)) then
          EvalVarToInt(Variant(Params.TempVar),Timeout);
        inc(idx,3); //idx:=3;
        //
        if (Timeout>0) then
          goto _ApplyTimeout;
      end;
    end else
    if (Params.TempVar.VType=varBoolean) then begin
      // if some specified, others are false:
      if (idx=0) then
        DWORD(bns):=0;
      //
      if (idx>=3)
      or not EvalVarToBool(Variant(Params.TempVar),bns[idx])
      then
        exit;
      inc(idx);
    end else
    if (Params.TempVar.VType in [varSingle,varDouble,varDate])
    and EvalVarToDate(Variant(Params.TempVar),Dt)
    then begin
      Dt:=(Dt*86400);
      Time.tv_sec:=Floor(Dt);
      Time.tv_usec:=Floor(Dt*1e6);
      Timeout:=1;
      lpTime:=@Time;
    end else
    if (Params.TempVar.VType in [varSmallint..varCurrency,$10..$14])
    then begin
      if not EvalVarToInt(Variant(Params.TempVar),Timeout) then
        exit;
    _ApplyTimeout:
      if (Timeout>=0) then begin
        Time.tv_sec:=Timeout div 1000;
        Time.tv_usec:=(Timeout-1000*Time.tv_sec)*1000; // micro-sec?
        lpTime:=@Time;
      end else
        lpTime:=nil;
    end else
    if (Params.TempVar.VType<=varNull) and (idx<3) then
      inc(idx)
    else
      exit;
  end;
  //
  Count:=HandleList.Count;
  Capa:=Count;
  if (Capa<FD_SETSIZE) then
    Capa:=FD_SETSIZE;
  //
  ZeroMem(@pfds,SizeOf(pfds));
  Mem:=AllocMem((Capa+1)*(3*4));
  P:=Mem;
  idx:=0;
  repeat
    if bns[idx] then begin
      pfds[idx]:=P;
      P:=@PByteArray(P)[Capa*4+4];
      //
      pfds[idx].fd_Count:=Count;
      Move(HandleList.List[0],pfds[idx].fd_array[0],Count*4);
    end;
    inc(idx);
  until (idx>=3);
  //
  Code:=select(Count,pfds[0],pfds[1],pfds[2],lpTime);
  if (Code>0) then begin
    // something is set:
    if (RetObjList<>nil) then begin
      // return array of set sockets:
      Seen:=TList.Create;
      MakePVariantNode(Node,nil);
      EvalCreateArray(Params.TempObj);
      idx:=0;
      repeat
        if (pfds[idx]<>nil) then
          for i:=0 to pfds[idx].fd_Count-1 do begin
            if (Seen.IndexOf(Pointer(pfds[idx].fd_array[i]))<=0) then begin
              Seen.Add(Pointer(pfds[idx].fd_array[i]));
              //
              j:=HandleList.IndexOf(Pointer(pfds[idx].fd_array[i]));
              if (j>=0) then begin
                Node.Arg:=PVariant(RetObjList[j]);
                Params.TempObj.CallFunc('Add',Variant(Params.TempVar),@Node);
              end;
            end;
          end;
        inc(idx);
      until (idx>=3);
      FreeAndNil(Seen);
      EvalIntfToVar(Params.TempObj,Params.lpResVar^);
    end else begin
      // return just number 1..7 with bitmask , what is set...
      Int:=0;
      if (pfds[0]<>nil) and (pfds[0].fd_count>0) then //zmena191102: +checking nil...!
        Int:=Int or 1;
      if (pfds[1]<>nil) and (pfds[1].fd_Count>0) then
        Int:=Int or 2;
      if (pfds[2]<>nil) and (pfds[2].fd_Count>0) then
        Int:=Int or 4;
      SetVarInt(Params.lpResVar^,Int);
    end;
  end else
  if (Code=0) then begin
    ECode:=ERROR_TIMEOUT;// = 1460;
    EvalHResultToVar(Params.lpResVar^,ECode);
  end else begin
    EvalHResultToVar(Params.lpResVar^,ApiError());
  end;
  FreeMem(Mem); //New200920
  Result:=True;
end;

function Sock_ReadSelect(Sock: PEvalSocket; Timeout: Longint; var ResVar: Variant): HResult; //New191124
var fdsRead,fdsExcept: TFdSet;
    C: integer;
    Now,Expire: Cardinal;
    time: TTimeVal;
    iValue: Longint;
Label _Retry;
begin
  if (Sock.phSocket=nil)
  or (Sock.phSocket.HSocket=0)
  then begin
    Result:=WSAENETDOWN;
    exit;
  end;
  ZeroMem(@fdsRead,SizeOf(fdsRead));
  ZeroMem(@fdsExcept,SizeOf(fdsExcept));
  //
  Now:=GetTickCount;
  Expire:=Now+Cardinal(Timeout); // Timeout -1 infinite...
  //
_Retry:
  //
  if (Timeout>=0) and (Timeout<=1000) then begin
    time.tv_sec:=0;
    time.tv_usec:=Timeout*1000;
  end else begin
    time.tv_sec:=1;
    time.tv_usec:=0;
  end;
  //
  FD_SET(Sock.phSocket.HSocket,fdsRead);
  FD_SET(Sock.phSocket.HSocket,fdsExcept);
  //
  C:=select(1,@fdsRead,nil,@fdsExcept,@time);
  //
  if (C>0) then begin
    // available size:
    iValue:=0;
    if (ioctlsocket(Sock.phSocket.HSocket,FIONREAD,iValue)=0)
    and (iValue>0)
    then begin
      SetVarInt(ResVar,iValue);
    end else begin
      SetVarNull(ResVar);
    end;
    //
    Result:=S_OK; // 0
    exit;
  end;
  //
  if (C=0) then begin
    //
    Now:=GetTickCount();
    if (Timeout>0) and (Longint(Expire-Now)>0) then begin
      Sleep(20);
      Timeout:=Expire-Now;
      goto _Retry;
    end;
    //
    SetVarNull(ResVar);
    Result:=WSAEWOULDBLOCK; // 1
  end else begin
    Result:=GetLastError();
    if (Result=0) then
      Result:=STG_E_ABNORMALAPIEXIT; // 800300FA
  end;
end;

function Sock_Select(Params: PObjCallParams): Boolean;
var List: TList;
    Sock: PEvalSocket;
begin
  //* Socket.Select(?read,?write,?except,?timeout) - returns boolean, if set... all sets default true
  //* Socket.Select({read:true,write:false,except:false,timeout:100}) - returns boolean, if set... all sets default false
  Sock:=Params.Self;
  List:=TList.Create;
  try
    if (Sock.phSocket<>nil)
    and (Sock.phSocket.HSocket<>0)
    then begin
      List.Add(Pointer(Sock.phSocket.HSocket));
      Result:=Eval_SockSelect2(Params,List,nil);
    end else begin
      Sleep(0);
      SetVarBool(Params.lpResVar^,False);
      Result:=True;
    end;
  finally
    List.Free;
  end;
end;

function Sock_WaitInput(Params: PObjCallParams): Boolean; //New191124
var Sock: PEvalSocket;
    Timeout: Longint;
    ECode: HResult;
begin
  //* Socket.WaitInput(TimeoutMsec) - returns integer AvailableSize or null+HResult
  Result:=False;
  Sock:=Params.Self;
  Timeout:=60000;
  if EvalNodeInt_Optional(Params.Args,Timeout) then begin
    Result:=True;
    //
    ECode:=Sock_ReadSelect(Sock,Timeout,Params.lpResVar^);
    //
    if (ECode<>0) and (PVarData(Params.lpResVar)^.VType<=varNull) then begin
      EvalHResultToVar(Params.lpResVar^,ECode);
      PByte(Params.lpResVar)^:=varNull;
    end;
  end;
end;

type
  PEnumCollectHSockets=^TEnumCollectHSockets;
  TEnumCollectHSockets=record
    HandleList:    TList;
    RetObjList:    TList;
  end;

function Enum_CollectHSockets(Arg: Pointer; const VName: Variant; const GetValue: TEvalGetValueMethod): Boolean; //New191030
var tv: TVarData;
    Obj: Pointer;
    Int: Longint;
    Info: PEnumCollectHSockets;
    pv: PVariant;
begin
  Info:=Arg;
  TdwVarData(tv).dwType:=TdwVarData(tv).dwType and 0;
  Obj:=nil;
  //
  if GetValue(VName,Variant(tv)) then begin
    if (tv.VType=varUnknown)
    and EvalVarToObj(Variant(tv),IEvalObj(Obj))
    then begin
      // or we could use ISocketHandle.GetHandle()... ?
      GetObjProp(IEvalObj(Obj),'HSocket',Variant(tv));
    end;
    //
    if (tv.VType in [varSmallint,varInteger,$10..$14])
    and EvalVarToInt(Variant(tv),Int)
    and (Int<>0)
    then begin
      Info.HandleList.Add(Pointer(Int));
      //
      if (Obj<>nil) then
        EvalIntfToVar(IEvalObj(Obj),Variant(tv));
      pv:=AllocMem(SizeOf(Variant));
      Info.RetObjList.Add(pv);
      VCopy(pv^,Variant(tv));
    end;
  end;
  //
  FinitIntf(Obj);
  SetVarNull(Variant(tv));
  //
  Result:=False; // continue...
end;

function Eval_SockSelect1(Params: PObjCallParams): Boolean; //New191030
var List,RetObjList: TList;
    Int,i: Longint;
    pv: PVariant;
    Info: TEnumCollectHSockets;
begin
  //* SockSelect([sockets],?read,?write,?except,?timeout) - returns array of sockets, that are in some set
  //* -- all sets default true
  //* SockSelect([sockets],{read:true,write:false,except:false,timeout:100}) - returns array of sockets, that are in some set
  //* -- all sets default false
  Result:=False;
  ZeroMem(@Info,SizeOf(Info));
  List:=TList.Create;
  RetObjList:=TList.Create;
  try
    //
    Info.HandleList:=List;
    Info.RetObjList:=RetObjList;
    //
    if EvaluateNode(Variant(Params.TempVar),Params.Args) then begin
      Params.Args:=Params.Args.Next;
      //
      if (TVarData(Params.TempVar).VType=varUnknown)
      and EvalVarToObj(Variant(Params.TempVar),Params.TempObj)
      then begin
        if (Params.TempObj.QueryInterface(guid_ISocketHandle,Params.TempObj2)=0) then begin
          Int:=ISocketHandle(Params.TempObj2).GetHandle;
          if (Int<>0) then begin
            List.Add(Pointer(Int));
            pv:=AllocMem(SizeOf(Variant));
            EvalIntfToVar(Params.TempObj,pv^);
            RetObjList.Add(pv);
          end;
        end else
        if (Params.TempObj.QueryInterface(guid_IEvalObjEnumerable,Params.TempObj2)=0) then begin
          IEvalObjEnumerable(Params.TempObj2).Enumerate(Enum_CollectHSockets,@Info);
        end else
      end else
      if (TVarData(Params.TempVar).VType in [varSmallint,varInteger,$10..$14])
      and EvalVarToInt(Variant(Params.TempVar),Int)
      then begin
        if (Int<>0) then begin
          List.Add(Pointer(Int));
          pv:=AllocMem(SizeOf(Variant));
          SetVarInt(pv^,Int);
          RetObjList.Add(pv);
        end;
      end else
        exit;
    end;
    //
    if (List.Count>0) then begin
      Result:=Eval_SockSelect2(Params,List,RetObjList);
    end else begin
      Sleep(0);
      Ocp_RetBool(Params,False);
      Result:=True;
    end;
  finally
    List.Free;
    i:=RetObjList.Count;
    while (i>0) do begin
      dec(i);
      pv:=RetObjList[i];
      RetObjList.Delete(i);
      SetVarNull(Variant(pv^));
      FreeMem(pv);
    end;
    FreeAndNil(RetObjList);
  end;
end;

function Eval_SockSelect(var ResVar: Variant; Args: PEvalNode): Boolean;
var Temp: Pointer;
begin
  Temp:=nil;
  Result:=OcpCall(TObjCallProc(@Eval_SockSelect1),@Temp,@ResVar,Args);
end;

function GetPortProp(Params: PObjCallParams; Addr: PSockAddr): Boolean;
begin
  if (Addr<>nil) then
    SetVarInt(Params.lpResVar^,WSwap(Addr.sin_port))
  else
    SetVarNull(Params.lpResVar^);
  Result:=True;
end;

{//x191102:
function GetIpProp(var ResVar: Variant; lpTempStr: PString8; Addr: PSockAddr; bnWithPort: Boolean): Boolean;
var pc: PAnsiChar;
    pb: PByte;
    i: integer;
    Buffer: array[0..63] of AnsiChar;
Label _Null;
begin
  if (Addr<>nil) then begin
    // '1.2.3.4'  ~ '1.2.3.4:555'
    // 'ipv6' ~ 'ipv6:555' //!!!TODO
    pc:=nil;
    case Addr.sin_family of
      AF_INET: begin
        //pc:=inet_ntoa(Addr.sin_addr);
        pc:=Buffer;
        pb:=Pointer(@Addr.sin_addr);
        i:=0;
        repeat
          pc:=StrEnd(StrLFmt(pc,7,'.%d',[pb^]));
          inc(pb);
          inc(i);
        until (i>=4);
        pc:=@Buffer[1]; // skip first '.'
      end;
      else begin
        //!!! what is ipv6? AF_INET6 ?
      end;
    end;
    //
    if (pc=nil) then
      goto _Null;
    //
    if bnWithPort then
      FmtStr(lpTempStr^,'%s:%d',[pc,WSwap(Addr.sin_port)])
    else
      FmtStr(lpTempStr^,'%s',[pc]);
    EvalAnsiToVar(ResVar,lpTempStr^);
    //
  end else begin
  _Null:
    SetVarNull(ResVar);
  end;
  Result:=True;
end;{}
function GetIpProp(var ResVar: Variant; lpTempStr: PString8; Addr: PSockAddr; bnWithPort: Boolean): Boolean;
var Buffer: array[0..79] of Char8;
    Len: integer;
    pc: PChar8;
begin
  Len:=EvalIpToStr(Addr.sin_family,@Addr.sin_addr,@Buffer,SizeOf(Buffer)-7);
  if (Len>0) and (Len<SizeOf(Buffer)-7) then begin
    if bnWithPort then begin
      pc:=@Buffer[Len];
      inc(Len,StrLen(StrLFmt(pc,6,':%d',[WSwap(Addr.sin_port)])));
    end;
    EvalPAnsiToVar(ResVar,@Buffer,Len);
  end else
    SetVarNull(ResVar);
  Result:=True;
end;

function Sock_GetLocalPort(Params: PObjCallParams): Boolean;
begin
  //* Socket.LocalPort -- returns integer or null
  //* Socket.Port -- returns integer or null
  Result:=GetPortProp(Params,PEvalSocket(Params.Self).MyAddress);
end;

function Sock_GetLocalIp(Params: PObjCallParams): Boolean;
begin
  //* Socket.LocalIp -- // '192.168.1.100'
  Result:=GetIpProp(Params.lpResVar^,@Params.TempStr1,PEvalSocket(Params.Self).MyAddress,False);
end;

function Sock_GetLocalAddr(Params: PObjCallParams): Boolean;
begin
  //* Socket.LocalAddress -- '192.168.1.100:1234'
  Result:=GetIpProp(Params.lpResVar^,@Params.TempStr1,PEvalSocket(Params.Self).MyAddress,True);
end;

function Sock_GetPeerPort(Params: PObjCallParams): Boolean;
begin
  //* Socket.PeerPort -- returns integer or null
  //* Socket.RemotePort
  Result:=GetPortProp(Params,PEvalSocket(Params.Self).PeerAddress);
end;

function Sock_GetPeerIp(Params: PObjCallParams): Boolean;
begin
  //* Socket.PeerIp -- '192.168.1.100'
  //* Socket.RemoteIp
  //* Socket.ClientIp
  Result:=GetIpProp(Params.lpResVar^,@Params.TempStr1,PEvalSocket(Params.Self).PeerAddress,False);
end;

function Sock_GetPeerAddr(Params: PObjCallParams): Boolean;
begin
  //* Socket.PeerAddress -- '192.168.1.100:8000'
  //* Socket.RemoteAddress
  //* Socket.ClientAddress
  Result:=GetIpProp(Params.lpResVar^,@Params.TempStr1,PEvalSocket(Params.Self).PeerAddress,True);
end;

function Sock_GetHandle(Params: PObjCallParams): Boolean; //New191030
var qw: LARGE_INTEGER;
begin
  //* Socket.HSocket - returns integer socket handle...
  //* Socket.Handle
  if (PEvalSocket(Params.Self).phSocket<>nil)
  and (PEvalSocket(Params.Self).phSocket.HSocket<>0)
  then begin
    // or we could use ISocketHandle.GetHandle()
    qw.LowPart:=PEvalSocket(Params.Self).phSocket.HSocket;
    qw.HighPart:=qw.HighPart and 0;
    SetVarInt64(Params.lpResVar^,qw.QuadPart);
  end else begin
    SetVarNull(Params.lpResVar^);
  end;
  Result:=True;
end;

function Sock_GetAvailSize(Params: PObjCallParams): Boolean;
var Avail: Longint;
    ECode: HResult;
Label _Null;
begin
  //* Socket.AvailSize -- returns available size for Recv...
  //* Socket.CanRead
  if (PEvalSocket(Params.Self).phSocket<>nil)
  and (PEvalSocket(Params.Self).phSocket.hSocket<>0)
  then begin
    Avail:=0;
    if (ioctlsocket(PEvalSocket(Params.Self).phSocket.hSocket,FIONBIO,Avail)=0) then
      SetVarInt(Params.lpResVar^,Avail)
    else begin
      ECode:=GetLastError();
      if (ECode<>0) then
        EvalHResultToVar(Params.lpResVar^,ECode)
      else
        goto _Null;
    end;
  end else begin
  _Null:
    Params.bnNullRes:=True; //SetVarNull(Params.lpResVar^);
  end;
  Result:=True;
end;

procedure CloneAddr(var Dst: Pointer; Src: Pointer);
begin
  if (Src<>nil) then begin
    GetMem(Dst,SizeOf(TSockAddrIn));
    PSockAddr(Dst)^:=PSockAddr(Src)^;
  end;
end;

function Sock_Clone(Params: PObjCallParams): Boolean;
var New,Old: PEvalSocket;
    phs: PSocketHandle;
begin
  //* Socket.Clone() -- returns new Socket object, sharing socket handle...
  //* Socket.Clone
  Eval_CreateSocket(nil,Params.TempObj,nil);
  New:=Pointer(Params.TempObj);
  Old:=Params.Self;
  //
  NplClone(New.Props,Old.Props);
  if (New.Prototype<>Old.Prototype) then
    New.Prototype:=Old.Prototype;
  //
  phs:=Old.phSocket;
  if (phs<>nil) then begin
    inc(phs.RefCount);
    New.phSocket:=phs;
  end;
  //
  New.SendStream:=Old.SendStream;
  New.RecvStream:=Old.RecvStream;
  //
  CloneAddr(New.MyAddress,Old.MyAddress);
  CloneAddr(New.PeerAddress,Old.PeerAddress);
  //
  New.LastError:=Old.LastError;
  New.Timeout:=Old.Timeout;
  New.bDefaultSide:=Old.bDefaultSide;
  //
  Result:=EvalIntfToVar(Params.TempObj,Params.lpResVar^);
end;

function Sock_GetStream(Params: PObjCallParams; Op: Byte): Boolean;
var Sock: PEvalSocket;
    bnHandled: Boolean;
    Slot: ^IStream;
    Stm: Pointer;
    QiSelf: TQueryInterfaceMethod;
begin
  // return IEvalObj(TEvalStream) wrapper with our SendStream/RecvStream ...
  Op:=Op and 1;
  bnHandled:=False;
  Sock:=Params.Self;
  QiSelf:=QiUnk(IUnknown(Sock));
  //
  if (Sock.Props<>nil) then begin
    // Cache in Props, is not used often?
    if (Op=0) then
      Result:=NplGet(Sock.Props,'SendStream',Params.lpResVar^,nil,QiSelf,@bnHandled)
    else
      Result:=NplGet(Sock.Props,'RecvStream',Params.lpResVar^,nil,QiSelf,@bnHandled);
    if bnHandled then
      exit;
  end;
  //
  Slot:=Pointer(@PPointerList(@PEvalSocket(Params.Self).SendStream)[Op and 1]);
  if (Slot^=nil) then begin
    //Params.bnNullRes:=True;
    SetVarNull(Params.lpResVar^);
    Result:=True;
    exit;
  end;
  //
  Stm:=nil;
  Result:=CreateEvalStream(Slot^,guid_IEvalObj,Stm);
  if not Result then
    exit;
  //
  EvalIntfToVar(IUnknown(Stm),Params.lpResVar^);
  FinitIntf(Stm);
  //
  if (Op=0) then
    NplPut(Sock.Props,'SendStream',Params.lpResVar^,nil,QiSelf)
  else
    NplPut(Sock.Props,'RecvStream',Params.lpResVar^,nil,QiSelf);
  //
  Result:=True;
end;

function Sock_GetSendStream(Params: PObjCallParams): Boolean;
asm
  //* Socket.SendStream -- return IStream object
  xor  edx,edx
  jmp  Sock_GetStream
end;

function Sock_GetRecvStream(Params: PObjCallParams): Boolean;
asm
  //* Socket.RecvStream -- return IStream object
  mov  dl,1
  jmp  Sock_GetStream
end;

function Sock_SetStream(Params: PObjPropParams; Op: Byte): Boolean;
var Sock: PEvalSocket;
    ps: ^IStream;
    QiSelf: TQueryInterfaceMethod;
begin
  //* Socket.SendStream:= -- can set Stream object
  //* Socket.RecvStream:= -- can set Stream object
  Result:=False;
  Sock:=Params.Self;
  if (PVarData(Params.lpValue)^.VType<=varNull) then begin
    if (Op=0) then begin
      NplRemove(Sock.Props,'SendStream');
      ps:=@Sock.SendStream;
    end else begin
      NplRemove(Sock.Props,'RecvStream');
      ps:=@Sock.RecvStream;
    end;
    FinitIntf(ps^);
    Result:=True;
  end else
  if (PVarData(Params.lpValue).VType=varUnknown)
  and EvalVarToObj(Params.lpValue^,Params.TempObj)
  and (Params.TempObj.QueryInterface(guid_IStream,Params.TempObj2)=0)
  then begin
    // keep original Stream IEvalObj in Props...
    QiSelf:=QiUnk(IUnknown(Sock));
    if (Op=0) then begin
      NplPut(Sock.Props,'SendStream',Params.lpValue^,nil,QiSelf);
      ps:=@Sock.SendStream;
    end else begin
      NplPut(Sock.Props,'RecvStream',Params.lpValue^,nil,QiSelf);
      ps:=@Sock.RecvStream;
    end;
    ps^:=IStream(Params.TempObj2);
    Result:=True;
  end;
end;

function Sock_SetSendStream(Params: PObjPropParams): Boolean;
asm
  //* Socket.SendStream:= -- can set Stream object
  xor  edx,edx
  jmp  Sock_SetStream
end;

function Sock_SetRecvStream(Params: PObjCallParams): Boolean;
asm
  //* Socket.RecvStream:= -- can set IStream object
  mov  dl,1
  jmp  Sock_SetStream
end;

function Sock_GetLastError(Params: PObjCallParams): Boolean;
begin
  //* Socket.GetLastError() ~ Socket.LastError - returns integer
  if (PEvalSocket(Params.Self).LastError<>0) then
    SetVarInt(Params.lpResVar^,PEvalSocket(Params.Self).LastError)
  else
    SetVarNull(Params.lpResVar^);
  Result:=True;
end;

function Sock_SetLastError(Params: PObjPropParams): Boolean;
var qw: LARGE_INTEGER;
begin
  //* Socket.LastError:=integer
  if (PVarData(Params.lpValue).VType<=varNull) then begin
    PEvalSocket(Params.Self).LastError:=0;
    Result:=True;
  end else
  if EvalVarToInt64(Params.lpValue^,qw.QuadPart) then begin
    PEvalSocket(Params.Self).LastError:=qw.LowPart;
    Result:=True;
  end else
    Result:=False;
end;

function Sock_SetLastError_Func(Params: PObjCallParams): Boolean;
var lpv: PVariant;
begin
  //* Socket.SetLastError(ECode)
  Result:=False;
  if EvaluateNode(Variant(Params.TempVar),Params.Args) then begin
    lpv:=Params.lpResVar;
    Params.lpResVar:=@Params.TempVar;
    Result:=Sock_SetLastError(PObjPropParams(Params));
    Params.lpResVar:=lpv;
    if Result then
      Result:=Ocpi_RetSelf(Params);
  end;
end;

function Sock_SetLocalPort(Params: PObjPropParams): Boolean;
var Port: integer;
    Sock: PEvalSocket;
begin
  //* Socket.LocalPort:=8000
  //* Socket.Port:=8000
  Result:=False;
  if EvalVarToInt(Params.lpValue^,Port) then begin
    if (Port<=0) or (Port>=65535) then
      Port:=0;
    Sock:=Params.Self;
    //
    if (Sock.phSocket<>nil) and (Sock.phSocket.hSocket<>0) then begin
      // Cannot change if connected...
      Result:=False;
      exit;
    end;
    //
    if (Sock.MyAddress=nil) then
      Sock.MyAddress:=AllocSockAddr();
    PSockAddr(Sock.MyAddress).sin_port:=WSwap(Port);
    Result:=True;
  end;
end;

function Sock_SetLocalIp(Params: PObjPropParams): Boolean;
var Sock: PEvalSocket;
    Addr: TSockAddrIn;
    Node: TEvalNode;
    lpv: PVariant;
begin
  //* Socket.LocalIp:='1.2.3.4'
  //* Socket.LocalAddress:='1.2.3.4:1234'
  Sock:=Params.Self;
  ZeroMem(@Addr,SizeOf(Addr));
  //
  if (Sock.phSocket<>nil) and (Sock.phSocket.hSocket<>0) then begin
    // Cannot change if connected...
    Result:=False;
    exit;
  end;
  //
  lpv:=Params.lpValue;
  PObjCallParams(Params).Args:=MakePVariantNode(Node,Params.lpValue);
  PObjCallParams(Params).lpResVar:=Pointer(@Params.TempVar);
  Result:=Eval_IpAddress(PObjCallParams(Params),@Addr,False);
  //
  PObjCallParams(Params).Args:=nil;
  Params.lpValue:=lpv;
  //
  if Result then begin
    if (Sock.MyAddress=nil) then
      Sock.MyAddress:=AllocSockAddr();
    PSockAddr(Sock.MyAddress)^:=Addr;
  end;
end;

function Sock_GetTimeout(Params: PObjCallParams): Boolean;
begin
  //* Socket.Timeout - returns integer or null, -1 infinite...
  if (PEvalSocket(Params.Self).Timeout=0) then begin
    SetVarNull(Params.lpResVar^);
  end else begin
    SetVarInt(Params.lpResVar^,PEvalSocket(Params.Self).Timeout);
  end;
  Result:=True;
end;

function Sock_SetTimeout(Params: PObjPropParams): Boolean;
var qw: LARGE_INTEGER;
begin
  //* Socket.Timeout:=integer or null, -1 infinite...
  if (PVarData(Params.lpValue).VType<=varNull) then begin
    PEvalSocket(Params.Self).Timeout:=0;
    Result:=True;
  end else
  if EvalVarToInt64(Params.lpValue^,qw.QuadPart) then begin
    PEvalSocket(Params.Self).Timeout:=qw.LowPart;
    Result:=True;
  end else
    Result:=False;
end;

function Vmt_EvalSocket(): Pointer;
asm
  mov eax,offset @Vmt
  ret
  nop
  nop
  dd  0
@Vmt:
  // IUnknown
  dd  @QueryInterface
  dd  GenObj_AddRef
  dd  @Release
  // IEvalObj
  dd  @CallFunc // -> @CallDesc
  dd  @GetProp  // -> @GetPropDesc
  dd  @SetProp  // -> @SetPropDesc
  dd  @Control
  dd  0
  db 'Socket',0 // 7 bytes to align control-table ...
@Control:
  call ObjControlTable
  //!!! (add specific control codes)
  dd 0,GenObj_Control // default handler...
  //
@qi_def: // QueryInterface list of interfaces...
  dd  offset guid_IEvalObj
  dd  @qi_this
  dd  offset guid_IUnknown
  dd  @qi_this
  dd  offset guid_IStream
  dd  @qi_Stream
  dd  offset guid_INetSvcStream //New191029
  dd  @qi_NetSvc
  dd  guid_INetSocket //New200828
  dd  @qi_NetSocket
  dd  0
  dd  ENoInterface_rb12
  //
@Vmt_INetSocket: //New200828
  dd  @qi_from_INetSocket
  dd  GenHelper_AddRef
  dd  GenHelper_Release
  //
  dd  Sock_INetSocket_Send
  dd  Sock_INetSocket_Recv
  dd  @Ins_GetLastError
  dd  @Ins_Control
  dd  0
  //
@qi_def_INetSocket: //New200828
  dd  guid_INetSocket,   @qi_this
  dd  guid_IUnknown,     @qi_this
  dd  0,                 ENoInterface_rb12
  //
  // --------------------------------
@CallDesc:
  // TObjCallDesc
  dd   @c_Alpha
  dd   0
  dd   GenObj_CallDesc
  // TObjMetAlpha:
@c_Alpha:
  dd   0           // @
  dd   @c_A        // A
  dd   0           // B
  dd   @c_C        // C
  dd   @c_D        // D
  dd   @c_E        // E
  dd   0           // F
  dd   0           // G
  dd   0           // H
  dd   @c_I        // I
  dd   0           // J
  dd   0           // K
  dd   @c_L        // L
  dd   0           // M
  dd   0           // N
  dd   0           // O
  dd   @c_P        // P
  dd   0           // Q
  dd   @c_R        // R
  dd   @c_S        // S
  dd   0           // T
  dd   0           // U
  dd   0           // V
  dd   @c_W        // W
  dd   0           // X
  dd   0           // Y
  dd   0           // Z   Zero() -- see Clear()
  // TObjMethodSlot
@c__Spec:
  dd 0
@c_A:
  dd @Accept           +1
  dd Sock_Accept
  dd 0
@c_B:
  dd @Bind             +1 //New191030 not needed with Listen...
  dd Sock_Bind
  dd 0
@c_C:
  dd @Connect          +1
  dd Sock_Connect
  dd @CreateParams     +1
  dd Sock_CreateParams
  dd @Clone            +1
  dd Sock_Clone
  dd @Close            +1 //New191110
  dd Sock_Disconnect
  dd 0
@c_D:
  dd @Disconnect       +1
  dd Sock_Disconnect
  dd 0
@c_E:
  dd @EventSelect      +1
  dd Sock_EventSelect
  dd 0
@c_G:
  dd @GetLastError     +1
  dd Sock_GetLastError
  dd 0
@c_I:
  dd @InitSSL          +1
  dd Sock_InitSSL
  dd 0
@c_L:
  dd @Listen           +1 // Bind+Listen
  dd Sock_Listen
  dd 0
@c_P:
  dd @Peek             +1
  dd Sock_Peek
  dd 0
@c_R:
  dd @Recv             +1
  dd Sock_Recv
  dd @ReadInt          +1
  dd Sock_ReadInt
  dd @RecvLine         +1
  dd Sock_RecvLine
  dd @RecvText         +1
  dd Sock_RecvText
  dd @RecvFrom         +1 //New191029 (udp)
  dd Sock_RecvFrom
  //!!!TODO_200829: RecvTo(?Timeout,Stream~Socket,?Size)
  dd 0
@c_S:
  dd @Send             +1
  dd Sock_Send
  dd @SendLine         +1
  dd Sock_SendLine
  dd @SendTo           +1 //New191030
  dd Sock_SendTo
  dd @Select           +1
  dd Sock_Select
  dd @SendStream       +1
  dd Sock_SendStream
  dd @SetLastError     +1
  dd Sock_SetLastError_Func
  dd @Shutdown         +1
  dd Sock_Shutdown
  dd 0
@c_W:
  dd @WaitInput        +1 //New191124
  dd Sock_WaitInput
  dd 0
  //
  // --------------------------------
@GetPropDesc:
  // TObjCallDesc
  dd   @g_Alpha
  dd   0
  dd   GenObj_GetPropDesc
  // TObjMetAlpha:
@g_Alpha:
  dd   0           // @
  dd   @g_A        // A
  dd   @g_B        // B
  dd   @g_C        // C
  dd   @g_D        // D
  dd   0           // E
  dd   0           // F
  dd   0           // G
  dd   @g_H        // H
  dd   @g_I        // I
  dd   0           // J
  dd   0           // K
  dd   @g_L        // L
  dd   0           // M
  dd   0           // N
  dd   0           // O
  dd   @g_P        // P
  dd   0           // Q
  dd   @g_R        // R
  dd   @g_S        // S
  dd   @g_T        // T
  dd   0           // U
  dd   0           // V
  dd   0           // W
  dd   0           // X
  dd   0           // Y
  dd   0           // Z   Zero() -- see Clear()
  // TObjMethodSlot
@g_A:
  dd  @AvailSize       +1
  dd  Sock_GetAvailSize
  dd  @Accept          +1
  dd  Sock_Accept
  dd  0
@g_B:
  dd  @Blocking        +1
  dd  Sock_GetIsBlocking
  dd  0
@g_C:
  dd  @CanRead         +1
  dd  Sock_GetAvailSize
  dd  @ClientIP        +1
  dd  Sock_GetPeerIp
  dd  @ClientPort      +1
  dd  Sock_GetPeerPort
  dd  @ClientAddress   +1
  dd  Sock_GetPeerAddr
  dd  @Clone           +1
  dd  Sock_Clone
  dd  @Connected       +1 //New191117
  dd  Sock_GetIsConnected
  // CodePage in Props...
  dd  0
@g_D:
  dd  @Disconnect      +1
  dd  Sock_Disconnect
  dd  0
@g_H:
  dd  @HSocket         +1
  dd  Sock_GetHandle
  dd  @Handle          +1
  dd  Sock_GetHandle
  dd  0
@g_I:
  dd  @IsConnected     +1 //New191117
  dd  Sock_GetIsConnected
  dd  0
@g_L:
  dd  @LastError       +1
  dd  Sock_GetLastError
  dd  @LocalPort       +1
  dd  Sock_GetLocalPort
  dd  @LocalIp         +1
  dd  Sock_GetLocalIp
  dd  @LocalAddress    +1
  dd  Sock_GetLocalAddr
  dd  0
// get Options from Props...
@g_P:
  dd  @Port            +1
  dd  Sock_GetLocalPort
  dd  @PeerIP          +1
  dd  Sock_GetPeerIp
  dd  @PeerPort        +1
  dd  Sock_GetPeerPort
  dd  @PeerAddress     +1
  dd  Sock_GetPeerAddr
  dd  0
@g_R:
  dd  @RecvStream      +1
  dd  Sock_GetRecvStream
  dd  @RemoteIP        +1
  dd  Sock_GetPeerIp
  dd  @RemotePort      +1
  dd  Sock_GetPeerPort
  dd  @RemoteAddress   +1
  dd  Sock_GetPeerAddr
  dd  0
@g_S:
  dd  @SendStream      +1
  dd  Sock_GetSendStream
  dd  0
@g_T:
  dd  @Timeout         +1
  dd  Sock_GetTimeout
  dd  0
  //
  // --------------------------------
@SetPropDesc:
  // TObjCallDesc
  dd   @s_Alpha
  dd   0
  dd   GenObj_SetPropDesc
  // TObjMetAlpha:
@s_Alpha:
  dd   0           // @
  dd   0           // A
  dd   @s_B        // B
  dd   0           // C
  dd   0           // D
  dd   0           // E
  dd   0           // F
  dd   0           // G
  dd   0           // H
  dd   0           // I
  dd   0           // J
  dd   0           // K
  dd   @s_L        // L
  dd   0           // M
  dd   0           // N
  dd   @s_O        // O
  dd   @s_P        // P
  dd   0           // Q
  dd   @s_R        // R
  dd   @s_S        // S
  dd   @s_T        // T
  dd   0           // U
  dd   0           // V
  dd   0           // W
  dd   0           // X
  dd   0           // Y
  dd   0           // Z   Zero() -- see Clear()
  // TObjMethodSlot
  // CodePage in Props...
@s_B:
  dd  @Blocking        +1
  dd  Sock_SetIsBlocking
  dd  0
@s_L:
  dd  @LastError       +1
  dd  Sock_SetLastError
  dd  @LocalPort       +1
  dd  Sock_SetLocalPort
  dd  @LocalIp         +1
  dd  Sock_SetLocalIp
  dd  @LocalAddress    +1
  dd  Sock_SetLocalIp
  dd  0
@s_O:
  dd  @Options         +1
  dd  Sock_SetOptions
  dd  0
@s_P:
  dd  @Port            +1
  dd  Sock_SetLocalPort
  //!!!TODO: Protocol // 'tcp','udp','tcp6','udp6','raw'
  dd  0
@s_R:
  dd  @RecvStream      +1
  dd  Sock_SetRecvStream
  dd  0
@s_S:
  dd  @SendStream      +1
  dd  Sock_SetSendStream
  dd  0
@s_T:
  dd  @Timeout         +1
  dd  Sock_SetTimeout
  dd  0
  //
@Accept: db 6,'Accept',0
@Bind: db 4,'Bind',0
@Connect: db 7,'Connect',0
@Clone: db 5,'Clone',0
@Close: db 5,'Close',0 //New191110
@CreateParams: db 12,'CreateParams',0
@Disconnect: db 10,'Disconnect',0
@EventSelect: db 11,'EventSelect',0
@Listen: db 6,'Listen',0
@Peek: db 4,'Peek',0
@Recv: db 4,'Recv',0
@RecvLine: db 8,'RecvLine',0
@RecvText: db 8,'RecvText',0
@RecvFrom: db 8,'RecvFrom',0
@ReadInt: db 7,'ReadInt',0
@Send: db 4,'Send',0
@SendLine: db 8,'SendLine',0
@SendTo: db 6,'SendTo',0 //New191030
@Shutdown: db 8,'Shutdown',0
@Select: db 6,'Select',0
@InitSSL: db 7,'InitSSL',0
@WaitInput: db 9,'WaitInput',0 //New191124
  //
@AvailSize: db 9,'AvailSize',0
@Blocking: db 8,'Blocking',0
@CanRead: db 7,'CanRead',0
@ClientIp: db 8,'ClientIp',0 // =RemoteIp
@ClientPort: db 10,'ClientPort',0 // =RemotePort
@ClientAddress: db 13,'ClientAddress',0 // =RemoteAddress
@Handle: db 6,'Handle',0 //New191030
@HSocket: db 7,'HSocket',0 //New191030
@Connected: db 9,'Connected',0 //New191117
@IsConnected: db 11,'IsConnected',0 //New191110
@Port: db 4,'Port',0 // =LocalPort
@LocalPort: db 9,'LocalPort',0
@LocalIp: db 7,'LocalIp',0
@LocalAddress: db 12,'LocalAddress',0
@Options: db 7,'Options',0
@PeerIp: db 6,'PeerIp',0
@PeerPort: db 10,'PeerPort',0
@PeerAddress: db 11,'PeerAddress',0
@RemoteIp: db 8,'RemoteIp',0
@RemotePort: db 10,'RemotePort',0
@RemoteAddress: db 13,'RemoteAddress',0
@Timeout: db 7,'Timeout',0
@LastError: db 9,'LastError',0
@GetLastError: db 12,'GetLastError',0
@SetLastError: db 12,'SetLastError',0
@SendStream: db 10,'SendStream',0
@RecvStream: db 10,'RecvStream',0
  //
@qi_from_INetSocket: //New200828
  push ebp
  mov  ebp,esp
  mov  eax,offset @qi_def_INetSocket
  jmp  @qi3
  //
@QueryInterface:
  // [esp+4]=[ebp+8]=Self, [esp+8]=[ebp+12]=Guid, [esp+12]=[ebp+16]=^Out
  push ebp
  mov  ebp,esp
  //
@qi2:
  mov  eax,offset @qi_def
@qi3:
  call QiMultiInternal
  jmp  eax
  //
@qi_this:
  // this interface... (also used in Helper objects...)
  mov  eax,[ebp+8]
  push eax
  mov  eax,[eax]
  call [eax].TIUnknownVmt.AddRef
  //
  mov  eax,[ebp+8]
@qi_retEax:
  mov  ecx,[ebp+16]
  mov  [ecx],eax
  xor  eax,eax
@rb12:
  mov  esp,ebp
  pop  ebp
  retn 12
  //
@qi_NetSocket: //New200828
  mov  edx,[ebp+8]
  mov  eax,offset @Vmt_INetSocket
  xor  ecx,ecx
  call MakeGenHelperI
  jmp  @qi_retEax
  //
@qi_NetSvc: //New191029
  mov  eax,[ebp+8]
  mov  eax,[eax].TEvalSocket.phSocket
  test eax,eax
  jz   @no_obj
  mov  eax,[eax].TSocketHandle.Svc
  test eax,eax
  //jz   @no_obj
  //mov  [ebp+8],eax
  //jnz  @qi_this
  jnz  @qi_AskThere
@no_obj:
  mov  eax,MK_E_NOOBJECT
  jmp  @rb12
  //
@qi_Stream:
  // which stream?
  mov  eax,[ebp+8]
  movzx edx,[eax].TEvalSocket.bDefaultSide
  and  edx,1
  mov  eax,[eax+4*edx].TEvalSocket.SendStream // SendStream or RecvStream
  test eax,eax
  jz   ENoInterface_rb12
@qi_AskThere:
  mov  esp,ebp
  pop  ebp
  mov  [esp+4],eax
  mov  eax,[eax]
  jmp  [eax].TIUnknownVmt.QueryInterface
  //
@Release: // [esp+4]=Self
  mov  eax,[esp+4]
  or   edx,-1
  lock xadd [eax].TEvalGenObj.RefCount,edx
  dec  edx
  jz   EvalSocket_Destroy // is stdcall...
  mov  eax,edx
  retn 4
  //
@CallFunc: // eax=Self, edx=FuncName, ecx=ResVar, [esp+4]=Args
  call GenObj_CallFunc_Prefix // FuncNode from this.Props ?
  push offset @CallDesc
  jmp  ObjMethodCall
  //
@GetProp: // eax=Self, edx=PropName, ecx=ResVar, [esp+4]=IndexArg
  test edx,edx
  jz   @gp0
  call GenObj_GetProp_Prefix // from this.Props takes precedence...
  push offset @GetPropDesc
  jmp  ObjMethodCall
@gp0:
  // (PropName='')
  cmp  dword ptr [esp+4],0 // IndexArg?
  jnz  @gp0_index
  //mov  edx,offset @szValue
  //jmp  @GetProp
  xor  eax,eax
  retn 4
  //
@gp0_index:
  // (PropName=''), (IndexArg<>nil)
  mov  edx,[esp+4]
  call GenObj_Get0Prop_Index
  retn 4
  //
@SetProp: // eax=Self, edx=PropName, ecx=Value, [esp+4]=IndexArg
  test edx,edx
  jz   @sp0
  push offset @SetPropDesc
  jmp  ObjMetSetProp
@sp0:
  // (PropName='')
  cmp  dword ptr [esp+4],0 // IndexArg?
  jnz  @sp0_index //! ByteArray_Set0Prop_Index //GenObj_SetProp_Fallback2
  // (PropName=''), (IndexArg=nil) -- SetProp('Value',Value,nil)
  //mov  edx,offset @szValue
  //jmp  @SetProp
  xor  eax,eax
  retn 4
@sp0_index:
  mov  edx,[esp+4]
  call GenObj_Set0Prop_Index
  retn 4
  //
  //New200828
@Ins_Control:
  mov  eax,[eax].TEvalGenHelper.Target
  jmp  @Control
  //
  //New200828
@Ins_GetLastError: // in EAX=Self
  mov  eax,[eax].TEvalGenHelper.Target
  mov  eax,[eax].TEvalSocket.LastError
  //ret
end;

function Eval_CreateSocket(Arg: Pointer; out Obj: IEvalObj; Params: PEvalNode): Boolean;
var Sock: PEvalSocket;
    tv: TVarData;
begin
  //* new Socket(?Port)
  //* -- Socket object is descendant from GenObj...
  if (NeedWSock()<>0) then begin
    Result:=False;
    exit;
  end;
  Sock:=AllocMem(SizeOf(TEvalSocket));
  Sock.Vmt:=Vmt_EvalSocket();
  inc(Sock.RefCount);
  Pointer(Obj):=Sock;
  Sock.Timeout:=Sock.Timeout or -1;
  //
  GenObj_InitProto(Sock);
  //
  if (Params<>nil) then begin
    TdwVarData(tv).dwType:=TdwVarData(tv).dwType and 0;
    Result:=Obj.CallFunc('CreateParams',Variant(tv),Params);
    SetVarNull(Variant(tv));
  end else
    Result:=True;
end;

function Eval_SocketFunc(var ResVar: Variant; Args: PEvalNode): Boolean;
begin
  //* var S:=Socket();  var S:=Socket(LocalPort,?'udp');
  Result:=False;
  SetVarNull(ResVar);
  if Eval_CreateSocket(nil,IEvalObj(TVarData(ResVar).VUnknown),Args) then begin
    TVarData(ResVar).VType:=varUnknown;
    Result:=True;
  end;
end;

procedure EvalNet_ThreadExit();
begin
  //??? (called from DLL_THREAD_DETACH)
end;

function Eval_TcpConnect(var ResVar: Variant; Args: PEvalNode): Boolean;
var Sock: IEvalObj;
begin
  //* Socket:=TcpConnect(host,port) == S:=new Socket; S.Connect(host,port)
  Result:=False;
  if Eval_CreateSocket(nil,Sock,nil) then begin
    Result:=Sock.CallFunc('Connect',ResVar,Args);
    if Result then
      EvalIntfToVar(Sock,ResVar);
  end;
end;

{ Forward }

const
  cFwdPairSign = $98A07CF1;

function NetFwd_Released(Fwd: PEvalForward): Longint; stdcall;
var H: THandle;
    Lock: PRtlCriticalSection;
    i: integer;
    Pair: PFwdSockPair;
begin
  if (Fwd.RefCount=0) then begin
    //
    Lock:=Fwd.Lock;
    if (Lock<>nil) then
      EnterCriticalSection(Lock^);
    //
    if (Fwd.RefCount=0) then begin
      //
      H:=Fwd.hSignal;
      Fwd.hSignal:=0;
      if (H<>0) then begin
        SetEvent(H);
        CloseHandle(H);
      end;
      //
      H:=Fwd.hThread;
      Fwd.hThread:=0;
      if (H<>0) then begin
        CloseHandle(H);
      end;
      //
      Fwd.Lock:=nil; // released below...
      //
      if (Fwd.Pairs<>nil) then begin
        i:=Fwd.Pairs.Count;
        while (i>0) do begin
          dec(i);
          Pair:=Fwd.Pairs.List[i];
          Fwd.Pairs.Delete(i);
          if (Pair<>nil) and (Pair.Signature=cFwdPairSign) then begin
            Pair.Signature:=0;
            FinitIntf(Pair.ReadStream);
            FinitIntf(Pair.WriteBuffer);
            FinitIntf(Pair.SendStream);
            FinitIntf(Pair.Socket1);
            FinitIntf(Pair.Socket2);
            FreeMem(Pair);
          end;
        end;
        FreeAndNil(Fwd.Pairs);
      end;
      //
    end;
    //
    if (Lock<>nil) and (Lock<>Fwd.Lock) then begin
      LeaveCriticalSection(Lock^);
      DeleteCriticalSection(Lock^);
      LocalFree(THandle(Lock));
    end;
    //
    Result:=GenObj_Released(Fwd);
  end else
    Result:=Fwd.RefCount;
end;

function NetFwd_Lock(Fwd: PEvalForward): Boolean; //New191116
begin
  //!!! if (Fwd.?=?) -- validate
  //!!!
  if (Fwd.Lock<>nil) then
    EnterCriticalSection(Fwd.Lock^);
  Result:=True;
end;

function NetFwd_Unlock(Fwd: PEvalForward): Boolean; //New191116
begin
  //!!! if (Fwd.?=?) -- validate
  //!!!
  if (Fwd.Lock<>nil) then
    LeaveCriticalSection(Fwd.Lock^);
  Result:=True;
end;

function PrepareSelect(Sockets: PWOHandleArray; var Count: integer; var pfdRead,pfdWrite,pfdExcept: PFdSet; var MemToFree: Pointer): integer; //New191116
var i,Used,SetSize,idx: integer;
    H: THandle;
begin
  // returns count of sockets in sets...
  Used:=0;
  for i:=0 to Count-1 do begin
    if (Sockets[i]<>0) and (Sockets[i]<>INVALID_HANDLE_VALUE) then begin
      inc(Used);
      if (Used>=63) then
        break;
    end;
  end;
  //
  SetSize:=Longint(@PFdSet(nil).fd_array[Used+1]);
  MemToFree:=AllocMem(3*SetSize);
  //
  pfdRead:=MemToFree;
  pfdWrite:=Pointer(Longint(MemToFree)+SetSize);
  pfdExcept:=Pointer(Longint(MemToFree)+2*SetSize);
  //
  idx:=0;
  for i:=0 to Count-1 do begin
    H:=Sockets[i];
    if (H<>0) and (H<>INVALID_HANDLE_VALUE) then begin
      pfdRead.fd_array[idx]:=H;
      pfdWrite.fd_array[idx]:=H;
      pfdExcept.fd_array[idx]:=H;
      inc(idx);
      pfdRead.fd_Count:=idx;
      pfdWrite.fd_Count:=idx;
      pfdExcept.fd_Count:=idx;
      if (idx>=63) then
        break;
    end;
  end;
  Result:=idx;
end;

function SelectMulti(Sockets: PWOHandleArray; SocketCount: integer; Timeout: Longint): HResult; //New191116
var time: TTimeVal;
    lpTime: PTimeVal;
    Code,i,ThisCount,_0: Longint;
    Start,Expire: Cardinal;
    pfdRead,pfdWrite,pfdExcept: PFdSet;
    pfdMem: Pointer;
begin
  Result:=ERROR_TIMEOUT;
  //
  Start:=GetTickCount();
  pfdMem:=nil;
  //
  if (Timeout>0) then begin
    time.tv_sec:=Timeout div 1000;
    time.tv_usec:=(Timeout-(time.tv_sec*1000))*1000;
    lpTime:=@time;
    Expire:=Start+Cardinal(Timeout);
  end else
  if (Timeout=0) then begin
    _0:=0;
    time.tv_sec:=_0;
    time.tv_usec:=_0;
    lpTime:=@time;
    Expire:=Start+100;
  end else begin
    lpTime:=nil; // infinite...
    Expire:=Start+$10000000;
  end;
  //
  while (Longint(GetTickCount()-Expire)<0) do begin
    if (SocketCount<64) then begin
      // single wait:
      ThisCount:=PrepareSelect(Sockets,SocketCount,pfdRead,pfdWrite,pfdExcept,pfdMem);
      if (ThisCount>0) then begin
        Code:=select(ThisCount,pfdRead,pfdWrite,pfdExcept,lpTime);
        if (Code>0) then begin
          // something available...
          //!!! (result is now ignored...)
          
          Result:=0;
          exit;
        end else
        if (Code<0) then begin
          //!!! error...
        end;
      end;
    end else begin
      // Wait on each part alone...
      time.tv_sec:=0;
      time.tv_usec:=20000; // 20 msec
      lpTime:=@time;
      i:=0;
      while (SocketCount>0) do begin
        ThisCount:=SocketCount-i;
        if (ThisCount>62) then
          ThisCount:=62;
        if (ThisCount>0) then
          ThisCount:=PrepareSelect(@Sockets[i],ThisCount,pfdRead,pfdWrite,pfdExcept,pfdMem);
        if (ThisCount>0) then begin
          Code:=select(ThisCount,pfdRead,pfdWrite,pfdExcept,lpTime);
          if (Code>0) then begin
            // something available...
            //!!! (result is now ignored...)
            
            Result:=0;
            exit;
          end else
          if (Code<0) then begin
            //!!! error
          end;
        end;
        //
        inc(i,62);
        if (i>=SocketCount) then begin
          Sleep(20);
          i:=0;
          if (SocketCount<=0) then break;
        end;
      end;
    end;
  end;
  //
  if (pfdMem<>nil) then
    FreeMem(pfdMem);
  //
end;

function WBufAvail(const Buf: IStream): Longint; //New191116
var Info: ISocketStreamInfo;
    ECode: HResult;
begin
  // how to tell?
  Result:=0;
  //
  if (Buf.QueryInterface(guid_ISocketStreamInfo,Info)=0) then begin
    Result:=0;
    ECode:=Info.GetAvailSize(Result);
    if (ECode<0) and (Result<=0) then
      Result:=Result or -1;
  end;
end;

function NetFwd_TerminatePair(Fwd: PEvalForward; Pair: PFwdSockPair; bnWriteFault: Boolean): Boolean; //New191116
var Avail: Longint;
begin
  if bnWriteFault then begin
    FinitIntf(Pair.SendStream);
  end else begin
    FinitIntf(Pair.ReadStream);
  end;
  //
  if (Pair.ReadStream=nil)
  and (Pair.SendStream<>nil)
  and (Pair.WriteBuffer<>nil)
  then begin
    Avail:=WBufAvail(Pair.WriteBuffer);
    if (Avail<=0) then begin
      FinitIntf(Pair.WriteBuffer);
      FinitIntf(Pair.SendStream);
    end;
  end;
  //
  if (Pair.SendStream=nil) then begin
    //
    FinitIntf(Pair.ReadStream);
    FinitIntf(Pair.WriteBuffer);
    FinitIntf(Pair.Socket1);
    FinitIntf(Pair.Socket2);
    //
    Result:=True;
  end else
    Result:=False;
end;

function NetFwd_CheckForwardPair(Fwd: PEvalForward; Pair: PFwdSockPair; var ReadStm,WriteStm: IStream; Buffer: PByteArray; bnRecv: Boolean): Boolean; //New191116
var Info: ISocketStreamInfo;
    Avail,nRead,Rest,nWritten: Longint;
    ECode: HResult;
    pb: PByteArray;
    tv: TVarData;
Label _Error,_AskReadStreamInfo,_AvailErr;
begin
  Result:=False;
  //
  if (WriteStm=nil) then begin
    if bnRecv and (Pair.WriteBuffer=nil) then begin
      Eval_CreateNetPipe(nil,Pair.WriteBuffer,nil);
      if (@Pair.WriteBuffer<>@WriteStm) then
        WriteStm:=Pair.WriteBuffer;
    end else
    if not bnRecv and (Pair.SendStream=nil) then begin
      // finished, some data read, nowhere to write...
      FinitIntf(Pair.WriteBuffer);
      FinitIntf(Pair.ReadStream);
      NetFwd_TerminatePair(Fwd,Pair,True);
      //Result:=False;
      exit;
    end;
  end;
  //
  if not bnRecv
  and (WriteStm.QueryInterface(guid_ISocketStreamInfo,Info)=0)
  then begin
    ECode:=Info.IsReady(sir_Send);
    if (ECode<>0) and (ECode<>E_NOTIMPL) then begin
      Result:=False;
      exit;
    end;
  end;
  //
  if (Pair.ReadStream=nil) then begin
    //Result:=False;
    exit;
  end;
  //
  TdwVarData(tv).dwType:=TdwVarData(tv).dwType and 0;
  PArrayOfLongint(@tv)[3]:=0;
  if not bnRecv
  and (Pair.Socket1<>nil)
  then begin
    //
    if Pair.Socket1.GetProp('AvailSize',Variant(tv),nil)
    and (tv.VType>varEmpty)
    then begin
      if (tv.VType=varNull)
      or (tv.VType=varBoolean)
      then begin
        ECode:=PArrayOfLongint(@tv)[3];
        Avail:=0;
        if (ECode=0) then
          ECode:=E_NOTIMPL;
        goto _AvailErr;
      end else
      if not EvalVarToInt(Variant(tv),Avail) then
        goto _AskReadStreamInfo;
    end else
      goto _AskReadStreamInfo;
  end else begin
  _AskReadStreamInfo:
    if (ReadStm<>nil) and (ReadStm.QueryInterface(guid_ISocketStreamInfo,Info)=0) then begin
      Avail:=1536;
      ECode:=Info.GetAvailSize(Avail);
    _AvailErr:
      if (ECode<>E_NOTIMPL)
      and (ECode<>0)
      and ((ECode=WSAEWOULDBLOCK) or (ECode<0))
      then begin
        Result:=False;
        exit;
      end;
    end else begin
      // How to tell if this stream is ready?
      Avail:=1536;
    end;
  end;
  SetVarNull(Variant(tv));
  //
  if (Avail>1536) then
    Avail:=1536; // BufSize...
  //
  nRead:=0;
  ECode:=ReadStm.Read(Buffer,Avail,@nRead);
  if (ECode=0) then begin
    if (nRead=0) then begin
      // source closed...
      if (ReadStm=Pair.ReadStream) then
        FinitIntf(Pair.ReadStream)
      else
      // Pair.WriteBuffer will be released when empty and source closed...
      if (ReadStm=Pair.WriteBuffer) and (Pair.ReadStream=nil) then begin
        // no more receive, no more in buffer...
        FinitIntf(Pair.WriteBuffer);
        NetFwd_TerminatePair(Fwd,Pair,False);
      end;
      //
      Result:=False;
      exit;
    end;
  end;
  //
  if (nRead>0) then begin
    // something was read...
    if (WriteStm=nil) then begin
      if bnRecv and (Pair.WriteBuffer=nil) then begin
        Eval_CreateNetPipe(nil,Pair.WriteBuffer,nil);
        if (@Pair.WriteBuffer<>@WriteStm) then
          WriteStm:=Pair.WriteBuffer;
      end else
      if not bnRecv and (Pair.SendStream=nil) then begin
        // finished, some data read, nowhere to write...
        FinitIntf(Pair.WriteBuffer);
        FinitIntf(Pair.ReadStream);
        NetFwd_TerminatePair(Fwd,Pair,True);
        Result:=False;
        exit;
      end;
    end;
    //
    Rest:=nRead;
    pb:=Buffer;
    //
    while (Rest>0) do begin
      //
      if (Pair.SendStream=nil) then begin
        NetFwd_TerminatePair(Fwd,Pair,True);
        Result:=False;
        exit;
      end;
      //
      nWritten:=0;
      ECode:=Pair.SendStream.Write(pb,Rest,@nWritten);
      if (nWritten>0) then begin
        pb:=@pb[nWritten];
        dec(Rest,nWritten);
      end else begin
        // some error...
        if (ECode=0) then
          ECode:=GetLastError();
        // terminate pair channel...
        NetFwd_TerminatePair(Fwd,Pair,True); // if cannot write
        goto _Error;
      end;
    end;
    Result:=True;
  end else
  if (ECode<>0) and (ECode<>WSAEWOULDBLOCK) and (ECode<>ERROR_IO_PENDING) and (ECode<>E_PENDING) then begin
    // some error...
    // terminate read channel...
    NetFwd_TerminatePair(Fwd,Pair,not bnRecv);
  _Error:
    if (Pair.Signature=cFwdPairSign) then begin
      Pair.LastError:=ECode;
      //??? NetFwd_TerminatePair just above...
    end;
  end;
end;

function NetFwd_CheckReadSockPair(Fwd: PEvalForward; Pair: PFwdSockPair; Buffer: PByteArray): Boolean; //New191116
begin
  Result:=NetFwd_CheckForwardPair(Fwd,Pair,Pair.ReadStream,Pair.WriteBuffer,Buffer,True);
end;

function NetFwd_CheckWriteSockPair(Fwd: PEvalForward; Pair: PFwdSockPair; Buffer: PByteArray): Boolean; //New191116
begin
  Result:=NetFwd_CheckForwardPair(Fwd,Pair,Pair.WriteBuffer,Pair.SendStream,Buffer,False);
end;

function NetFwd_PerformThread(Fwd: PEvalForward): HResult; //New191116
var bImmed: Byte;
    WaitList: TList;
    i: integer;
    Pair: PFwdSockPair;
    When: Cardinal;
    Buffer: PByteArray;
begin
  bImmed:=0;
  //
  Buffer:=AllocMem(1536+64); // =3*512 + 64 reserved, MTU=1500 ...
  WaitList:=TList.Create;
  try
    //
    while not Fwd.bnTerminate do begin
      try
        // Wait some select ready:
        When:=GetTickCount();
        //
        NetFwd_Lock(Fwd);
        try
          WaitList.Clear;
          if (Fwd.Pairs<>nil) then
            for i:=0 to Fwd.Pairs.Count-1 do begin
              Pair:=Fwd.Pairs[i];
              //
              if (Pair.hRecv<>0) and (Pair.hRecv<>INVALID_HANDLE_VALUE)
              and (WaitList.IndexOf(Pointer(Pair.hRecv))<0)
              then
                WaitList.Add(Pointer(Pair.hRecv));
              //
              if (Pair.hSend<>0) and (Pair.hSend<>INVALID_HANDLE_VALUE)
              and (WaitList.IndexOf(Pointer(Pair.hSend))<0)
              then
                WaitList.Add(Pointer(Pair.hSend));
            end;
          //
        finally
          NetFwd_Unlock(Fwd);
        end;
        //
        if (WaitList.Count>0) then begin
          // select()
          SelectMulti(PWOHandleArray(WaitList.List),WaitList.Count,2000);
        end;
        //
        if ((GetTickCount()-When)<20) and (bImmed<$F8) then
          inc(bImmed,4); // in case of immediate error in Select(), sleep some time below...
        //
        // copy ReadStream->WriteBuffer where ready
        i:=0;
        while (i<Fwd.Pairs.Count) do begin
          if NetFwd_CheckReadSockPair(Fwd,Fwd.Pairs[i],Buffer) then
            bImmed:=0; // in case of anything transfered, do not block...
          //
          inc(i);
        end;
        //
        // copy WriteBuffer->SendStream where available and not jamming (jamming = full write-cache buffer, slow send...)
        i:=0;
        while (i<Fwd.Pairs.Count) do begin
          if NetFwd_CheckWriteSockPair(Fwd,Fwd.Pairs[i],Buffer) then
            bImmed:=0; // in case of anything transfered, do not block...
          //
          inc(i);
        end;
        //
        if (bImmed>=2*Fwd.Pairs.Count) then begin
          Sleep(20);
          //dec(bImmed);
        end;
        if (bImmed>0) then
          dec(bImmed);
        //
      except
        LogException(TObject(Fwd),'NetFwd');
      end;
      //
      //Sleep(10); // this would limit speed to 150kb/s ... 100*1500 bytes per second...
    end;
    //
  finally
    WaitList.Free;
    FreeMem(Buffer);
  end;
  //
  Result:=0;
end;

procedure NetFwd_Finishing(Fwd: PEvalForward); //New191116
var Thid: Cardinal;
    H: THandle;
begin
  // forward-thread is finishing...
  Thid:=GetCurrentThreadId();
  if (Fwd.idThread=Thid) then begin
    NetFwd_Lock(Fwd);
    try
      if (Fwd.idThread=Thid) then begin
        //
        H:=Fwd.hThread;
        Fwd.hThread:=0;
        if (H<>0) then
          CloseHandle(H);
        //
        // what else close now ?
      end;
      //
    finally
      NetFwd_Unlock(Fwd);
    end;
  end;
end;

function NetFwd_ThreadProc(aParam: Pointer): Longint; //New191116
var Fwd: PEvalForward;
begin
  //Result:=0;
  //
  try
    try
      Fwd:=aParam;
      //
      Result:=NetFwd_PerformThread(Fwd);
      //
    finally
      Fwd:=aParam;
      NetFwd_Finishing(Fwd);
    end;
  except
    // Main thread catcher...
    Result:=E_FAIL;
    try
      LogException(nil,'NetFwd_Thread');
    except ; end;
  end;
  //
end;

function NetFwd_CheckStarted(Fwd: PEvalForward): Boolean; //New191116
var ExCode: Cardinal;
    H: THandle;
begin
  // called inside NetFwd_Lock(Fwd) ...
  //
  if (Fwd.hThread<>0) then begin
    if GetExitCodeThread(Fwd.hThread,ExCode) then begin
      if (ExCode=STILL_ACTIVE) then begin
        // still running...
        Result:=True;
        exit;
      end;
      // valid thread, terminated...
      H:=Fwd.hThread;
      Fwd.hThread:=0;
      CloseHandle(H);
    end else begin
      // invalid handle...
      Fwd.hThread:=0;
      Fwd.idThread:=0;
    end;
  end;
  //
  //if (Fwd.hThread=0) then
  begin
    Fwd.hThread:=BeginThread(nil,0,NetFwd_ThreadProc,Fwd,CREATE_SUSPENDED,Fwd.idThread);
    if (Fwd.hThread<>0) then begin
      ResumeThread(Fwd.hThread);
      Result:=True;
      exit;
    end;
    // Failed to start thread?
    Result:=False;
  end;
end;

procedure NetFwd_FreePair(Pair: PFwdSockPair); //New191116
begin
  if (Pair.Signature=cFwdPairSign) then begin
    Pair.Signature:=INVALID_HANDLE_VALUE-1;
    Finalize(Pair^); // release streams, write-buffer and sockets...
    FreeMem(Pair);
  end;
end;

function NetFwd_AddPair(Fwd: PEvalForward; Params: PObjCallParams; MaxSize: Int64; const Opts: IEvalObj): Boolean; //New191116 //zmena191126: +MaxSize
var Pair1,Pair2: PFwdSockPair;
    qw: LARGE_INTEGER;
begin
  // add Params.TempObj,Params.TempObj2 pair...
  Result:=False;
  Pair1:=AllocMem(SizeOf(TFwdSockPair));
  Pair2:=AllocMem(SizeOf(TFwdSockPair));
  Pair1.Signature:=cFwdPairSign;
  Pair2.Signature:=cFwdPairSign;
  //New191126
  if (MaxSize>0) then begin
    Pair1.RestSize.QuadPart:=MaxSize;
    Pair2.RestSize.QuadPart:=MaxSize;
  end else begin
    Pair1.RestSize.HighPart:=$10000000;
    Pair2.RestSize.HighPart:=$10000000;
    Pair1.RestSize.LowPart:=0;
    Pair2.RestSize.LowPart:=0;
  end;
  //New191126b
  if (Opts<>nil) then begin
    Opts.QueryInterface(guid_IEvalObj,Pair1.Options);
    Pair2.Options:=Pair1.Options;
  end;
  //
  if (Params.TempObj<>nil)
  and (Params.TempObj2<>nil)
  and (Params.TempObj<>Params.TempObj2)
  //and (Params.TempObj.QueryInterface(guid_IStream,Pair.ReadStream)=0)
  //and (Params.TempObj2.QueryInterface(guid_IStream,Pair.SendStream)=0)
  then begin
    //
    Pair1.Socket1:=IEvalObj(Params.TempObj);
    Pair1.Socket2:=IEvalObj(Params.TempObj2);
    //
    Pair2.Socket1:=IEvalObj(Params.TempObj2);
    Pair2.Socket2:=IEvalObj(Params.TempObj);
    //
    if GetObjProp(Pair1.Socket1,'RecvStream',Variant(Params.TempVar)) then
      VarQueryInterface(Variant(Params.TempVar),guid_IStream,Pair1.ReadStream);
    if (Pair1.ReadStream=nil) then
      Pair1.Socket1.QueryInterface(guid_IStream,Pair1.ReadStream); // can read from file/stream...
    //
    if GetObjProp(Pair1.Socket2,'SendStream',Variant(Params.TempVar)) then
      VarQueryInterface(Variant(Params.TempVar),guid_IStream,Pair1.SendStream);
    if (Pair1.SendStream=nil) then
      Pair1.Socket2.QueryInterface(guid_IStream,Pair1.SendStream); // can write to file/stream...?
    //
    if GetObjProp(Pair2.Socket2,'RecvStream',Variant(Params.TempVar)) then
      VarQueryInterface(Variant(Params.TempVar),guid_IStream,Pair2.ReadStream);
    if (Pair2.ReadStream=nil) then
      Pair2.Socket2.QueryInterface(guid_IStream,Pair2.ReadStream); // can read from file/stream...
    //
    if GetObjProp(Pair2.Socket1,'SendStream',Variant(Params.TempVar)) then
      VarQueryInterface(Variant(Params.TempVar),guid_IStream,Pair2.SendStream);
    if (Pair2.SendStream=nil) then
      Pair2.Socket1.QueryInterface(guid_IStream,Pair2.SendStream); // can write to file/stream...?
    //
    // will not short-circuit it...
    if (Pair1.ReadStream=nil)
    or (Pair1.SendStream=nil)
    or (Pair2.ReadStream=nil)
    or (Pair2.SendStream=nil)
    or (Pair1.ReadStream=Pair1.SendStream)
    or (Pair1.ReadStream=Pair2.ReadStream)
    or (Pair1.ReadStream=Pair2.SendStream)
    or (Pair2.ReadStream=Pair2.SendStream)
    //or (Pair2.ReadStream=Pair1.ReadStream) == (Pair1.ReadStream=Pair2.ReadStream)
    or (Pair2.ReadStream=Pair1.SendStream)
    or (Pair2.ReadStream=Pair2.SendStream)
    then begin
      // streams missing...
      //goto _Invalid;
      NetFwd_FreePair(Pair1);
      NetFwd_FreePair(Pair2);
      SetVarBool(Params.lpResVar^,False);
      Result:=True;
      exit;
    end;
    //
    if GetObjProp(Pair1.Socket1,'Handle',Variant(Params.TempVar))
    //and (Params.TempVar.VType>varNull)
    then begin
      if EvalVarToInt64(Variant(Params.TempVar),qw.QuadPart)
      and (qw.LowPart<>0)
      then begin
         Pair1.hRecv:=qw.LowPart;
         Pair2.hSend:=qw.LowPart;
      end;
    end;
    //
    if GetObjProp(Pair1.Socket2,'Handle',Variant(Params.TempVar))
    //and (Params.TempVar.VType>varNull)
    then begin
      if EvalVarToInt64(Variant(Params.TempVar),qw.QuadPart)
      and (qw.LowPart<>0)
      then begin
         Pair2.hRecv:=qw.LowPart;
         Pair1.hSend:=qw.LowPart;
      end;
    end;
    //
    NetFwd_Lock(Fwd);
    try
      // Add pairs to list:
      if (Fwd.Pairs=nil) then
        Fwd.Pairs:=TList.Create;
      Fwd.Pairs.Add(Pair1);
      Fwd.Pairs.Add(Pair2);
      //
      // Check to start thread:
      NetFwd_CheckStarted(Fwd);
      //
    finally
      NetFwd_Unlock(Fwd);
    end;
    //
    Result:=True;
  end;
end;

function NetFwd_Add(Params: PObjCallParams): Boolean; //New191116
var Fwd: PEvalForward;
    Args: PEvalNode;
    MaxSize: Int64;
    Opts: Pointer;
begin
  //* Forward.Add(Socket1,Socket2,?MaxSize~Options)
  //* new SockForward(Socket1,Socket2,?MaxSize~Options)
  Result:=False;
  if EvalNodeObj(Params.Args,Params.TempObj)
  and EvalNodeObj(Params.Args.Next,IEvalObj(Params.TempObj2)) //zmena191126: +Next
  then begin
    //New191126
    Opts:=nil;
    MaxSize:=-1;
    Args:=Params.Args.Next.Next;
    if (Args<>nil) then begin
      if not EvaluateNode(Variant(Params.TempVar),Args) then
        exit;
      if (Params.TempVar.VType in [varSmallint..varCurrency,$10..$14]) then
        EvalVarToInt64(Variant(Params.TempVar),MaxSize)
      else
      if (Opts=nil) and (Params.TempVar.VType=varUnknown) then begin
        EvalVarToObj(Variant(Params.TempVar),IEvalObj(Opts));
      end;
    end;
    //
    Fwd:=Params.Self;
    NetFwd_AddPair(Fwd,Params,MaxSize,IEvalObj(Opts)); //zmena191126: +MaxSize,Opts
    Result:=Ocpi_RetSelf(Params);
  end;
end;

function NetFwd_Remove2(Fwd: PEvalForward; Item: Pointer): Boolean; //New191116
var i: integer;
    Pair: PFwdSockPair;
begin
  Result:=False;
  if (Item=nil) then
    exit;
  //
  NetFwd_Lock(Fwd);
  try
    if (Fwd.Pairs<>nil) then begin
      i:=Fwd.Pairs.Count;
      while (i>0) do begin
        dec(i);
        Pair:=Fwd.Pairs.List[i];
        if (Pointer(Pair.Socket1)=Item)
        or (Pointer(Pair.Socket2)=Item)
        or (Pointer(Pair.ReadStream)=Item)
        or (Pointer(Pair.SendStream)=Item)
        then begin
          Result:=True;
          Fwd.Pairs.Delete(i);
          //
          FinitIntf(Pair.ReadStream);
          FinitIntf(Pair.SendStream);
          if NetFwd_TerminatePair(Fwd,Pair,False) and (Pair.Signature=cFwdPairSign) then begin
            Pair.Signature:=Pair.Signature and 0;
            FreeMem(Pair);
          end;
          //
        end;
      end;
    end;
  finally
    NetFwd_Unlock(Fwd);
  end;
end;

function NetFwd_Remove(Params: PObjCallParams): Boolean; //New191116
var bnFound: Boolean;
begin
  //* Forward.Remove(Socket) -- stop forwarding on that pair...
  Result:=False;
  if EvaluateNode(Variant(Params.TempVar),Params.Args) then begin
    Result:=True;
    bnFound:=NetFwd_Remove2(Params.Self,Params.TempVar.VPointer);
    SetVarBool(Params.lpResVar^,bnFound);
  end;
end;

function Vmt_SockForward(): Pointer;
asm
  mov  eax,offset @Vmt
  ret
  nop
  nop
  //New191116
  dd 0
@Vmt:
  // IUnknown
  dd GenObj_QueryInterface
  dd GenObj_AddRef
  dd @Release
  // IEvalObj
  dd @CallFunc    // -> CallDesc
  dd @GetProp     // -> GetPropDesc
  dd @SetProp     // -> SetPropDesc
  dd GenObj_Control
  dd 0
  db 'Forward',0
  //
@CallDesc:
  // short format:
  dd -1,0,GenObj_CallDesc
  dd @Add
  dd NetFwd_Add
  dd @Remove
  dd NetFwd_Remove
  dd @CreateParams
  dd NetFwd_Add
  dd 0
  //
@GetPropDesc:
  // short format:
  dd -1,0,GenObj_GetPropDesc
  dd 0
  //
@SetPropDesc:
  // short format:
  dd -1,0,GenObj_SetPropDesc
  dd 0
  //
@Add: db 3,'Add',0
@Remove: db 6,'Remove',0
@CreateParams: db 12,'CreateParams',0
  //
@Release: // [esp+4]=Self
  mov  eax,[esp+4]
  or   edx,-1
  lock xadd [eax].TEvalGenObj.RefCount,edx
  dec  edx
  jz   NetFwd_Released // is stdcall...
  mov  eax,edx
  retn 4
  //
@CallFunc: // eax=Self, edx=FuncName, ecx=ResVar, [esp+4]=Args
  call GenObj_CallFunc_Prefix // FuncNode from this.Props ?
  push offset @CallDesc
  jmp  ObjMethodCall
  //
@GetProp: // eax=Self, edx=PropName, ecx=ResVar, [esp+4]=IndexArg
  test edx,edx
  jz   @gp0
  call GenObj_GetProp_Prefix // from this.Props takes precedence...
  push offset @GetPropDesc
  jmp  ObjMethodCall
@gp0:
  // (PropName='')
  cmp  dword ptr [esp+4],0 // IndexArg?
  jnz  @gp0_index
  //mov  edx,offset @szValue
  //jmp  @GetProp
  xor  eax,eax
  retn 4
  //
@gp0_index:
  // (PropName=''), (IndexArg<>nil)
  mov  edx,[esp+4]
  call GenObj_Get0Prop_Index
  retn 4
  //
@SetProp: // eax=Self, edx=PropName, ecx=Value, [esp+4]=IndexArg
  test edx,edx
  jz   @sp0
  push offset @SetPropDesc
  jmp  ObjMetSetProp
@sp0:
  // (PropName='')
  cmp  dword ptr [esp+4],0 // IndexArg?
  jnz  @sp0_index //! ByteArray_Set0Prop_Index //GenObj_SetProp_Fallback2
  // (PropName=''), (IndexArg=nil) -- SetProp('Value',Value,nil)
  //mov  edx,offset @szValue
  //jmp  @SetProp
  xor  eax,eax
  retn 4
@sp0_index:
  mov  edx,[esp+4]
  call GenObj_Set0Prop_Index
  retn 4
  //
end;

function Eval_CreateForward(Arg: Pointer; out Obj: IEvalObj; Params: PEvalNode): Boolean;
var Fwd: PEvalForward;
    tvRes: TVarData;
begin
  //* new SockForward(Socket1,Socket2,?MaxSize~Options)  -- probably not tested...
  //New191116
  Fwd:=AllocMem(SizeOf(TEvalForward));
  Fwd.Vmt:=Vmt_SockForward();
  //
  inc(Fwd.RefCount);
  Pointer(Obj):=Fwd;
  //
  GenObj_InitProto(Fwd);
  //
  Fwd.Lock:=Pointer(LocalAlloc(LPTR,SizeOf(TRtlCriticalSection)));
  InitializeCriticalSection(Fwd.Lock^);
  //
  if (Params<>nil) then begin
    TdwVarData(tvRes).dwType:=TdwVarData(tvRes).dwType and 0;
    IEvalObj(Fwd).CallFunc('CreateParams',Variant(tvRes),Params);
    SetVarNull(Variant(tvRes));
  end;
  //
  Result:=True;
end;

//-----------------------

function NetPipe_Released(Pipe: PNetPipe): Longint; stdcall; //New191116
var Base: PListEntry;
    Desc: PNetPipeBufDesc;
begin
  if (Pipe.RefCount=0) then begin
    //
    FinitIntf(Pipe.EStream);
    NplClear(Pipe.Props);
    //
    // Free buffers:
    Base:=@Pipe.Buffers;
    if (Base.FLink<>nil) and (Base.FLink<>Base) then begin
      Base.BLink:=nil;
      Desc:=Pointer(Base.FLink);
      while (Desc<>nil) do begin
        Base.FLink:=Pointer(Desc.Next);
        FreeMem(Desc.Buffer);
        FreeMem(Desc);
        Desc:=Pointer(Base.FLink);
      end;
    end;
    //
    //Result:=GenObj_Released(Pipe);
    Pipe.Vmt:=nil;
    FreeMem(Pipe);
    //
    Result:=0;
  end else
    Result:=Pipe.RefCount;
end;

type
  PIStreamCopyToParams=^TIStreamCopyToParams;
  TIStreamCopyToParams=packed record case Byte of
  0: (
    Helper:        PEvalGenHelper; // using Helper.Target
    Dst:           Pointer; //IStream;
    cb:            LARGE_INTEGER;
    pcbRead:       PLARGE_INTEGER;
    pcbWritten:    PLARGE_INTEGER;
  );
  1: ( //New191114 - any other IStream type...
    Self:          Pointer;
    //...
  );
  end;

function NetPipe_StreamCopyTo(Params: PIStreamCopyToParams): HResult; register; //New191116
begin
  //!!!
end;

function NetPipe_MakeEStream(Pipe: PNetPipe): HResult; register; //New191116
begin
  if (Pipe.EStream=nil) then begin
    if CreateEvalStream(IStream(Pipe),guid_IEvalObj,Pipe.EStream)
    and (Pipe.EStream<>nil)
    then
      Result:=0
    else
      Result:=MK_E_NOOBJECT;
  end else begin
    Result:=0;
  end;
end;

function Vmt_NetPipe(): Pointer; //New191116
asm
  mov eax,offset @Vmt_IStream
  ret
  nop
  nop
  //
  dd 0
@Vmt_IStream:
  // IUnknown
  dd @QueryInterface
  dd GenObj_AddRef
  dd @Release
  // ISequentialStream:
  dd NetPipe_Read //@is_Read          // function Read(DataPipe; pv: Pointer; cb: Longint; pcbRead: PLongint): HResult; stdcall;
  dd NetPipe_Write //@is_Write         // function Write(DataPipe; pv: Pointer; cb: Longint; pcbWritten: PLongint): HResult; stdcall;
  // IStream
  dd @is_Seek          // function Seek(DataPipe; dlibMove: Largeint; dwOrigin: Longint; out libNewPosition: Largeint): HResult; stdcall;
  dd @is_SetSize       // function SetSize(DataPipe; libNewSize: Largeint): HResult; stdcall;
  dd @is_CopyTo        // function CopyTo(DataPipe; stm: IStream; cb: Largeint; out cbRead: Largeint; out cbWritten: Largeint): HResult; stdcall;
  dd @is_Commit        // function Commit(DataPipe; grfCommitFlags: Longint): HResult; stdcall;
  dd @is_Revert        // function Revert(DataPipe): HResult; stdcall;
  dd @is_LockRegion    // function LockRegion(DataPipe; libOffset: Largeint; cb: Largeint; dwLockType: Longint): HResult; stdcall;
  dd @is_UnlockRegion  // function UnlockRegion(DataPipe; libOffset: Largeint; cb: Largeint; dwLockType: Longint): HResult; stdcall;
  dd @is_Stat          // function Stat(DataPipe; out statstg: TStatStg; grfStatFlag: Longint): HResult; stdcall;
  dd @is_Clone         // function Clone(DataPipe; out stm: IStream): HResult; stdcall;
  // IRefStream
  dd @is_IsLastRef     // function(DataPipe; const EStm: IEvalObj): Longint; stdcall;
  dd 0
  db 'Pipe',0,0,0,0
  //
@qi_def:
  dd offset guid_IStream,          @qi_this
  dd offset guid_IRefStream,       @qi_this
  dd offset guid_IUnknown,         @qi_this
  dd offset guid_ISequentialStream,@qi_this
  dd offset guid_IEvalObj,         @qi_IEvalObj
  dd 0,ENoInterface_rb12
  //
@QueryInterface:
  // [esp+4]=[ebp+8]=Self, [esp+8]=[ebp+12]=Guid, [esp+12]=[ebp+16]=^Out
  push ebp
  mov  ebp,esp
  //
@qi2:
  mov  eax,offset @qi_def
  call QiMultiInternal
  jmp  eax
  //
@qi_this:
  // this interface... (also used in Helper objects...)
  mov  eax,[ebp+8]
  push eax
  mov  eax,[eax]
  call [eax].TIUnknownVmt.AddRef
  //
  mov  eax,[ebp+8]
@qi_retEax:
  mov  ecx,[ebp+16]
  mov  [ecx],eax
  xor  eax,eax
@rb12:
  mov  esp,ebp
  pop  ebp
  retn 12
  //
@qi_IEvalObj: // [ebp+8]=Self
  mov  eax,[ebp+8]
  mov  edx,[eax].TNetPipe.EStream
  test edx,edx
  jz   @make_EStream
  mov  [ebp+8],edx
  jmp  @qi_this
@make_EStream:
  call NetPipe_MakeEStream
  test eax,eax
  jz   @qi_IEvalObj
  //
  jmp  @rb12
  //
@Release: // [esp+4]=Self
  mov  eax,[esp+4]
  or   edx,-1
  lock xadd [eax].TEvalGenObj.RefCount,edx
  dec  edx
  jz   NetPipe_Released // is stdcall...
  mov  eax,edx
  retn 4
  //
  // ---- IStream ----
//@is_Read:          // function Read(DataPipe; pv: Pointer; cb: Longint; pcbRead: PLongint): HResult; stdcall;
//  //                               [esp+4]   [esp+8]      [esp+12]      [esp+16]          ->EAX
//  //                               TDpStreamIoParams
//  lea  eax,[esp+4]
//  call DataPipe_StreamRead
//  retn 16
//  //
//@is_Write:         // function Write(DataPipe; pv: Pointer; cb: Longint; pcbWritten: PLongint): HResult; stdcall;
//  //                                TDpStreamIoParams
//  lea  eax,[esp+4]
//  call DataPipe_StreamWrite
//  retn 16
//  //
@is_Seek:          // function Seek(DataPipe; dlibMove: Largeint; dwOrigin: Longint; out libNewPosition: Largeint): HResult; stdcall;
  //                               [esp+4]    [esp+8]             [esp+16]               [esp+20]
  // libNewPosition^:=Pipe.Size; return 0;
  mov  eax,[esp+4]
  mov  eax,[eax].TNetPipe.Size
  mov  edx,[esp+20]
  mov  [edx],eax
  and  dword ptr [edx+4],0
  //
  xor  eax,eax
  retn 20
  //
@is_CopyTo:        // function CopyTo(DataPipe; stm: IStream; cb: Largeint; out cbRead: Largeint; out cbWritten: Largeint): HResult; stdcall;
  lea  eax,[esp+4]
  call NetPipe_StreamCopyTo
  retn 24
  //
@is_Commit:        // function Commit(DataPipe; grfCommitFlags: Longint): HResult; stdcall;
  xor eax,eax
  retn 8
  //
@is_Revert:        // function Revert(DataPipe): HResult; stdcall;
  mov  eax,E_NOTIMPL
  retn 4
  //
@is_Clone:         // function IStream.Clone(DataPipe; out stm: IStream): HResult; stdcall;
  //                                        [esp+4]       [esp+8]       ->EAX
  mov  eax,E_NOTIMPL
@is_Clone_out:
  retn 8
  //
@is_SetSize:       // function SetSize(DataPipe; libNewSize: Largeint): HResult; stdcall;
  //
  mov  eax,E_NOTIMPL
  retn 12
  //
@lb_LockRegion:    // function ILockBytes.LockRegion(Unk: Pointer; libOffset: Largeint; cb: Largeint; dwLockType: Longint): HResult; stdcall;
@lb_UnlockRegion:  // function ILockBytes.UnlockRegion(Unk: Pointer; libOffset: Largeint; cb: Largeint; dwLockType: Longint): HResult; stdcall;
@is_LockRegion:    // function IStream.LockRegion(Helper; libOffset: Largeint; cb: Largeint; dwLockType: Longint): HResult; stdcall;
@is_UnlockRegion:  // function IStream.UnlockRegion(Helper; libOffset: Largeint; cb: Largeint; dwLockType: Longint): HResult; stdcall;
  mov  eax,E_NOTIMPL // ~ 0; ?
  retn 24
  //
@lb_Stat:          // function ILockBytes.Stat(Unk: Pointer; out statstg: TStatStg; grfStatFlag: Longint): HResult; stdcall;
@is_Stat:          // function IStream.Stat(Helper; out statstg: TStatStg; grfStatFlag: Longint): HResult; stdcall;
  //!!! we could return Size, +FileName from Props?
  //? 
  mov  eax,E_NOTIMPL
  retn 12
  //
  // IRefStream.IsLastRef(EvalStream) : Longint; stdcall;
@is_IsLastRef: // [esp+4]=Self, [esp+8]=EStream
  mov  eax,[esp+4]
  mov  edx,[esp+8]
  cmp  edx,[eax].TNetPipe.EStream
  jne  @diff_LastRef
  // EStream was released... if Pipe has single ref, it is from EStream, can release both...
  cmp  [eax].TNetPipe.RefCount,1
  jle  @was_LastRef
@diff_LastRef:
  mov  eax,[eax].TNetPipe.RefCount
  retn 8
  //
@was_LastRef:
  // FinitIntf(Pipe.EStream) -- this releases both objects...
  lea  eax,[eax].TNetPipe.EStream
  call FinitIntf
  //
  xor  eax,eax
  retn 8
end;

function Eval_CreateNetPipe(Arg: Pointer; out Obj: IStream; Params: PEvalNode): Boolean; //New191116
var Pipe: PNetPipe;
    Base: PListEntry;
begin
  //* new NetPipe  -- not available, creaetes IStream, not tested...
  //* new NetPipe(?Capacity=16384)
  Pipe:=AllocMem(SizeOf(TNetPipe));
  Pipe.Vmt:=Vmt_NetPipe();
  //
  inc(Pipe.RefCount);
  Pointer(Obj):=Pipe;
  //
  Base:=@Pipe.Buffers;
  Base.FLink:=Base;
  Base.BLink:=Base;
  //
  Pipe.Capacity:=16384;
  //
  if (Params<>nil) then
    EvalNodeInt(Params,Pipe.Capacity);
  //
  GenObj_InitProto(Pipe);
  //
  Result:=True;
end;

function NetPipe_NewWriteBuf(Pipe: PNetPipe): HResult; //New191116
var Desc: PNetPipeBufDesc;
    BufSize: integer;
    Base: PListEntry;
begin
  // Pipe WriteBuffer is full or missing...
  Desc:=AllocMem(SizeOf(TNetPipeBufDesc));
  if (Pipe.Size<1024) then
    BufSize:=256
  else
    BufSize:=1024;
  //
  Desc.BufSize:=BufSize;
  Desc.Buffer:=AllocMem(BufSize);
  //
  Base:=@Pipe.Buffers;
  if (Base.BLink=nil) then begin
    // InitializeListHead(@Pipe.Buffers);
    Base.FLink:=Base;
    Base.BLink:=Base;
  end;
  //
  Desc.Next:=Base.BLink;
  Base.BLink.FLink:=Pointer(Desc);
  Base.BLink:=Pointer(Desc);
  //
  Result:=0;
end;

function NetPipe_Write(Pipe: PNetPipe; Buffer: Pointer; Size: Longint; pcbWritten: PLongint): HResult; stdcall; //New191116
asm //                [ebp+8]         [ebp+12]         [ebp+16]       [ebp+20]
  // D5-auto: push ebp; mov ebp,esp
  push edi
  push esi
  push 0 // Temp
  //
  mov  eax,[ebp+20]
  test eax,eax
  jnz  @pcb_ok
  mov  [ebp+20],esp // if (!pcbWritten) pcbWritten:=@Temp;
@pcb_ok:
  and  dword ptr [eax],0 // pcbWritten^:=0;
  //
  mov  eax,[ebp+16]
  test eax,eax
  jle  @no_size
  //
@WriteToLastBuf:
  mov  eax,[ebp+8]
  // check Pipe.Size < Pipe.Capacity
  mov  edx,[eax].TNetPipe.Size
  cmp  edx,[eax].TNetPipe.Capacity
  jge  @pipe_full
  //
  // WriteBuffer:
  lea  ecx,[eax].TNetPipe.Buffers.BLink // WriteBuffer
  mov  edx,[ecx]
  test edx,edx
  jz   @no_buf
  cmp  edx,ecx
  je   @no_buf
  //
  movzx ecx,[edx].TNetPipeBufDesc.BufSize
  movzx edi,[edx].TNetPipeBufDesc.WriteOffset
  //
  sub  ecx,edi // AvailSize:=BufSize-WriteOffset;
  jle  @buf_full
  //
  cmp  ecx,[ebp+16] // Size?
  jle  @size_ok
  mov  ecx,[ebp+16]
@size_ok:
  mov  eax,ecx
  //
  add  edi,[edx].TNetPipeBufDesc.Buffer
  mov  esi,[ebp+12] // Buffer
  cmp  ecx,8
  jbe  @small
  push ecx
  shr  ecx,2
  rep  movsd
  pop  ecx
  and  ecx,3
@small:
  rep movsb
  //
  add  [ebp+12],eax // inc(Buffer,CopySize)
  mov  edx,[ebp+20] // pcbWritten
  add  [edx],eax // inc(pcbWritten^,CopySize)
  mov  eax,[ebp+8] // Pipe
  add  [eax].TNetPipe.Size,eax // inc(Pipe.Size,CopySize)
  sub  [ebp+16],eax // dec(Size,CopySize)
  jg   @next_buf // more space needed?
  //
  // return S_OK;
  xor  eax,eax
  jmp  @done
  //
@pipe_full:
  cmp  [eax].TNetPipe.Capacity,0
  je   @pipe_closed
  //
  mov  eax,WSAEWOULDBLOCK
  jmp  @done
@pipe_closed:
  mov  eax,WSAENETRESET // source closed, cannot write more from this source...
  jmp  @done
  //
@no_size:
  jl   @invalid_size
  xor  eax,eax
  jmp  @done
@invalid_size:
  mov  eax,E_INVALIDARG
  jmp  @done
  //
@buf_full:
@next_buf:
@no_buf:
  // need another buffer...
  mov  eax,[ebp+8]
  call NetPipe_NewWriteBuf
  //
  test eax,eax
  jz   @WriteToLastBuf
  //
@done:
  pop  edx
  pop  esi
  pop  edi
  // D5-auto: pop ebp; retn 16;
end;

procedure NetPipe_FreeBufDesc(Desc: PNetPipeBufDesc); //New191116
var P: Pointer;
begin
  if (Desc<>nil) and (Desc.Next=nil) then begin
    P:=Desc.Buffer;
    Desc.Buffer:=nil;
    if (P<>nil) then
      FreeMem(P);
    FreeMem(Desc);
  end;
end;

type
  PStmIoArgs=^TStmIoArgs;
  TStmIoArgs=record
    Self:          Pointer;
    Buffer:        Pointer;
    Size:          Longint;
    pcbRead:       PLongint;
  end;

function NetPipe_InternalRead(Params: PStmIoArgs; bnRead: Boolean): HResult; register; //New191116
asm //                        EAX->ebx            EDX             ->EAX
  // both Read and Peek...
  push ebx // [ebp-4]
  push edi // [ebp-8]
  push esi // [ebp-12]
  push edx // bnRead at [ebp-16]
  push 0 // Temp
  //
  mov  ebx,eax
  //
  mov  eax,[ebx].TStmIoArgs.pcbRead
  test eax,eax
  jnz  @pcb_ok
  mov  eax,esp // ^Temp
  mov  [ebx].TStmIoArgs.pcbRead,eax
@pcb_ok:
  and  dword ptr [eax],0 // pcbRead^:=0;
  //
@ReadFromLastBuffer:
  mov  eax,[ebx].TStmIoArgs.Self
  lea  ecx,[eax].TNetPipe.Buffers.FLink // ReadBuffer
  mov  edx,[ecx]
  test edx,edx
  jz   @no_bufs
  cmp  edx,ecx
  je   @no_bufs
  //
@ReadFromThisBuf:
  movzx ecx,[edx].TNetPipeBufDesc.WriteOffset
  movzx esi,[edx].TNetPipeBufDesc.ReadOffset
  sub  ecx,esi // AvailSize:=WriteOffset-ReadOffset
  jle  @buf_done
  add  esi,[edx].TNetPipeBufDesc.Buffer
  //
  cmp  ecx,[ebx].TStmIoArgs.Size
  jle  @size_ok
  mov  ecx,[ebx].TStmIoArgs.Size
@size_ok:
  //
  mov  eax,ecx
  mov  edi,[ebx].TStmIoArgs.Buffer
  //cmp  ecx,8
  //jb   @small
  push ecx
  shr  ecx,2
  rep  movsd
  pop  ecx
  and  ecx,3
@small:
  rep  movsb
  //
  mov  [ebx].TStmIoArgs.Buffer,edi // inc(Buffer,CopySize)
  sub  [ebx].TStmIoArgs.Size,eax // dec(Size,CopySize)
  mov  ecx,[ebx].TStmIoArgs.pcbRead
  add  [ecx],eax // inc(pcbRead^,CopySize)
  //
  cmp  byte ptr [ebp-16],0 // bnRead?
  jz   @peek_skip
  //
  mov  ecx,[ebx].TStmIoArgs.Self
  sub  [ecx].TNetPipe.Size,eax // dec(Pipe.Size,CopySize)
  //
  movzx ecx,[edx].TNetPipeBufDesc.ReadOffset
  add  ecx,eax
  mov  [edx].TNetPipeBufDesc.ReadOffset,cx // inc(Buf.ReadOffset,CopySize)
  cmp  cx,[edx].TNetPipeBufDesc.WriteOffset // Buf.ReadOffset >= Buf.WriteOffset ?
  jae  @buf_done
  //
  cmp  [ebx].TStmIoArgs.Size,0
  jg   @more_bufs
  //
@ok:
  xor  eax,eax
  jmp  @done
  //
@buf_done: // edx=BufDesc finished reading...
  // if Peek, just skip it...
  cmp  byte ptr [ebp-16],0 // bnRead?
  jz   @peek_skip
  //
  // if it is last buffer, just reset it's ReadOffset & WriteOffset...
  mov  eax,[ebx].TStmIoArgs.Self
  cmp  edx,[eax].TNetPipe.Buffers.BLink
  je   @is_last_buffer
  // remove BufDesc from TNetPipe.Buffers.FLink and free:
  mov  ecx,[edx].TNetPipeBufDesc.Next
  mov  [eax].TNetPipe.Buffers.FLink,ecx
  and  [edx].TNetPipeBufDesc.Next,0
  // free buffer:
  mov  eax,edx
  call NetPipe_FreeBufDesc
  //
@more_bufs:
  nop
  jmp  @ReadFromLastBuffer
  //
@peek_skip:
  // go to next buffer, if any...
  mov  edx,[edx].TNetPipeBufDesc.Next
  test edx,edx
  jnz  @ReadFromThisBuf
  // peek at pipe end...
  jmp  @all_read
  //
@is_last_buffer:
  // ReadBuffer is current WriteBuffer, keep it...
  and  dword ptr [edx].TNetPipeBufDesc.WriteOffset,0 // reset both WriteOffset:=ReadOffset:=0;
@all_read:
  // if anything has been read so far, done...
  mov  eax,[ebx].TStmIoArgs.pcbRead
  cmp  dword ptr [eax],0
  jg   @ok
  // otherwise done, nothing to read...
@no_bufs:
  // if Pipe source has finished, signalize EOF, otherwise io-pending...
  mov  eax,[ebx].TStmIoArgs.Self
  cmp  [eax].TNetPipe.Capacity,0
  jz   @ok // source closed, all data read...
@pending:
  mov  eax,ERROR_IO_PENDING // = 997;   { dderror }
  //mov  eax,E_PENDING // = HRESULT($8000000A);
  //jmp  @done
  //
@done:
  pop  edx
  pop  edx
  pop  esi
  pop  edi
  pop  ebx
  //ret
end;

function NetPipe_Read(Pipe: PNetPipe; Buffer: Pointer; Size: Longint; pcbRead: PLongint): HResult; stdcall; //New191116
asm //               [ebp+8]
  // D5-auto: push ebp; mov ebp,esp
  lea  eax,&Pipe
  mov  dl,1
  call NetPipe_InternalRead
  // D5-auto: pop ebp; retn 16
end;

function NetPipe_Peek(Pipe: PNetPipe; Buffer: Pointer; Size: Longint; pcbRead: PLongint): HResult; stdcall; //New191116
asm //               [ebp+8]
  // D5-auto: push ebp; mov ebp,esp
  lea  eax,&Pipe
  mov  dl,0
  call NetPipe_InternalRead
  // D5-auto: pop ebp; retn 16
end;

//-----------------------------------------------------------------------------
// Thunking code for dynamic binding...
// - each function is retrieved only once...
// - functions must be "stdcall"
// - functions must look like this:
{
function xxx(params: types): Boolean; stdcall;
begin   // push ebp ; mov ebp,esp
  Result:=AdvApiCall(_xxx,'xxx');  // mov edx,'xxx'; mov eax,_xxx; call AdvApiCall
  // unimplemented:
  Result:=False;
end;

// The stub function
// - must NOT use try-frame
// - must NOT use finalizable variables (strings...)
// - should not use any variables

// Thunking code by Semi...
{}

var
  hIpHlpApi: THandle;

function IpHlpApiProc(var Proc; ProcName: PChar): Cardinal; register;
asm //                  [EAX] EDX
  // [EBP]=SaveEbp, [EBP+4]=Caller, [EBP+8]=params...
  push eax
  cmp  dword ptr [eax],0
  jnz  @have_func
  push edx // push ProcName for GetProcAddress later...
  //
  cmp  hIpHlpApi,0
  jnz  @have_ntdll
  mov  eax,offset @szDllName
  //call GetModuleHandle
  call SafeLoadLibrary
  mov  hIpHlpApi,eax
  test eax,eax
  jz   @bail_out1
@have_ntdll:
  push hIpHlpApi
  call GetProcAddress
  mov  edx,[esp] // ^Proc
  mov  [edx],eax // store Proc...
  test eax,eax
  jz   @bail_out0
  //
@have_func:
  pop  eax
  mov  eax,[eax]
  // undo caller stack-frame, skip returning into the stub function:
  mov  esp,ebp
  pop  ebp
  jmp  eax
  //
@bail_out1:
  pop  edx
@bail_out0:
  pop  eax
  //
  push ERROR_CALL_NOT_IMPLEMENTED
  call SetLastError
  // return -1 if call not implemented...
  or   eax,-1
  ret
  //
  dd   -1,12
@szDllName:
  db   'iphlpapi.dll',0
end;

{ NetInterfaceTable }

const
  MAX_INTERFACE_NAME_LEN = 256; // MPRAPI.H
  MAXLEN_IFDESCR  = 256;
  MAXLEN_PHYSADDR = 8;

type
  PMIB_IFROW = ^TMIB_IFROW; //New191102 from JwaIpRtrMib.pas
  TMIB_IFROW = record
    wszName: array [0..MAX_INTERFACE_NAME_LEN - 1] of WCHAR;
    dwIndex: DWORD;
    dwType: DWORD;
    dwMtu: DWORD;
    dwSpeed: DWORD;
    dwPhysAddrLen: DWORD;
    bPhysAddr: array [0..MAXLEN_PHYSADDR - 1] of BYTE;
    dwAdminStatus: DWORD;
    dwOperStatus: DWORD;
    dwLastChange: DWORD;
    dwInOctets: DWORD;
    dwInUcastPkts: DWORD;
    dwInNUcastPkts: DWORD;
    dwInDiscards: DWORD;
    dwInErrors: DWORD;
    dwInUnknownProtos: DWORD;
    dwOutOctets: DWORD;
    dwOutUcastPkts: DWORD;
    dwOutNUcastPkts: DWORD;
    dwOutDiscards: DWORD;
    dwOutErrors: DWORD;
    dwOutQLen: DWORD;
    dwDescrLen: DWORD;
    bDescr: array[0..MAXLEN_IFDESCR - 1] of BYTE;
  end;
  MIB_IFROW = TMIB_IFROW;
  
  PMIB_IFTABLE = ^TMIB_IFTABLE; //New191102
  TMIB_IFTABLE = record
    dwNumEntries: DWORD;
    table: array [0..0] of MIB_IFROW;
  end;
  MIB_IFTABLE = TMIB_IFTABLE;

type
  PMIB_IPADDRROW = ^MIB_IPADDRROW; //New191102 from JwaIpRtrMib.pas
  TMIB_IPADDRROW = record
    dwAddr: DWORD; // IP
    dwIndex: DWORD; // = MIB_IFROW.dwIndex
    dwMask: DWORD;
    dwBCastAddr: DWORD;
    dwReasmSize: DWORD;
    unused1: Word;
    wType: Word;
  end;
  MIB_IPADDRROW = TMIB_IPADDRROW;
  TMibIpAddrRow = MIB_IPADDRROW;
  PMibIpAddrRow = PMIB_IPADDRROW;

  PMIB_IPADDRTABLE = ^TMIB_IPADDRTABLE; //New191102
  TMIB_IPADDRTABLE = record
    dwNumEntries: DWORD;
    table: array [0..0] of MIB_IPADDRROW;
  end;
  MIB_IPADDRTABLE = TMIB_IPADDRTABLE;
  TMibIpAddrTable = TMIB_IPADDRTABLE;
  PMibIpAddrTable = PMIB_IPADDRTABLE;

var
  _GetIfTable: Pointer; //New191102
  _GetIpAddrTable: Pointer; //New191102

function GetIfTable(pIfTable: PMIB_IFTABLE; pdwSize: PDWORD; bOrder: BOOL): DWORD; stdcall; //New191102
begin
  Result:=IpHlpApiProc(_GetIfTable,'GetIfTable');
end;

function GetIpAddrTable(pIpAddrTable: PMIB_IPADDRTABLE; pdwSize: PDWORD; bOrder: BOOL): DWORD; stdcall; //New191102
begin
  Result:=IpHlpApiProc(_GetIpAddrTable,'GetIpAddrTable');
end;

procedure MibIfTableToObj(Row: PMIB_IFROW; var Obj: IEvalObj); //New191102
var Len: integer;
    Prop: TVarData;
    pc: PAnsiChar;
    pwc: PWideChar;
    pb: PByte;
    StItem,Sub: Pointer;
    Buffer: array[0..MAXLEN_PHYSADDR*2+1] of Char8;
  procedure P(const Name: String8);
  begin
    Obj.SetProp(Name,Variant(Prop),nil);
  end;
  procedure Stat(const Name: String8; pdw: PDWORD; bnIn: Boolean);
  var lpObj: PIEvalObj;
      pv: PVariant;
      qw: LARGE_INTEGER;
  begin
    lpObj:=Pointer(@StItem);
    pv:=Pointer(@Prop);
    EvalCreateObject(lpObj^);
    //
    qw.HighPart:=0;
    qw.LowPart:=pdw^;
    inc(pdw);
    SetVarInt64(pv^,qw.QuadPart);
    lpObj^.SetProp('Octets',pv^,nil); // dwInOctets,dwOutOctets
    //
    qw.LowPart:=pdw^;
    inc(pdw);
    SetVarInt64(pv^,qw.QuadPart);
    lpObj^.SetProp('Packets',pv^,nil); // dwInUcastPkts, dwOutUcastPkts
    //
    qw.LowPart:=pdw^;
    inc(pdw);
    SetVarInt64(pv^,qw.QuadPart);
    lpObj^.SetProp('Multicasts',pv^,nil); // dwInNUcastPkts, dwOutNUcastPkts
    //
    qw.LowPart:=pdw^;
    inc(pdw);
    SetVarInt64(pv^,qw.QuadPart);
    lpObj^.SetProp('Discards',pv^,nil); // dwInDiscards, dwOutDiscards
    //
    qw.LowPart:=pdw^;
    inc(pdw);
    SetVarInt64(pv^,qw.QuadPart);
    lpObj^.SetProp('Errors',pv^,nil); // dwInErrors, dwOutErrors
    //
    qw.LowPart:=pdw^;
    //inc(pdw);
    SetVarInt64(pv^,qw.QuadPart);
    if bnIn then
      lpObj^.SetProp('UnknownProtos',pv^,nil) // dwInUnknownProtos
    else
      lpObj^.SetProp('QLen',pv^,nil); // dwOutQLen
    //
    EvalIntfToVar(lpObj^,pv^);
    Obj.SetProp(Name,pv^,nil);
    SetVarNull(pv^);
    FinitIntf(lpObj^);
    //
  end;
begin
  ZeroMem16(@Prop);
  EvalCreateObject(Obj);
  StItem:=nil;
  //
  Len:=Row.dwDescrLen;
  // r-trim (dwDescrLen includes #0...)
  pc:=Pointer(@Row.bDescr);
  dec(Len);
  while (Len>=0) and (pc[Len]<=' ') do
    dec(Len);
  inc(Len);
  //
  EvalPAnsiToVar(Variant(Prop),pc,Len);
  P('Description');
  //
  pwc:=@Row.wszName;
  Len:=WStrLen(pwc);
  if (Len>0) then
    EvalPWideToVar(Variant(Prop),pwc,Len)
  else
    SetVarNull(Variant(Prop));
  P('Name');
  //
  Len:=Row.dwPhysAddrLen;
  if (Len>0) then begin
    if (Len>MAXLEN_PHYSADDR) then
      Len:=MAXLEN_PHYSADDR;
    pb:=Pointer(@Row.bPhysAddr);
    pc:=Buffer;
    while (Len>0) do begin
      dec(Len);
      StrLFmt(pc,3,'%.2x',[pb^]);
      inc(pc,2);
      inc(pb);
    end;
    pc^:=#0;
    pc:=Buffer;
    EvalPAnsiToVar(Variant(Prop),pc,StrLen(pc));
  end else
    SetVarNull(Variant(Prop));
  P('PhysAddr');
  //
  //New191124 - move to sub-object to wrap line...
  Sub:=nil;
  EvalCreateObject(IEvalObj(Sub));
  //
  SetVarInt(Variant(Prop),Row.dwAdminStatus);
  P('.AdminStatus'); //x191124: P('AdminStatus');
  SetObjProp0(IEvalObj(Sub),'AdminStatus',Variant(Prop)); //New191124
  //
  SetVarInt(Variant(Prop),Row.dwOperStatus);
  P('.OperStatus'); //x191124: P('OperStatus');
  SetObjProp0(IEvalObj(Sub),'OperStatus',Variant(Prop)); //New191124
  //
  //New191124
  EvalIntfToVar(IEvalObj(Sub),Variant(Prop));
  FinitIntf(Sub);
  P('Status');
  //
  SetVarInt(Variant(Prop),Row.dwIndex);
  P('Index');
  //
  SetVarInt(Variant(Prop),Row.dwType);
  P('Type');
  //
  SetVarInt(Variant(Prop),Row.dwMtu);
  P('MTU');
  //
  SetVarInt(Variant(Prop),Row.dwSpeed);
  P('Speed');
  //
  SetVarInt(Variant(Prop),Row.dwLastChange);
  P('LastChange');
  //
  Stat('In',@Row.dwInOctets,True);
  Stat('Out',@Row.dwOutOctets,False);
  //
  SetVarNull(Variant(Prop));
end;

procedure MibIpAddrTableToObj(Row: PMIB_IPADDRROW; var Obj: IEvalObj); //New191102
var Prop: TVarData;
begin
  ZeroMem16(@Prop);
  EvalCreateObject(Obj);
  //
  if EvalIpToVar(AF_INET,@Row.dwAddr,Variant(Prop)) then
    Obj.SetProp('IP',Variant(Prop),nil);
  // dwIndex is surplus, is in parent object...
  //
  if EvalIpToVar(AF_INET,@Row.dwMask,Variant(Prop)) then
    Obj.SetProp('Mask',Variant(Prop),nil);
  //
  SetVarInt(Variant(Prop),Row.dwBCastAddr); // = 1 ...
  Obj.SetProp('Broadcast',Variant(Prop),nil);
  //
  SetVarInt(Variant(Prop),Row.dwReasmSize); // = 65535
  Obj.SetProp('ReasmSize',Variant(Prop),nil);
  //
  SetVarInt(Variant(Prop),Row.wType); // = 65535
  Obj.SetProp('Type',Variant(Prop),nil);
  //
  SetVarNull(Variant(Prop));
end;

function Eval_GetNetInterfaceTable(var ResVar: Variant; Arg: Pointer): Boolean; //New191102
var IfTable: PMIB_IFTABLE;
    IpAddrTable: PMIB_IPADDRTABLE;
    dwSize: DWORD;
    ECode: HResult;
    Arr,Item,IpArr,IpItem: IEvalObj;
    i,j: integer;
    Row: PMIB_IFROW;
    Row2: PMIB_IPADDRROW;
    Node: TEvalNode;
Label _Fail;
begin
  //* NetInterfaceTable -- returns new array...
  //* -- for other version, see EvalNtAcl.dll EnumIfTable()
  Result:=True;
  ZeroMemNode(Node);
  IfTable:=nil;
  IpAddrTable:=nil;
  try
    dwSize:=0;
    ECode:=GetIfTable(nil,@dwSize,True);
    if (dwSize>0) then begin
      IfTable:=AllocMem(dwSize+16);
      IfTable.dwNumEntries:=IfTable.dwNumEntries and 0;
      ECode:=GetIfTable(IfTable,@dwSize,True);
      if (ECode<>0) or (IfTable.dwNumEntries=0) then
        goto _Fail;
      //
      dwSize:=0;
      ECode:=GetIpAddrTable(nil,@dwSize,True);
      if (dwSize=0) then
        goto _Fail;
      //
      IpAddrTable:=AllocMem(dwSize+16);
      ECode:=GetIpAddrTable(IpAddrTable,@dwSize,True);
      if (ECode<>0) or (IpAddrTable.dwNumEntries=0) then
        goto _Fail;
      //
      EvalCreateArray(Arr);
      //
      for i:=0 to IfTable.dwNumEntries-1 do begin
        Row:=@IfTable.table[i];
        //
        MibIfTableToObj(Row,Item);
        //
        Node.Kind:=enkValue;
        EvalIntfToVar(Item,Variant(Node.VarData));
        Arr.CallFunc('Add',ResVar,@Node);
        //
        IpArr:=nil;
        //
        for j:=0 to IpAddrTable.dwNumEntries-1 do begin
          Row2:=@IpAddrTable.table[j];
          if (Row2.dwIndex=Row.dwIndex) then begin
            MibIpAddrTableToObj(Row2,IpItem);
            if (IpArr=nil) then begin
              EvalCreateArray(IpArr);
              EvalIntfToVar(IpArr,ResVar);
              Item.SetProp('IpAddress',ResVar,nil);
            end;
            EvalIntfToVar(IpItem,Variant(Node.VarData));
            IpArr.CallFunc('Add',ResVar,@Node);
          end;
        end;
      end;
      //
      EvalIntfToVar(Arr,ResVar);
      //
    end else begin
    _Fail:
      if (ECode=0) then
        ECode:=STG_E_ABNORMALAPIEXIT; // 800300FA
      EvalHResultToVar(ResVar,ECode);
      TVarData(ResVar).VType:=varNull;
    end;
  finally
    if (IfTable<>nil) then
      FreeMem(IfTable);
    if (IpAddrTable<>nil) then
      FreeMem(IpAddrTable);
  end;
end;

{ NetNotify }

var
  _NotifyAddrChange: Pointer;
  _CancelIPChangeNotify: Pointer;

function NotifyAddrChange(lpHandle: PHandle; overlapped: POVERLAPPED): DWORD; stdcall; //New191103
begin
  Result:=IpHlpApiProc(_NotifyAddrChange,'NotifyAddrChange');
end;

function CancelIPChangeNotify(notifyOverlapped: POVERLAPPED): BOOL; stdcall; //New191103
begin
  Result:=BOOL(IpHlpApiProc(_CancelIPChangeNotify,'CancelIPChangeNotify'));
end;

function NetNotify_InternalClose(Notify: PEvalNetNotify): Boolean; //New191103
var H: THandle;
begin
  H:=Notify.Handle;
  Notify.Handle:=0;
  if (H<>0) then begin
    Result:=CancelIPChangeNotify(@Notify.Overlapped);
    // we should not close that handle...
    // But we shall close the event handle:
    H:=Notify.Overlapped.hEvent;
    Notify.Overlapped.hEvent:=0;
    if (H<>0) then
      CloseHandle(H);
  end else
    Result:=False;
end;

function NetNotify_Released(Notify: PEvalNetNotify): Longint; stdcall; //New191103
begin
  if (Notify.RefCount=0) then begin
    //
    NetNotify_InternalClose(Notify);
    //
    Result:=GenObj_Released(Notify);
    //
  end else
    Result:=Notify.RefCount;
end;

function NetNotify_Close(Params: PObjCallParams): Boolean; //New191103
begin
  //* Notify.Close() -- cancel notify now, do not wait to release the object...
  //* Notify.Close
  SetVarBool(Params.lpResVar^,NetNotify_InternalClose(Params.Self));
  Result:=True;
end;

function NetNotify_Open(Params: PObjCallParams): Boolean; //New191103
var Notify: PEvalNetNotify;
    ECode: HResult;
    H: THandle;
begin
  //* Notify.Open() -- used internally in constructor... or can re-open when previously closed...
  //* Notify.Open
  Notify:=Params.Self;
  //
  //? if (Notify.Handle<>0) then NetNotify_InternalClose(Notify);
  if (Notify.Overlapped.hEvent=0) then
    Notify.Overlapped.hEvent:=CreateEvent(nil,True,False,nil);
  //
  ECode:=NotifyAddrChange(@Notify.Handle,@Notify.Overlapped);
  if (ECode<>0) then begin
    ECode:=GetLastError();
    if (ECode<>WSA_IO_PENDING) then begin
      //
      H:=Notify.Overlapped.hEvent;
      Notify.Overlapped.hEvent:=0;
      if (H<>0) then
        CloseHandle(H);
      //
      EvalHResultToVar(Params.lpResVar^,ECode);
      Result:=True;
      exit;
    end;
  end;
  //
  Result:=Ocp_RetBool(Params,True);
end;

function NetNotify_WaitFor(Params: PObjCallParams): Boolean; //New191103
var Timeout: Longint;
    Code: Cardinal;
    Notify: PEvalNetNotify;
begin
  //* Notify.WaitFor(?Timeout) -- wait for IP address change notify or ask it without waiting with Timeout=0
  //* Notify.WaitFor -- wait infinitely...
  //* -- it restarts the notify...
  Result:=False;
  Timeout:=-1;
  if EvalNodeInt_Optional(Params.Args,Timeout) then begin
    Result:=True;
    Notify:=Params.Self;
    if (Notify.Overlapped.hEvent=0) then begin
      NetNotify_Open(Params);
      if (Notify.Overlapped.hEvent=0) then
        exit;
    end;
    //
    Code:=WaitForSingleObject(Notify.Overlapped.hEvent,Cardinal(Timeout));
    SetVarBool(Params.lpResVar^,(Code=WAIT_OBJECT_0));
    //
    // prepare for next notify:
    NotifyAddrChange(@Notify.Handle,@Notify.Overlapped);
  end;
end;

function NetNotify_GetHandle(Params: PObjCallParams): Boolean; //New191103
var qw: LARGE_INTEGER;
begin
  //* Notify.Handle - returns integer
  if (PEvalNetNotify(Params.Self).Handle<>0) then begin
    // return unsigned...
    qw.HighPart:=qw.HighPart and 0;
    qw.LowPart:=PEvalNetNotify(Params.Self).Handle;
    SetVarInt64(Params.lpResVar^,qw.QuadPart);
  end else
    Params.bnNullRes:=True;
  Result:=True;
end;

function Vmt_NetNotify(): Pointer; //New191103
asm
  mov eax,offset @Vmt
  ret
  nop
  nop
  dd 0
@Vmt:
  // IUnknown
  dd GenObj_QueryInterface
  dd GenObj_AddRef
  dd @Release
  // IEvalObj
  dd @CallFunc
  dd @GetProp
  dd @SetProp
  dd GenObj_Control
  dd 0
  db 'NetNotify',0,0,0
  //
@CallDesc:
  // short format:
  dd -1,0,GenObj_CallDesc
  dd @WaitFor          +1
  dd NetNotify_WaitFor
  dd @Close            +1
  dd NetNotify_Close
  dd @Open             +1
  dd NetNotify_Open
  dd 0
@GetPropDesc:
  // short format:
  dd -1,0,GenObj_GetPropDesc
  dd @Handle           +1
  dd NetNotify_GetHandle
  dd @WaitFor          +1
  dd NetNotify_WaitFor
  dd @Close            +1
  dd NetNotify_Close
  dd @Open             +1
  dd NetNotify_Open
  dd 0
@SetPropDesc:
  // short format:
  dd -1,0,GenObj_SetPropDesc
  dd 0
  //
@Open: db 4,'Open',0
@Close: db 5,'Close',0
@Handle: db 6,'Handle',0
@WaitFor: db 7,'WaitFor',0
  //
  dd -1,6
@szHandle: db 'Handle',0
  //
@Release: // [esp+4]=Self
  mov  eax,[esp+4]
  or   edx,-1
  lock xadd [eax].TEvalGenObj.RefCount,edx
  dec  edx
  jz   NetNotify_Released // is stdcall...
  mov  eax,edx
  retn 4
  //
@CallFunc: // eax=Self, edx=FuncName, ecx=ResVar, [esp+4]=Args
  call GenObj_CallFunc_Prefix // FuncNode from this.Props ?
  push offset @CallDesc
  jmp  ObjMethodCall
  //
@GetProp: // eax=Self, edx=PropName, ecx=ResVar, [esp+4]=IndexArg
  test edx,edx
  jz   @gp0
  call GenObj_GetProp_Prefix // from this.Props takes precedence...
  push offset @GetPropDesc
  jmp  ObjMethodCall
@gp0:
  // (PropName='')
  cmp  dword ptr [esp+4],0 // IndexArg?
  jnz  @gp0_index
  mov  edx,offset @szHandle
  jmp  @GetProp
  //
@gp0_index:
  // (PropName=''), (IndexArg<>nil)
  mov  edx,[esp+4]
  call GenObj_Get0Prop_Index
  retn 4
  //
@SetProp: // eax=Self, edx=PropName, ecx=Value, [esp+4]=IndexArg
  test edx,edx
  jz   @sp0
  push offset @SetPropDesc
  jmp  ObjMetSetProp
@sp0:
  // (PropName='')
  cmp  dword ptr [esp+4],0 // IndexArg?
  jnz  @sp0_index //! ByteArray_Set0Prop_Index //GenObj_SetProp_Fallback2
  // (PropName=''), (IndexArg=nil) -- SetProp('Value',Value,nil)
  //mov  edx,offset @szValue
  //jmp  @SetProp
  xor  eax,eax
  retn 4
@sp0_index:
  mov  edx,[esp+4]
  call GenObj_Set0Prop_Index
  retn 4
  //
end;

function Eval_NotifyAddrChange(var ResVar: Variant; Args: PEvalNode): Boolean; //New191103
var Notify: PEvalNetNotify;
    tv: TVarData;
    bn: Boolean;
begin
  //* var H:=NotifyAddrChange(); -- returns object/handle, that can be used in wait functions
  //* if (!H) ECode:=HResult(H);
  //* if (H && H.WaitFor(0)) ... //some adapter ip address changed since Notify created...
  //* -- WaitFor restarts notify...
  SetVarNull(ResVar);
  //
  Notify:=AllocMem(SizeOf(TEvalNetNotify));
  Notify.Vmt:=Vmt_NetNotify();
  EvalIntfToVar(IEvalObj(Notify),ResVar);
  //
  GenObj_InitProto(Notify);
  //
  TdwVarData(tv).dwType:=TdwVarData(tv).dwType and 0;
  if not IEvalObj(Notify).CallFunc('Open',Variant(tv),nil)
  or not EvalVarToBool(Variant(tv),bn)
  or not bn
  then begin
    EvalHResultToVar(ResVar,GetLastError());
    TVarData(ResVar).VType:=varNull;
  end;
  //
  Result:=True;
end;

function Eval_IpToInt2(Params: PObjCallParams): Boolean; //New191102
var Addr: TSockAddrIn;
    qw: LARGE_INTEGER;
begin
  //* IpToInt('1.2.3.4') - returns binary ip uint32...
  Result:=False;
  ZeroMem(@Addr,SizeOf(Addr));
  Addr.sin_family:=AF_INET; // only ipv4...
  //
  if Eval_IpAddress(Params,@Addr,False) then begin
    qw.HighPart:=0; // return unsigned 32-bit...
    qw.LowPart:=dwSwap(Addr.sin_addr.S_addr);
    SetVarInt64(Params.lpResVar^,qw.QuadPart);
    Result:=True;
  end;
end;

function Eval_IpToInt(var ResVar: Variant; Args: PEvalNode): Boolean; //New191102
begin
  //* IpToInt('1.2.3.4') - returns binary ip...
  Result:=OcpExtCall(ResVar,Args,TObjCallProc(@Eval_IpToInt2));
end;

function Eval_IntToIp(var ResVar: Variant; Args: PEvalNode): Boolean; //New191102
var qw: LARGE_INTEGER;
begin
  //* IpToInt(0x01020304) - returns string ip...
  Result:=False;
  if EvalNodeInt64(Args,qw.QuadPart) then begin
    qw.LowPart:=dwSwap(qw.LowPart);
    EvalIpToVar(AF_INET,@qw.LowPart,ResVar);
    Result:=True;
  end;
end;

function Eval_DwSwap(var ResVar: Variant; Args: PEvalNode): Boolean; //New191102
var qw: LARGE_INTEGER;
begin
  //* DwSwap(Int) -- return byte-swapped unsigned 32-bit integer...
  Result:=False;
  if EvalNodeInt64(Args,qw.QuadPart) then begin
    qw.LowPart:=dwSwap(qw.LowPart);
    qw.HighPart:=0;
    SetVarInt64(ResVar,qw.QuadPart);
    Result:=True;
  end;
end;

function Eval_WSwap(var ResVar: Variant; Args: PEvalNode): Boolean; //New191102
var Int: Longint;
begin
  //* WSwap(Int) -- return byte-swapped unsigned 16-bit integer...
  Result:=False;
  if EvalNodeInt(Args,Int) then begin
    Int:=WSwap(Int);
    SetVarInt(ResVar,Int);
    Result:=True;
  end;
end;

procedure EvalRegister();
begin
  if not bnEvalAvailable then begin
    EvalAddInitProc(EvalRegister);
    exit;
  end;
  //
  RegisterEvalObjClass('Socket',Eval_CreateSocket,nil);
  RegisterExternalFunc('Socket',Eval_SocketFunc);
  RegisterExternalFunc('DnsLookup',Eval_DnsLookup);
  RegisterExternalFunc('TcpConnect',Eval_TcpConnect);
  RegisterExternalFunc('SockSelect',Eval_SockSelect);
  RegisterEvalObjClass('SockForward',Eval_CreateForward,nil);
  RegisterDynConst('NetInterfaceTable',Eval_GetNetInterfaceTable,nil); //New191102
  RegisterExternalFunc('NotifyAddrChange',Eval_NotifyAddrChange); //New191103
  RegisterExternalFunc('IpToInt',Eval_IpToInt); //New191102
  RegisterExternalFunc('IntToIp',Eval_IntToIp); //New191102
  RegisterExternalFunc('dwSwap',Eval_DwSwap); //New191102
  RegisterExternalFunc('WSwap',Eval_WSwap); //New191102
end;

initialization
  EvalRegister();
end.
